unit FrmMain;

{

   COPYRIGHT 1999 .. 2014 Blue Hell / Jan Punter

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License version 2 as
  published by the Free Software Foundation;

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

  For all listed email addresses :

    _dot. to be substituted by a dot      '.'
    2@t2  to be substituted by an at sign '@'


  Blue Hell is a trade mark owned by

    Jan Punter
    Oogstplein 6
    7545 HP Enschede
    the Netherlands
    http://www.iaf.nl/Users/BlueHell/
    http://bluehell.electro-music.com/
    j_dot.punter2@t2iaf_dot.nl

  All rights attributed to Blue Hell are owned by Jan Punter.

  +-----------------------------------------------------------------+
  + RhastUnit courtesy HrastProgrammer, please note the distinctive +
  + copyright notice in that file.                                  +
  +-----------------------------------------------------------------+

}

interface

uses

  WinApi.Windows, WinApi.Messages, Winapi.CommCtrl, System.SysUtils, System.UITypes, System.TypInfo, System.Classes,
  Vcl.Graphics, Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls, Vcl.Buttons, Vcl.ExtCtrls, Vcl.ComCtrls,
  VCLTee.Chart, VCLTee.Series, System.IniFiles, WinApi.MMSystem, System.Math, Vcl.Menus, Vcl.Samples.Spin,
  WinApi.ShellApi, Vcl.Imaging.jpeg, VclTee.TeeGDIPlus, VCLTee.TeeProcs, VCLTee.TeEngine, System.Win.Registry,
  Vcl.Imaging.pngimage, OverbyteIcsWndControl, OverbyteIcsWSocket, Vcl.Mask,

  KnobsConversions, KnobsUtils, Globals, FrmStore, wave_dlg, KnobParser, AudioIO, CpuUsage, module_defs,
  module_implementations, knobs2013, Rationals, WaveStorage, WaveUtils, wave_tools,

  ctypes, portaudio,

  HrastUnit;

type

  // Some stuff to fix the border width for TPageControls

  TPageControl = class( Vcl.ComCtrls.TPageControl)
  private
    procedure   TCMAdjustRect(var Msg: TMessage); message TCM_ADJUSTRECT;
  end;

  TMidiRxState = (
    mrxNormal,
    mrxRunningStatus
  );

  EWren               = class( Exception);
  EWrenExecutionError = class( Ewren);

  TFormModules = class(TForm)
    PanelControl: TPanel;
    Label1: TLabel;
    Label2: TLabel;
    TimerStatsUpdate: TTimer;
    PanelMain: TPanel;
    PageControlMain: TPageControl;
    TabSheetDebug: TTabSheet;
    PanelDebug: TPanel;
    LabelIOBalance: TLabel;
    BitBtnClear: TBitBtn;
    BitBtnDump: TBitBtn;
    SaveDialogPatch: TSaveDialog;
    BitBtnDocument: TBitBtn;
    TabSheetEditor: TTabSheet;
    OpenDialogPatch: TOpenDialog;
    MainMenu1: TMainMenu;
    MenuFile: TMenuItem;
    MenuFileLoad: TMenuItem;
    MenuFileSave: TMenuItem;
    MenuEdit: TMenuItem;
    N1: TMenuItem;
    MenuFileExit: TMenuItem;
    MenuEditDelete: TMenuItem;
    MenuEditCut: TMenuItem;
    MenuEditCopy: TMenuItem;
    MenuEditPaste: TMenuItem;
    N2: TMenuItem;
    MenuEditSelectAll: TMenuItem;
    MenuEditInvertSelection: TMenuItem;
    N3: TMenuItem;
    MenuEditUndo: TMenuItem;
    MenuEditRedo: TMenuItem;
    MenuFileSaveAs: TMenuItem;
    N4: TMenuItem;
    MenuEditWiggleWires: TMenuItem;
    MenuSetup: TMenuItem;
    MenuSetupDevices: TMenuItem;
    MenuFileNew: TMenuItem;
    BitBtnShowDesigner: TBitBtn;
    BitBtnDebugStep: TBitBtn;
    BitBtnDebugRun: TBitBtn;
    BitBtnDebugReset: TBitBtn;
    MenuHelp: TMenuItem;
    MenuHelpHelp: TMenuItem;
    N5: TMenuItem;
    MenuSetupSettings: TMenuItem;
    BitBtnAudioRunning: TBitBtn;
    PageControlDGSA: TPageControl;
    TabSheetText: TTabSheet;
    TabSheetGraph: TTabSheet;
    MemoDebug: TMemo;
    ChartDebug: TChart;
    BitBtnClearGraph: TBitBtn;
    CheckBoxUseGraph: TCheckBox;
    CheckBoxGraphStairs: TCheckBox;
    TabSheetSettings: TTabSheet;
    PanelSettings: TPanel;
    MenuView: TMenuItem;
    MenuViewEditor: TMenuItem;
    MenuViewDebugger: TMenuItem;
    MenuViewGraphs: TMenuItem;
    MenuViewSettings: TMenuItem;
    BitBtnCloseDubugger: TBitBtn;
    LabelOverflows: TLabel;
    LabelUnderflows: TLabel;
    TabSheetAbout: TTabSheet;
    MenuViewAbout: TMenuItem;
    MenuHelpAbout: TMenuItem;
    Panelabout: TPanel;
    PanelAboutRight: TPanel;
    MemoAbout: TMemo;
    PanelAboutLeft: TPanel;
    Label7: TLabel;
    PanelWren: TPanel;
    ImageWren: TImage;
    Label8: TLabel;
    Label9: TLabel;
    LabelProgramVersion: TLabel;
    LabelPatchVersion: TLabel;
    N7: TMenuItem;
    N8: TMenuItem;
    MenuFileReopen: TMenuItem;
    knob_outputlevel1: TKnobsKnob;
    knob_inputlevel1: TKnobsKnob;
    IndicatorBarVolumeInLeft1: TKnobsIndicatorBar;
    IndicatorBarVolumeInRight1: TKnobsIndicatorBar;
    IndicatorBarVolumeOutLeft1: TKnobsIndicatorBar;
    IndicatorBarVolumeOutRight1: TKnobsIndicatorBar;
    GroupBoxEditorSettings: TGroupBox;
    Label12: TLabel;
    KnobsDisplayOffsetLeft: TKnobsDisplay;
    KnobsDisplayOffsetTop: TKnobsDisplay;
    Label13: TLabel;
    KnobsSmallKnob_LeftOffset: TKnobsNoKnob;
    KnobsSmallKnob_TopOffset: TKnobsNoKnob;
    LabeldBIn1: TLabel;
    LabeldbOut1: TLabel;
    MenuAction: TMenuItem;
    MenuActionRunStop: TMenuItem;
    OpenDialogWave: TOpenDialog;
    PanelEditorTop: TPanel;
    SelectNone1: TMenuItem;
    Bevel4: TBevel;
    Bevel5: TBevel;
    Bevel6: TBevel;
    Bevel7: TBevel;
    EditorPatch: TKnobsWirePanel;
    Label14: TLabel;
    WSocketNetMidi: TWSocket;
    RadioGroupControlMode: TRadioGroup;
    CheckBoxCurvedLines: TCheckBox;
    Label15: TLabel;
    GroupBoxNetMidi: TGroupBox;
    Label16: TLabel;
    Label17: TLabel;
    EditNetMidiServer: TEdit;
    EditNetMidiPort: TEdit;
    BitBtnApplyNetMidi: TBitBtn;
    BitBtnCancelNetMidi: TBitBtn;
    BitBtnNetMidiConnect: TBitBtn;
    CheckBoxNetMidiAutoConnect: TCheckBox;
    TimerNetMidiConnect: TTimer;
    LedNetMidiConnect2: TKnobsLed;
    LedNetMidiTx2: TKnobsLed;
    LedNetMidiRx2: TKnobsLed;
    Label23: TLabel;
    Label22: TLabel;
    Label21: TLabel;
    LedNetMidiConnect1: TKnobsLed;
    LedNetMidiTx1: TKnobsLed;
    LedNetMidiRx1: TKnobsLed;
    Label20: TLabel;
    Label19: TLabel;
    Label18: TLabel;
    Label6: TLabel;
    CheckBoxReloadLastPatch: TCheckBox;
    CheckBoxAutoRun: TCheckBox;
    Panel3: TPanel;
    ModuleSelector: TKnobsModuleSelector;
    EditPatchName: TEdit;
    LabelRunTime: TLabel;
    SpinButtonWureThickness: TSpinButton;
    LabelCpuUsage: TLabel;
    Label3: TLabel;
    EditSearch: TEdit;
    Help1: TMenuItem;
    Profile1: TMenuItem;
    BitBtnProfile: TBitBtn;
    N6: TMenuItem;
    Find1: TMenuItem;
    Label10: TLabel;
    Label24: TLabel;
    CheckBoxLogMidi: TCheckBox;
    CheckBoxLogMidiMsgs: TCheckBox;
    CheckBoxCompilerDebug: TCheckBox;
    BitBtnTest: TBitBtn;
    GroupBoxTuning: TGroupBox;
    Label4: TLabel;
    Label5: TLabel;
    Label11: TLabel;
    Label25: TLabel;
    EditReferenceA: TEdit;
    EditNotesPerOctave: TEdit;
    EditMiddleNote: TEdit;
    RadioGroupPrioLevel: TRadioGroup;
    PopupMenuConnector: TPopupMenu;
    DeleteConnector: TMenuItem;
    BreakWire: TMenuItem;
    DisconnectConnector: TMenuItem;
    CheckBoxWarnOnPatchChange: TCheckBox;
    BitBtnSynthReset: TBitBtn;
    PopupMenuModule: TPopupMenu;
    CopyModule: TMenuItem;
    CutModule: TMenuItem;
    DeleteModule: TMenuItem;
    PopupMenuKnob: TPopupMenu;
    SetKnobDefaultvalue: TMenuItem;
    LockKnob: TMenuItem;
    LabeldBInMax1: TLabel;
    LabeldBOutMax1: TLabel;
    TimerLightsUpdate: TTimer;
    GroupBoxAudioProperties: TGroupBox;
    RadioGroupSampleRate: TRadioGroup;
    LabelPleaseStopAudio1: TLabel;
    Label30: TLabel;
    KnobsSmallKnob_LightsRate: TKnobsSmallKnob;
    KnobsDisplayLightsRate: TKnobsDisplay;
    PopupMenuSelector: TPopupMenu;
    dynamics1: TMenuItem;
    SaveDialogWave: TSaveDialog;
    KnobsLedrendering: TKnobsLed;
    KnobsSelectorFileRender: TKnobsSelector;
    LabeldBInMin1: TLabel;
    LabeldBOutMin1: TLabel;
    Bevel2: TBevel;
    Bevel3: TBevel;
    Bevel8: TBevel;
    Bevel9: TBevel;
    Label31: TLabel;
    Label32: TLabel;
    IndicatorBarVolumeInLeft2: TKnobsIndicatorBar;
    IndicatorBarVolumeInRight2: TKnobsIndicatorBar;
    IndicatorBarVolumeOutLeft2: TKnobsIndicatorBar;
    IndicatorBarVolumeOutRight2: TKnobsIndicatorBar;
    LabeldBIn2: TLabel;
    LabeldbOut2: TLabel;
    LabeldBInMax2: TLabel;
    LabeldBOutMax2: TLabel;
    LabeldBInMin2: TLabel;
    LabeldBOutMin2: TLabel;
    knob_outputlevel2: TKnobsKnob;
    knob_inputlevel2: TKnobsKnob;
    Bevel10: TBevel;
    Bevel11: TBevel;
    Bevel12: TBevel;
    Bevel13: TBevel;
    Label39: TLabel;
    Label40: TLabel;
    IndicatorBarVolumeInLeft3: TKnobsIndicatorBar;
    IndicatorBarVolumeInRight3: TKnobsIndicatorBar;
    IndicatorBarVolumeOutLeft3: TKnobsIndicatorBar;
    IndicatorBarVolumeOutRight3: TKnobsIndicatorBar;
    LabeldBIn3: TLabel;
    LabeldbOut3: TLabel;
    LabeldBInMax3: TLabel;
    LabeldBOutMax3: TLabel;
    LabeldBInMin3: TLabel;
    LabeldBOutMin3: TLabel;
    knob_outputlevel3: TKnobsKnob;
    knob_inputlevel3: TKnobsKnob;
    Bevel14: TBevel;
    Bevel15: TBevel;
    Bevel16: TBevel;
    Bevel17: TBevel;
    Label47: TLabel;
    Label48: TLabel;
    IndicatorBarVolumeInLeft4: TKnobsIndicatorBar;
    IndicatorBarVolumeInRight4: TKnobsIndicatorBar;
    IndicatorBarVolumeOutLeft4: TKnobsIndicatorBar;
    IndicatorBarVolumeOutRight4: TKnobsIndicatorBar;
    LabeldBIn4: TLabel;
    LabeldbOut4: TLabel;
    LabeldBInMax4: TLabel;
    LabeldBOutMax4: TLabel;
    LabeldBInMin4: TLabel;
    LabeldBOutMin4: TLabel;
    knob_outputlevel4: TKnobsKnob;
    knob_inputlevel4: TKnobsKnob;
    SplitterMain: TSplitter;
    Label33: TLabel;
    Label34: TLabel;
    Label35: TLabel;
    Label36: TLabel;
    ColorDialogModule: TColorDialog;
    N9: TMenuItem;
    Color1: TMenuItem;
    KnobsLedModuleColor: TKnobsLed;
    BitBtnModuleColor: TBitBtn;
    CheckBoxResetOnRender: TCheckBox;
    CheckBoxUseWheelOnKnobs: TCheckBox;
    knob_WheelSensitivity: TKnobsSmallKnob;
    Label26: TLabel;
    KnobsDisplayWheelSensitivity: TKnobsDisplay;
    CheckBoxUseUnFocus: TCheckBox;
    CheckBoxUsePortAudio: TCheckBox;
    LabelPleaseStopAudio2: TLabel;
    BitBtnGhostCheck: TBitBtn;
    Findunconnectedmodules1: TMenuItem;
    KnobsSmallKnobModuleOpacity: TKnobsSmallKnob;
    KnobsDisplayModuleOpacity: TKnobsDisplay;
    Label27: TLabel;
    procedure BitBtnExItClick(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure BitBtnDebugStepClick(Sender: TObject);
    procedure BitBtnClearClick(Sender: TObject);
    procedure BitBtnClearGraphClick(Sender: TObject);
    procedure BitBtnDebugRunClick(Sender: TObject);
    procedure CheckBoxUseGraphClick(Sender: TObject);
    procedure BitBtnDebugResetClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure CheckBoxGraphStairsClick(Sender: TObject);
    procedure BitBtnDumpClick(Sender: TObject);
    procedure knob_outputlevel1ValueChanged(aSender: TObject; const aPath, aControlType: string; aValue: Double; IsFinal: Boolean);
    procedure knob_inputlevel1ValueChanged(aSender: TObject; const aPath, aControlType: string; aValue: Double; IsFinal: Boolean);
    procedure TimerStatsUpdateTimer(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure CheckBoxReloadLastPatchClick(Sender: TObject);
    procedure CheckBoxAutoRunClick(Sender: TObject);
    procedure BitBtnDocumentClick(Sender: TObject);
    procedure ModuleSelectorModuleButtonClick(aSender: TObject; aModuleclass: Integer);
    procedure MenuFileLoadClick(Sender: TObject);
    procedure MenuFileSaveClick(Sender: TObject);
    procedure MenuFileSaveAsClick(Sender: TObject);
    procedure MenuFileExitClick(Sender: TObject);
    procedure MenuEditDeleteClick(Sender: TObject);
    procedure MenuEditCutClick(Sender: TObject);
    procedure MenuEditCopyClick(Sender: TObject);
    procedure MenuEditPasteClick(Sender: TObject);
    procedure MenuEditSelectAllClick(Sender: TObject);
    procedure MenuEditInvertSelectionClick(Sender: TObject);
    procedure MenuEditUndoClick(Sender: TObject);
    procedure MenuEditRedoClick(Sender: TObject);
    procedure MenuEditWiggleWiresClick(Sender: TObject);
    procedure MenuSetupDevicesClick(Sender: TObject);
    procedure MenuFileNewClick(Sender: TObject);
    procedure SpinButtonWureThicknessUpClick(Sender: TObject);
    procedure SpinButtonWureThicknessDownClick(Sender: TObject);
    procedure CheckBoxCurvedLinesClick(Sender: TObject);
    procedure BitBtnShowDesignerClick(Sender: TObject);
    procedure MenuHelpHelpClick(Sender: TObject);
    procedure MenuSetupSettingsClick(Sender: TObject);
    function ModuleSelectorGetGlyph(aSender: TObject; const aName: string): TBitmap;
    procedure BitBtnAudioRunningClick(Sender: TObject);
    procedure RadioGroupPrioLevelClick(Sender: TObject);
    procedure BitBtnCloseDubuggerClick(Sender: TObject);
    procedure MenuViewEditorClick(Sender: TObject);
    procedure MenuViewDebuggerClick(Sender: TObject);
    procedure MenuViewGraphsClick(Sender: TObject);
    procedure MenuViewSettingsClick(Sender: TObject);
    procedure MenuViewAboutClick(Sender: TObject);
    procedure MenuHelpAboutClick(Sender: TObject);
    procedure EditPatchNameChange(Sender: TObject);
    procedure EditNotesPerOctaveChange(Sender: TObject);
    procedure EditReferenceAChange(Sender: TObject);
    procedure BitBtnProfileClick(Sender: TObject);
    procedure KnobsSmallKnob_LeftOffsetValueChanged(aSender: TObject; const aPath, aControlType: string; aValue: Double; IsFinal: Boolean);
    procedure KnobsSmallKnob_TopOffsetValueChanged(aSender: TObject; const aPath, aControlType: string; aValue: Double; IsFinal: Boolean);
    procedure MenuActionRunStopClick(Sender: TObject);
    procedure SelectNone1Click(Sender: TObject);
    procedure FormMouseWheel(Sender: TObject; Shift: TShiftState; WheelDelta: Integer; MousePos: TPoint;
      var Handled: Boolean);
    procedure RadioGroupControlModeClick(Sender: TObject);
    procedure BitBtnNetMidiConnectClick(Sender: TObject);
    procedure CheckBoxNetMidiAutoConnectClick(Sender: TObject);
    procedure BitBtnApplyNetMidiClick(Sender: TObject);
    procedure BitBtnCancelNetMidiClick(Sender: TObject);
    procedure EditNetMidiServerChange(Sender: TObject);
    procedure EditNetMidiPortChange(Sender: TObject);
    procedure TimerNetMidiConnectTimer(Sender: TObject);
    procedure WSocketNetMidiBgException(Sender: TObject; E: Exception; var CanClose: Boolean);
    procedure WSocketNetMidiChangeState(Sender: TObject; OldState, NewState: TSocketState);
    procedure WSocketNetMidiDataAvailable(Sender: TObject; ErrCode: Word);
    procedure WSocketNetMidiDataSent(Sender: TObject; ErrCode: Word);
    procedure WSocketNetMidiError(Sender: TObject);
    procedure WSocketNetMidiSessionClosed(Sender: TObject; ErrCode: Word);
    procedure WSocketNetMidiSessionConnected(Sender: TObject; ErrCode: Word);
    procedure CheckBoxLogMidiClick(Sender: TObject);
    procedure CheckBoxLogMidiMsgsClick(Sender: TObject);
    procedure EditSearchChange(Sender: TObject);
    procedure CheckBoxCompilerDebugClick(Sender: TObject);
    procedure Profile1Click(Sender: TObject);
    procedure Find1Click(Sender: TObject);
    procedure EditMiddleNoteChange(Sender: TObject);
    procedure BitBtnTestClick(Sender: TObject);
    procedure DeleteConnectorClick(Sender: TObject);
    procedure BreakConnectorClick(Sender: TObject);
    procedure DisconnectConnectorClick(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure CheckBoxWarnOnPatchChangeClick(Sender: TObject);
    procedure BitBtnSynthResetClick(Sender: TObject);
    procedure CutModuleClick(Sender: TObject);
    procedure CopyModuleClick(Sender: TObject);
    procedure DeleteModuleClick(Sender: TObject);
    procedure SetKnobDefaultvalueClick(Sender: TObject);
    procedure LockKnobClick(Sender: TObject);
    procedure LabeldBOutMax1Click(Sender: TObject);
    procedure LabeldBInMax1Click(Sender: TObject);
    procedure TimerLightsUpdateTimer(Sender: TObject);
    procedure RadioGroupSampleRateClick(Sender: TObject);
    procedure LabelRunTimeClick(Sender: TObject);
    procedure KnobsSmallKnob_LightsRateValueChanged(aSender: TObject; const aPath, aControlType: string; aValue: Double;
      IsFinal: Boolean);
    procedure FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure FormKeyUp(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure KnobsSelectorFileRenderValueChanged(const aSender: TObject; const aPath, aControlType: string;
      aValue: Double; IsFinal: Boolean);
    procedure SplitterMainMoved(Sender: TObject);
    procedure Color1Click(Sender: TObject);
    procedure BitBtnModuleColorClick(Sender: TObject);
    procedure CheckBoxUseWheelOnKnobsClick(Sender: TObject);
    procedure knob_WheelSensitivityValueChanged(const aSender: TObject; const aPath, aControlType: string;
      aValue: Double; IsFinal: Boolean);
    procedure CheckBoxUseUnFocusClick(Sender: TObject);
    procedure CheckBoxUsePortAudioClick(Sender: TObject);
    procedure BitBtnGhostCheckClick(Sender: TObject);
    procedure Findunconnectedmodules1Click(Sender: TObject);
    procedure KnobsSmallKnobModuleOpacityValueChanged(const aSender: TObject; const aPath, aControlType: string;
      aValue: Double; IsFinal: Boolean);
  private
    FOldMemoDebug          : TWndMethod; // Startup window proc for the debug memo
  private
    FIniLoaded             : Boolean;    // True on successful load of ini file - no auto ini save when false
    FPrioLevel             : Integer;
    FBufferSize            : Integer;
    FUseGraph              : Boolean;
    FGraphStairs           : Boolean;
    FHistoryCount          : Integer;
    FRecentSourceFiles     : TRecentStrings;
    FOrigCaption           : string;
    FReloadLastPatch       : Boolean;
    FAutoRun               : Boolean;
    FRenderToFile          : Boolean;
    FRenderFileName        : string;
    FRenderDuration        : string;
    FRenderFile            : TStereoWaveWriter;
    FPatchChanged          : Boolean;
    FWarnOnPatchChange     : Boolean;
    FUseWheelOnKnobs       : Boolean;
    FWheelSensitivity      : Integer;
    FUseUnfocus            : Boolean;
    FPopupSender           : TControl;
  private
    FNetMidiServer         : string;
    FNetMidiPort           : string;
    FNetMidiAutoConnect    : Boolean;
    FNetMidiConnected      : Boolean;
    FNetMidiChanged        : Boolean;
    FLogMidi               : Boolean;
    FLogMidiMsgs           : Boolean;
  private
    FCompilerDebug         : Boolean;
    FDebugRunning          : Boolean;
    FSynthPatch            : TSynthPatch;
    FChartSeries           : array of TFastLineSeries;
    FTime                  : Cardinal;
    FUpdateCounter         : Integer;
  private
    FPAInitialized         : Boolean;
    FUsePortAudio          : Boolean;
    FPortAudioSelected     : Boolean;
    FSelectedAPIID         : Integer;
  private
    FSelectedInputId       : DWORD;
    FSelectedOutputId      : DWORD;
    FSelectedInputIdPA     : DWORD;
    FSelectedOutputIdPA    : DWORD;
  private
    FAudioIn               : TAudioIn;
    FAudioOut              : TAudioOut;
    FPaStream              : Pointer;
    FPaInstreamParameters  : TPaStreamParameters;
    FPaOutstreamParameters : TPaStreamParameters;
    FPaAsioMinFrames       : clong;
    FPaAsioMaxFrames       : clong;
    FPaAsioPrefFrames      : clong;
    FPaAsioGranFrames      : clong;
  private
    FPaInUnderflows        : Int64;
    FPaInoverflows         : Int64;
    FPaOutUnderflows       : Int64;
    FPaOutoverflows        : Int64;
    FIOBalance             : Int64;
    FPatchReader           : IKnobsPatchReader;
    FPatchWriter           : IKnobsPatchWriter;
  private
    FStartTime             : TDateTime;
    FInShadow1             : TSignal;
    FInShadow2             : TSignal;
    FInShadow3             : TSignal;
    FInShadow4             : TSignal;
    FOutShadow1            : TSignal;
    FOutShadow2            : TSignal;
    FOutShadow3            : TSignal;
    FOutShadow4            : TSignal;
    FInVolume1             : TSignal;
    FInVolume2             : TSignal;
    FInVolume3             : TSignal;
    FInVolume4             : TSignal;
    FOutVolume1            : TSignal;
    FOutVolume2            : TSignal;
    FOutVolume3            : TSignal;
    FOutVolume4            : TSignal;
    FAudioInRunning        : Boolean;
    FAudioOutRunning       : Boolean;
  private
    FWireThickness         : Integer;
    FCurvedLines           : Boolean;
    FControlMode           : TDistanceMode;
    FLightsRate            : TSignal;
    FKeyF8Down             : Boolean;
    FResetOnRender         : Boolean;
  private
    FdBIn1                 : TSignal;
    FdBIn2                 : TSignal;
    FdBIn3                 : TSignal;
    FdBIn4                 : TSignal;
    FdBIn5                 : TSignal;
    FdBIn6                 : TSignal;
    FdBIn7                 : TSignal;
    FdBIn8                 : TSignal;
    FdBOut1                : TSignal;
    FdBOut2                : TSignal;
    FdBOut3                : TSignal;
    FdBOut4                : TSignal;
    FdBOut5                : TSignal;
    FdBOut6                : TSignal;
    FdBOut7                : TSignal;
    FdBOut8                : TSignal;
    FdBInMax1              : TSignal;
    FdBInMax2              : TSignal;
    FdBInMax3              : TSignal;
    FdBInMax4              : TSignal;
    FdBOutMax1             : TSignal;
    FdBOutMax2             : TSignal;
    FdBOutMax3             : TSignal;
    FdBOutMax4             : TSignal;
    FdBInMaxMax1           : TSignal;
    FdBInMaxMax2           : TSignal;
    FdBInMaxMax3           : TSignal;
    FdBInMaxMax4           : TSignal;
    FdBOutMaxMax1          : TSignal;
    FdBOutMaxMax2          : TSignal;
    FdBOutMaxMax3          : TSignal;
    FdBOutMaxMax4          : TSignal;
    FdBInMaxMin1           : TSignal;
    FdBInMaxMin2           : TSignal;
    FdBInMaxMin3           : TSignal;
    FdBInMaxMin4           : TSignal;
    FdBOutMaxMin1          : TSignal;
    FdBOutMaxMin2          : TSignal;
    FdBOutMaxMin3          : TSignal;
    FdBOutMaxMin4          : TSignal;
  private
    FCpuUsageData          : PCPUUsageData;
    FProcessTime           : Single;
  private
    FMidiRxState           : TMidiRxState; // Either mrxNormal or mrxRunningStatus
    FMidiRunningStatus     : Byte;         // Current running status - a midi command
    FMidiDataCount         : Integer;      // Number of bytes received dofar, for current midi message
    FMidiChannel           : Byte;         // Channel for current midi message
    FMidiData              : Byte;         // last received midi data septet
    FMidiSysex             : TBytes;       // Buffer for incoming sysex message
  private
    procedure   UpdateCaptions;
  private
    function    GetOffsetLeft       : Integer;
    procedure   SetOffsetLeft       ( aValue: Integer);
    function    GetOffsetTop        : Integer;
    procedure   SetOffsetTop        ( aValue: Integer);
    function    GetModuleColor      : TColor;
    procedure   SetModuleColor      ( aValue: TColor);
    function    GetModuleOpacity    : Byte;
    procedure   SetModuleOpacity    ( aValue: Byte);
    procedure   SetPrioLevel        ( aValue: Integer);
    function    GetSampleRate       : Integer;
    procedure   SetSampleRate       ( aValue: Integer);
    procedure   SetUseGraph         ( aValue: Boolean);
    procedure   SetGraphStairs      ( aValue: Boolean);
    procedure   SetHistoryCount     ( aValue: Integer);
    function    GetSourceFileName   : string;
    procedure   SetSourceFileName   ( const aValue: string);
    function    GetPatchName        : string;
    procedure   SetPatchName        ( const aValue: string);
    procedure   SetReloadLastPatch  ( aValue: Boolean);
    procedure   SetAutoRun          ( aValue: Boolean);
    procedure   SetRenderToFile     ( aValue: Boolean);
    procedure   SetPatchChanged     ( aValue: Boolean);
    procedure   SetWarnOnPatchChange( aValue: Boolean);
    procedure   SetUseWheelOnKnobs  ( aValue: Boolean);
    procedure   SetWheelSensitivity ( aValue: Integer);
    procedure   SetUseUnFocus       ( aValue: Boolean);
    procedure   SetUsePortAudio     ( aValue: Boolean);
  private
    procedure   SetNetMidiServer     ( const aValue: string);
    procedure   SetNetMidiPort       ( const aValue: string);
    procedure   SetNetMidiAutoConnect( aValue: Boolean);
    procedure   SetNetMidiConnected  ( aValue: Boolean);
    procedure   SetNetMidiChanged    ( aValue: Boolean);
    procedure   SetLogMidi           ( aValue: Boolean);
    procedure   SetLogMidiMsgs       ( aValue: Boolean);
    procedure   SetCompilerDebug     ( aValue: Boolean);
    procedure   PaDebugProc          ( const aMsg: string);
  private
    function    GetInVolume1         : Integer;
    procedure   SetInVolume1         ( aValue: Integer);
    function    GetOutVolume1        : Integer;
    procedure   SetOutVolume1        ( aValue: Integer);
    function    GetInVolume2         : Integer;
    procedure   SetInVolume2         ( aValue: Integer);
    function    GetOutVolume2        : Integer;
    procedure   SetOutVolume2        ( aValue: Integer);
    function    GetInVolume3         : Integer;
    procedure   SetInVolume3         ( aValue: Integer);
    function    GetOutVolume3        : Integer;
    procedure   SetOutVolume3        ( aValue: Integer);
    function    GetInVolume4         : Integer;
    procedure   SetInVolume4         ( aValue: Integer);
    function    GetOutVolume4        : Integer;
    procedure   SetOutVolume4        ( aValue: Integer);
  private
    procedure   StartRendering;
    procedure   StopRendering;
    procedure   AddRenderData( const aLeft, aRight: TSignal);
  private
    procedure   OpenRecentFile( const anIndex: Integer);
    procedure   DorecentMenuItemClick( aSender: TObject);
    procedure   AddRecentMenuItem( anIndex: Integer; const aFileName: string);
    procedure   RemoveRecentMenuItems;
    procedure   SetRecentMenuItems;
    procedure   SetMostRecentFile( const aFileName: string);
    procedure   DoSelectorMenuItemClick( aSender: TObject);
    procedure   AddSelectorMenuItem( anIndex: Integer; const aName: string);
    procedure   RemoveSelectorMenuItems;
    procedure   LoadIni;
    procedure   SaveIni;
    procedure   ShowHelp;
    function    MustMakeDocs: Boolean;
    procedure   MakeDocs( const aFolder : string);
  private
    procedure   Log( const aMsg: string);
    procedure   LogFmt( const aFmt: string; const anArgs: array of const);
    procedure   MidiLog( const aMsg: string);
    procedure   MidiLogFmt( const aFmt: string; const anArgs: array of const);
    procedure   MidiMsgLog( const aMsg: string);
    procedure   MidiMsgLogFmt( const aFmt: string; const anArgs: array of const);
    procedure   ClearMemo;
    procedure   ClearGraphs;
    procedure   BuildGraphs;
    procedure   ShowPatch;
    procedure   ProfilePatch;
    function    ChangeSynthPatch( const aSynthPatch: TSynthPatch): Boolean;
    procedure   ExecutePatch;
    procedure   ChartOutput( anIndex: Integer; aValue: TSignal);
    procedure   ChartOoutputs;
    procedure   DebugRunStop;
    procedure   EnableDebugButtons( anEnable: Boolean);
    procedure   FixLocalWheelSettings;
  private
    procedure   DeZipper;
    procedure   UpdateLights;
    function    HandleAudioInOnBufferFilled  ( aBuffer: pAnsiChar; var aSize: Integer): Boolean;
    function    HandleAudioOutOnFillBuffer   ( aBuffer: pAnsiChar; var aSize: Integer): Boolean;
    procedure   HandleAudioInOnStart         ( aSender: TObject);
    procedure   HandleAudioInOnStop          ( aSender: TObject);
    procedure   HandleAudioOutOnStart        ( aSender: TObject);
    procedure   HandleAudioOutOnStop         ( aSender: TObject);
    function    HandleAudioInOnBufferFilledPA( anInput, anOutput: Pointer; aFrameCount: culong; aTimeInfo: PPaStreamCallbackTimeInfo; aStatusFlags: TPaStreamCallbackFlags; UserData: Pointer): cint;
    function    HandleAudioOutOnFillBufferPA ( anInput, anOutput: Pointer; aFrameCount: culong; aTimeInfo: PPaStreamCallbackTimeInfo; aStatusFlags: TPaStreamCallbackFlags; UserData: Pointer): cint;
    procedure   HandleAudioOnStartPA         ( userdata: Pointer);
    procedure   HandleAudioOnStopPA          ( userdata: Pointer);
    procedure   CreateDevices;
    procedure   FreeDevices;
    procedure   HookDevices;
    procedure   UnhookDevices;
    procedure   StopAudioIn;
    procedure   StopAudioOut;
    procedure   StartAudioIn;
    procedure   StartAudioOut;
    procedure   StartStopAudioIo;
    procedure   VerifyDevices;
    procedure   SelectDevices;
    procedure   ClearVolumeIndicators;
    procedure   ShowOverUnderFlows;
    procedure   ShowRunTime;
    procedure   ResetRuntime;
    procedure   ConnectorDelete    ( const aConnector    : TKnobsConnector    );
    procedure   ConnectorBreak     ( const aConnector    : TKnobsConnector    );
    procedure   ConnectorDisconnect( const aConnector    : TKnobsConnector    );
    procedure   ModuleCut          ( const aModule       : TKnobsModule       );
    procedure   ModuleCopy         ( const aModule       : TKnobsModule       );
    procedure   ModuleDelete       ( const aModule       : TKnobsModule       );
    procedure   ChangeModuleColor  ( const aModule       : TKnobsModule       );
    procedure   KnobSetDefaultValue( const aValuedControl: TKnobsValuedControl);
    procedure   KnobChangeLock     ( const aKnob         : TKnobsKnob         );
  private
    procedure   SetWireThickness ( aValue: Integer);
    procedure   SetCurvedLines   ( aValue: Boolean);
    procedure   SetControlMode   ( aValue: TDistanceMode);
    procedure   SetLightsRate    ( aValue: TSignal);
    function    GetReferenceA    : TSignal;
    procedure   SetReferenceA    ( aValue: TSignal);
    function    GetNotesPerOctave: TSignal;
    procedure   SetNotesPerOctave( aValue: TSignal);
    function    GetMiddleNote    : TSignal;
    procedure   SetMiddleNote    ( aValue: TSignal);
    procedure   SetResetOnRender ( aValue: Boolean);
  private
    procedure   DoDesignerLog   ( const aSender: TObject; const aMsg: string);
    procedure   DoWirePanelLog  ( const aSender: TObject; const aMsg: string);
    procedure   DoHistoryChanged( const aSender: TObject; anUndoCount, aRedoCount: Integer);
    procedure   DoValueChanged  ( const aSender: TObject; const aPath, aControlType: string; aValue: TSignal; IsFinal: Boolean);
    procedure   DoDisplayChanged( const aSender: TObject; const aPath, aValue: string);
    procedure   DoFileChanged   ( const aSender: TObject; const aPath, aValue: string);
    procedure   DoShowHint( var aHintStr: string; var CanShow: Boolean; var aHintInfo: Vcl.Controls.THintInfo);
    function    DoCreateModuleBitmap( const aModuleType: TKnobsModuleType): TBitmap;
    function    DoReadModuleComment ( const aModuleType: TKnobsModuleType): string;
  private
    function    SplitValueInfo     ( const aPath: string; var aModule: TKnobsCustomModule; var aModuleType, aSignalName: string): Boolean;
    procedure   HandleSpecialValues( const aPath, aControlType: string; aValue: TSignal);
    procedure   ChangeRangeFor     ( const aModule: TKnobsCustomModule; const aModuleType, aRangeType: string; aValue: TSignal);
    procedure   ChangeModeFor      ( const aModule: TKnobsCustomModule; const aModuleType: string; aValue: TSignal);
    procedure   HandleRandomFor    ( const aModule: TKnobsCustomModule; const aModuleType: string; aValue: TSignal);
  private
    procedure   DoLights       ( const aSender: TMod; const aMsg: string);
    procedure   DoData         ( const aSender: TMod; const aPath: string; const aData: TSignalArray);
    procedure   DoXYData       ( const aSender: TMod; const aPath: string; const aData: TSignalFifo);
    procedure   DoInfo         ( const aSender: TMod; const aMsg: string);
    procedure   DoPatchChanged ( const aSender: TKnobsWirePanel);
    procedure   DoShowPopupMenu( const aSender: TKnobsWirePanel; const aControl: TControl);
    procedure   DoUnFocus( const aSender: TObject);
    function    SavePatch  : Boolean;
    function    SavePatchAs: Boolean;
    procedure   DoLoadPatch( const aFileName: string);
    procedure   LoadPatch;
    procedure   NewPatch;
    procedure   DeleteModules;
    procedure   CutModules;
    procedure   CopyModules;
    procedure   PasteModules;
    procedure   SelectAll;
    procedure   SelectNone;
    procedure   InvertSelection;
    procedure   WiggleWires;
    procedure   SearchPatch( const aValue: string);
    procedure   FindUnconnectedModules;
  private
    function    FunctionalPinName( const aName: string): string;
    function    SplitConnectorName( const aName: string; var aMod, aPin: string): Boolean;
    function    ModuleTypeToModule( aType: Integer; const aParent: TSynthPatch; const aName: string): TMod;
    procedure   CompilePatch;
  private
    procedure   InitializeCPUCounter;
    procedure   FinalizeCPUCounter;
    procedure   TickCPUCounter;
  private
    procedure   StartNetMidiConnectTimer;
    procedure   StopNetMidiConnectTimer;
    procedure   NetMidiConnectTimerFired;
    procedure   NetMidiConnect;
    procedure   NetMidiDisconnect;
    procedure   NetMidiApply;
    procedure   NetMidiCancel;
    function    SocketStateToStr( aValue: TSocketState): string;
    procedure   ReceiveNetMidi;
    procedure   SendNetMidi  ( const aData: TBytes);
    procedure   AcceptNetMidi( const aData: TBytes);
    procedure   AcceptMidiByte   ( aByte: Byte);
    procedure   AcceptMidiCommand( aByte: Byte);
    procedure   AcceptMidiData   ( aByte: Byte);
    procedure   AcceptMidiSysex  ( aByte: Byte);
    procedure   MidiReset;
    procedure   MidiProcessNoteOff        ( aVelocity, aNote, aChannel: Byte);
    procedure   MidiProcessNoteOn         ( aVelocity, aNote, aChannel: Byte);
    procedure   MidiProcessKeyPressure    ( aPressure, aNote, aChannel: Byte);
    procedure   MidiProcessControlChange  ( aValue, aController, aChannel: Byte);
    procedure   MidiProcessProgramChange  ( aProgram, aChannel: Byte);
    procedure   MidiProcessChannelPressure( aValue, aChannel: Byte);
    procedure   MidiProcessPitchBend      ( aData: Word; aChannel: Byte);
    procedure   MidiProcessStartSysEx;
    procedure   MidiProcessEndSysEx;
    procedure   MidiProcessSongPosition   ( aData: Word);
    procedure   MidiProcessSongSelect     ( aSong: Byte);
    procedure   MidiProcessTuneRequest;
    procedure   MidiProcessTimingClock;
    procedure   MidiProcessStart;
    procedure   MidiProcessContinue;
    procedure   MidiProcessStop;
    procedure   MidiProcessActiveSense;
    procedure   MidiProcessReset;
    procedure   MidiProcessSysExData      ( aData: Byte);
    procedure   MidiProcessMessage( const aMsg: TMidiMessage);
    procedure   DoMidiSendMessage( const aSender: TObject; const aMsg: TMidiMessage);
  public // yes .. public ..
    procedure   MemoDebugWindowProc( var aMsg: TMessage);
    function    IsShortCut( var aMessage: TWMKey): Boolean; override;
    procedure   ResetInPeaks;
    procedure   ResetOutPeaks;
    procedure   ResetPeaks;
  private
    property    OffsetLeft         : Integer       read GetOffsetLeft       write SetOffsetLeft;
    property    OffsetTop          : Integer       read GetOffsetTop        write SetOffsetTop;
    property    ModuleColor        : TColor        read GetModuleColor      write SetModuleColor;
    property    ModuleOpacity      : Byte          read GetModuleOpacity    write SetModuleOpacity;
    property    PrioLevel          : Integer       read FPrioLevel          write SetPrioLevel;
    property    BufferSize         : Integer       read FBufferSize         write FBufferSize;
    property    Samplerate         : Integer       read GetSampleRate       write SetSampleRate;
    property    UseGraph           : Boolean       read FUseGraph           write SetUseGraph;
    property    GraphStairs        : Boolean       read FGraphStairs        write SetGraphStairs;
    property    HistoryCount       : Integer       read FHistoryCount       write SetHistoryCount;
    property    SourceFileName     : string        read GetSourceFileName   write SetSourceFileName;
    property    PatchName          : string        read GetPatchName        write SetPatchName;
    property    ReloadLastPatch    : Boolean       read FReloadLastPatch    write SetReloadLastPatch;
    property    AutoRun            : Boolean       read FAutoRun            write SetAutoRun;
    property    RenderToFile       : Boolean       read FRenderToFile       write SetRenderToFile;
    property    PatchChanged       : Boolean       read FPatchChanged       write SetPatchChanged;
    property    WarnOnPatchChange  : Boolean       read FWarnOnPatchChange  write SetWarnOnPatchChange;
    property    UseWheelOnKnobs    : Boolean       read FUseWheelOnKnobs    write SetUseWheelOnKnobs;
    property    WheelSensitivity   : Integer       read FWheelSensitivity   write SetWheelSensitivity;
    property    UseUnFocus         : Boolean       read FUseUnfocus         write SetUseUnFocus;
    property    UsePortAudio       : Boolean       read FUsePortAudio       write setUsePortAudio;
  private
    property    NetMidiServer      : string        read FNetMidiServer      write SetNetMidiServer;
    property    NetMidiPort        : string        read FNetMidiPort        write SetNetMidiPort;
    property    NetMidiAutoConnect : Boolean       read FNetMidiAutoConnect write SetNetMidiAutoConnect;
    property    NetMidiConnected   : Boolean       read FNetMidiConnected   write SetNetMidiConnected;
    property    NetMidiChanged     : Boolean       read FNetMidiChanged     write SetNetMidiChanged;
    property    LogMidi            : Boolean       read FLogMidi            write SetLogMidi;
    property    LogMidiMsgs        : Boolean       read FLogMidiMsgs        write SetLogMidiMsgs;
    property    CompilerDebug      : Boolean       read FCompilerDebug      write SetCompilerDebug;
  private
    property    InVolume1          : Integer       read GetInVolume1        write SetInVolume1;
    property    OutVolume1         : Integer       read GetOutVolume1       write SetOutVolume1;
    property    InVolume2          : Integer       read GetInVolume2        write SetInVolume2;
    property    OutVolume2         : Integer       read GetOutVolume2       write SetOutVolume2;
    property    InVolume3          : Integer       read GetInVolume3        write SetInVolume3;
    property    OutVolume3         : Integer       read GetOutVolume3       write SetOutVolume3;
    property    InVolume4          : Integer       read GetInVolume4        write SetInVolume4;
    property    OutVolume4         : Integer       read GetOutVolume4       write SetOutVolume4;
  private
    property    WireThickness      : Integer       read FWireThickness      write SetWireThickness;
    property    CurvedLines        : Boolean       read FCurvedLines        write SetCurvedLines;
    property    ControlMode        : TDistanceMode read FControlMode        write SetControlMode;
    property    LightsRate         : TSignal       read FLightsRate         write SetLightsRate;
    property    ReferenceA         : TSignal       read GetReferenceA       write SetReferenceA;
    property    NotesPerOctave     : TSignal       read GetNotesPerOctave   write SetNotesPerOctave;
    property    MiddleNote         : TSignal       read GetMiddleNote       write SetMiddleNote;
    property    ResetOnRender      : Boolean       read FResetOnRender      write SetResetOnRender;
  end;

var
  FormModules: TFormModules;

implementation

type

  TSample    = SmallInt;                                  // External value type for OS samples
  TSamples   = packed array[ 0 .. MaxInt div SizeOf( TSample) - 1] of TSample;
  PSamples   = ^TSamples;

const

  SAMP_MAX   =   High( TSample);   // Maximum value for a sample
  SAMP_MIN   = - High( TSample);   // Minimum value for a sample

{$R *.dfm}

// User area

    function ClipSample( aSample: TSignal): TSample; inline;
    begin
      if aSample > SAMP_MAX
      then Result := SAMP_MAX
      else if aSample < SAMP_MIN
      then Result := SAMP_MIN
      else Result := Round( aSample);
    end;

    function SampleToUnits( aSample: TSample): TSignal; inline;
    begin
      Result := aSample / SAMP_MAX;
    end;

    function SignalToSample( aUnit: TSignal): TSample; inline;
    begin
      Result := ClipSample( aUnit * SAMP_MAX);
    end;

    // Port audio stream callbacks

    function    GHandleAudioOnBufferFilledPA( anInput, anOutput: Pointer; aFrameCount: culong; aTimeInfo: PPaStreamCallbackTimeInfo; aStatusFlags: TPaStreamCallbackFlags; UserData: Pointer): cint; cdecl;
    begin
      if Assigned( FormModules)
      then begin
        Result := FormModules.HandleAudioInOnBufferFilledPA( anInput, anOutput, aFrameCount, aTimeInfo, aStatusFlags, UserData);
        if Result = paContinue
        then Result := FormModules.HandleAudioOutOnFillBufferPA ( anInput, anOutput, aFrameCount, aTimeInfo, aStatusFlags, UserData);
      end
      else Result := paAbort;
    end;

    procedure   GHandleAudioOnStopPA( userdata: Pointer); cdecl;
    begin
      if Assigned( FormModules)
      then FormModules.HandleAudioOnStopPA( userdata);
    end;

    procedure   GPaDebugProc( const aMsg: PAnsiChar); cdecl;
    begin
      if Assigned( FormModules)
      then FormModules.PaDebugProc( string( aMsg));
    end;


{ ========
  TPageControl = class( Vcl.ComCtrls.TPageControl)
  private
}

    // Some stuff to fix the border width for TPageControls

    procedure   TPageControl.TCMAdjustRect(var Msg: TMessage); // message TCM_ADJUSTRECT;
    begin
      inherited;
      if Msg.WParam = 0
      then InflateRect( PRect( Msg.LParam)^,  4,  4)
      else InflateRect( PRect( Msg.LParam)^, -4, -4);
    end;



{ ========
  TFormModules = class( TForm)
  private
}

    procedure   TFormModules.UpdateCaptions;

      procedure Addpart( const aParts: TStringList; const aPart: string);
      begin
        if aPart <> ''
        then aParts.Add( aPart);
      end;

    const
    {$ifdef DEBUG}
      Changed: array[ Boolean] of string = (
        'DEBUG ',
        '*** DEBUG'
      );
      Runs: array[ Boolean] of string = (
        'STOPPED',
        ''
      );
    {$else}
      Changed: array[ Boolean] of string = (
        '',
        '***'
      );
      Runs: array[ Boolean] of string = (
        'STOPPED',
        ''
      );
    {$endif}
      PortAudio: array[ Boolean] of string = (
        'using Windows legacy audio',
        'using Port Audio'
      );
      Pleases1: array[ Boolean] of string = (
        '',
        'Please stop audio processing before making changes here,'
      );
      Pleases2: array[ Boolean] of string = (
        '',
        'and stop and restart the program after making changes.'
      );
      Caps: array[ Boolean] of string = (
        'run',
        'stop'
      );
      {$IFDEF PATCH_PROFILER}
      Profiled = 'PROFILED';
      {$ELSE}
      Profiled = '';
      {$ENDIF}
    var
      aParts : TStringList;
    begin
      aparts := TStringList.Create;
      try
        Addpart( aParts, Changed[ PatchChanged]);
        AddPart( aParts, Profiled);
        Addpart( aParts, Runs[ FAudioInRunning and FAudioOutRunning]);
        AddPart( aParts, FOrigCaption);
        AddPart( aParts, PatchName);
        Addpart( aparts, ExtractFileName( SourceFileName));
        Addpart( aParts, portaudio[ FPortAudioSelected]);
        Caption := Implode( aParts, ' :: ');
        LabelPleaseStopAudio1  .Caption := Pleases1[ FAudioInRunning or  FAudioOutRunning];
        LabelPleaseStopAudio2  .Caption := Pleases2[ FAudioInRunning or  FAudioOutRunning];
        BitBtnAudioRunning     .Caption := Caps[ FAudioInRunning and FAudioOutRunning];
        MenuActionRunStop      .Caption := Caps[ FAudioInRunning and FAudioOutRunning];
        MenuActionRunStop      .Checked :=       FAudioInRunning and FAudioOutRunning;
        GroupBoxAudioProperties.Enabled := not(  FAudioInRunning and FAudioOutRunning);
      finally
        aParts.Free;
      end;
    end;

    //  private

    function    TFormModules.GetOffsetLeft: Integer;
    begin
      if Assigned( EditorPatch)
      then Result := EditorPatch.OffsetLeft
      else Result := 4;
    end;

    procedure   TFormModules.SetOffsetLeft( aValue: Integer);
    begin
      if Assigned( EditorPatch)
      then EditorPatch.OffsetLeft           := aValue;
      KnobsSmallKnob_LeftOffset.KnobPosition := aValue;
    end;

    function    TFormModules.GetOffsetTop: Integer;
    begin
      if Assigned( EditorPatch)
      then Result := EditorPatch.OffsetTop
      else Result := 4;
    end;

    procedure   TFormModules.SetOffsetTop( aValue: Integer);
    begin
      if Assigned( EditorPatch)
      then EditorPatch.OffsetTop           := aValue;
      KnobsSmallKnob_TopOffset.KnobPosition := aValue;
    end;

    function    TFormModules.GetModuleColor: TColor;
    begin
      Result := EditorPatch.ModuleColor;
    end;

    procedure   TFormModules.SetModuleColor( aValue: TColor);
    begin
      EditorPatch        .ModuleColor := aValue;
      KnobsLedModuleColor.ColorOn     := aValue;
    end;

    function    TFormModules.GetModuleOpacity: Byte;
    begin
      Result := EditorPatch.ModuleOpacity;
    end;

    procedure   TFormModules.SetModuleOpacity( aValue: Byte);
    begin
      EditorPatch                .ModuleOpacity := aValue;
      KnobsSmallKnobModuleOpacity.KnobPosition  := aValue;
    end;

    procedure   TFormModules.SetPrioLevel( aValue: Integer);

      function PriorityLevelToStr( aValue : Integer): string;
      begin
        case aValue of
         -1  : Result := 'idle';
          0  : Result := 'normal';
          1  : Result := 'higher';
          2  : Result := 'real time';
          else Result := Format( 'unknown (%d)', [ aValue]);
        end;
      end;

    begin
      if aValue <> FPrioLevel
      then begin
        if SetPriorityLevel( aValue)
        then begin
          FPrioLevel := aValue;
          LogFmt( 'priority level was set to "%s".', [ PriorityLevelToStr( FPrioLevel)]);
        end
        else LogFmt( 'could not set priority level to "%s".', [ PriorityLevelToStr( aValue)]);
      end;
      RadioGroupPrioLevel.ItemIndex := FPrioLevel;
    end;

    function    TFormModules.GetSampleRate: Integer;
    begin
      Result := System_Rate;;
    end;

    procedure   TFormModules.SetSampleRate( aValue: Integer);
    begin
      Assert( not( FAudioInRunning or FAudioOutRunning), 'Audio must be stopped for changing the system rate');
      if
        ( aValue <> 44100) and
        ( aValue <> 48000) and
        ( aValue <> 88200) and
        ( aValue <> 96000)
      then aValue := 44100;

      if aValue <> System_Rate
      then begin
        FreeDevices;                // Recreate devices for new sample rate
        SetSystemRate( aValue);     // Recalculate lookup tables and such
        HrastUnit.CreateTables;     // Recalculate Hrast lookup tables too
        CreateDevices;
        case aValue of
          44100 : RadioGroupSampleRate.ItemIndex := 0;
          48000 : RadioGroupSampleRate.ItemIndex := 1;
          88200 : RadioGroupSampleRate.ItemIndex := 2;
          96000 : RadioGroupSampleRate.ItemIndex := 3;
        end;
      end;
    end;

    procedure   TFormModules.SetUseGraph( aValue: Boolean);
    begin
      if aValue <> FUseGraph
      then begin
        FUseGraph := aValue;
        CheckBoxUseGraph.Checked := aValue;
        BuildGraphs;
      end;
    end;

    procedure   TFormModules.SetGraphStairs( aValue: Boolean);
    var
      i : Integer;
    begin
      if aValue <> FGraphStairs
      then begin
        FGraphStairs                := aValue;
        CheckBoxGraphStairs.Checked := aValue;
        for i := 0 to Length( FChartSeries) - 1
        do FChartSeries[ i].Stairs := aValue;
      end;
    end;

    procedure   TFormModules.SetHistoryCount( aValue: Integer);
    begin
      if aValue <> FHistoryCount
      then begin
        FHistoryCount := aValue;
      end;
    end;

    function    TFormModules.GetSourceFileName : string;
    begin
      if Assigned( EditorPatch)
      then Result := EditorPatch.Filename
      else Result := '';
    end;

    procedure   TFormModules.SetSourceFileName( const aValue: string);
    begin
      if ( aValue <> SourceFileName) and Assigned( EditorPatch)
      then begin
        EditorPatch.Filename := aValue;
        SetMostRecentFile( aValue);
        UpdateCaptions;
      end;
    end;

    function    TFormModules.GetPatchName: string;
    begin
      if Assigned( EditorPatch)
      then Result := EditorPatch.Title
      else Result := 'no name';
    end;

    procedure   TFormModules.SetPatchName( const aValue: string);
    begin
      if ( aValue <> PatchName) and Assigned( EditorPatch)
      then begin
        EditorPatch.Title := aValue;
        UpdateCaptions;
      end;
      EditPatchName.Text  := aValue;
    end;

    procedure   TFormModules.SetPatchChanged( aValue: Boolean);
    begin
      if aValue <> FPatchChanged
      then begin
        FPatchChanged := aValue;
        UpdateCaptions;
      end;
    end;

    procedure   TFormModules.SetWarnOnPatchChange( aValue: Boolean);
    begin
      if aValue <> FWarnOnPatchChange
      then begin
        FWarnOnPatchChange                := aValue;
        CheckBoxWarnOnPatchChange.Checked := aValue;
      end;
    end;

    procedure   TFormModules.SetUseWheelOnKnobs( aValue: Boolean);
    begin
      if aValue <> FUseWheelOnKnobs
      then begin
        FUseWheelOnKnobs                := aValue;
        CheckBoxUseWheelOnKnobs.Checked := aValue;
        if Assigned( EditorPatch)
        then EditorPatch.WheelSupportOnKnobs := aValue;
        FixLocalWheelSettings;
        CheckBoxUseUnFocus.Enabled := aValue;
      end;
    end;

    procedure   TFormModules.SetWheelSensitivity( aValue: Integer);
    begin
      if aValue <> FWheelSensitivity
      then begin
        FWheelSensitivity                  := aValue;
        knob_WheelSensitivity.KnobPosition := aValue;
        if Assigned( EditorPatch)
        then EditorPatch.WheelSensitivity := aValue;
        FixLocalWheelSettings;
      end;
    end;

    procedure   TFormModules.SetUseUnFocus( aValue: Boolean);
    begin
      if aValue <> FUSeUnFocus
      then begin
        FUSeUnFocus                := aValue;
        CheckBoxUseUnFocus.Checked := aValue;
      end;
    end;

    procedure   TFormModules.SetUsePortAudio( aValue: Boolean);
    begin
      if aValue <> FUsePortAudio
      then begin
        FUsePortAudio                := aValue;
        CheckBoxUsePortAudio.Checked := aValue;
        SelectDevices;
      end;
    end;

    procedure   TFormModules.SetReloadLastPatch( aValue: Boolean);
    begin
      if aValue <> FReloadLastPatch
      then begin
        FReloadLastPatch                := aValue;
        CheckBoxReloadLastPatch.Checked := aValue;
      end;
    end;

    procedure   TFormModules.SetAutoRun( aValue: Boolean);
    begin
      if aValue <> FAutoRun
      then begin
        FAutoRun                := aValue;
        CheckBoxAutoRun.Checked := aValue;
        if AutoRun
        then begin
          if not FAudioInRunning
          then StartAudioIn;
          if not FAudioOutRunning
          then StartAudioOut;
        end;
      end;
    end;

    procedure   TFormModules.SetRenderToFile( aValue: Boolean);
    begin
      if aValue <> FRenderToFile
      then begin
        FRenderToFile := aValue;
        KnobsSelectorFileRender.KnobPosition := Ord( aValue);
        if aValue
        then StartRendering;
      end;
    end;

//  private

    procedure   TFormModules.SetNetMidiServer( const aValue: string);
    var
      WasConnected : Boolean;
    begin
      if aValue <> FNetMidiServer
      then begin
        WasConnected := NetMidiConnected;
        NetMidiDisconnect;
        FNetMidiServer := aValue;
        if WasConnected
        then NetMidiConnect;
      end;
    end;

    procedure   TFormModules.SetNetMidiPort( const aValue: string);
    var
      WasConnected : Boolean;
    begin
      if aValue <> FNetMidiPort
      then begin
        WasConnected := NetMidiConnected;
        NetMidiDisconnect;
        FNetMidiPort := aValue;
        if WasConnected
        then NetMidiConnect;
      end;
    end;

    procedure   TFormModules.SetNetMidiAutoConnect( aValue: Boolean);
    begin
      if aValue <> FNetMidiAutoConnect
      then begin
        FNetMidiAutoConnect                := aValue;
        CheckBoxNetMidiAutoConnect.Checked := aValue;
        if NetMidiAutoConnect and not NetMidiConnected
        then StartNetMidiConnectTimer;
      end;
    end;

    procedure   TFormModules.SetNetMidiConnected( aValue: Boolean);
    const
      Caps : array[ Boolean] of string = (
        'connect',
        'disconnect'
      );
    begin
      if aValue <> FNetMidiConnected
      then begin
        FNetMidiConnected            := aValue;
        LedNetMidiConnect1  .Active  := aValue;
        LedNetMidiConnect2  .Active  := aValue;
        BitBtnNetMidiConnect.Caption := Caps[ aValue];
      end;
    end;

    procedure   TFormModules.SetNetMidiChanged( aValue: Boolean);
    begin
      if aValue <> FNetMidiChanged
      then begin
        FNetMidiChanged             := aValue;
        BitBtnApplyNetMidi .Enabled := aValue;
        BitBtnCancelNetMidi.Enabled := aValue;
      end;
    end;

    procedure   TFormModules.SetLogMidi( aValue: Boolean);
    begin
      if  aValue <> FLogMidi
      then begin
        FLogMidi                := aValue;
        CheckBoxLogMidi.Checked := aValue;
      end;
    end;

    procedure   TFormModules.SetLogMidiMsgs( aValue: Boolean);
    begin
      if  aValue <> FLogMidiMsgs
      then begin
        FLogMidiMsgs                := aValue;
        CheckBoxLogMidiMsgs.Checked := aValue;
      end;
    end;

    procedure   TFormModules.SetCompilerDebug( aValue: Boolean);
    begin
      if  aValue <> FCompilerDebug
      then begin
        FCompilerDebug                := aValue;
        CheckBoxCompilerDebug.Checked := aValue;
      end;
    end;

    procedure   TFormModules.PaDebugProc( const aMsg: string);
    begin
      Log( aMsg);
    end;

//  private

    function    TFormModules.GetInVolume1: Integer;
    begin
      Result := knob_inputlevel1.KnobPosition;
    end;

    procedure   TFormModules.SetInVolume1( aValue: Integer);
    begin
      knob_inputlevel1.KnobPosition := aValue;
      FInShadow1                    := knob_inputlevel1.AsValue;
    end;

    function    TFormModules.GetOutVolume1: Integer;
    begin
      Result := knob_outputlevel1.KnobPosition;
    end;

    procedure   TFormModules.SetOutVolume1( aValue: Integer);
    begin
      knob_outputlevel1.KnobPosition := aValue;
      FOutShadow1                    := knob_outputlevel1.AsValue;
    end;

    function    TFormModules.GetInVolume2: Integer;
    begin
      Result := knob_inputlevel2.KnobPosition;
    end;

    procedure   TFormModules.SetInVolume2( aValue: Integer);
    begin
      knob_inputlevel2.KnobPosition := aValue;
      FInShadow2                    := knob_inputlevel2.AsValue;
    end;

    function    TFormModules.GetOutVolume2: Integer;
    begin
      Result := knob_outputlevel2.KnobPosition;
    end;

    procedure   TFormModules.SetOutVolume2( aValue: Integer);
    begin
      knob_outputlevel2.KnobPosition := aValue;
      FOutShadow2                    := knob_outputlevel2.AsValue;
    end;

    function    TFormModules.GetInVolume3: Integer;
    begin
      Result := knob_inputlevel3.KnobPosition;
    end;

    procedure   TFormModules.SetInVolume3( aValue: Integer);
    begin
      knob_inputlevel3.KnobPosition := aValue;
      FInShadow3                    := knob_inputlevel3.AsValue;
    end;

    function    TFormModules.GetOutVolume3: Integer;
    begin
      Result := knob_outputlevel3.KnobPosition;
    end;

    procedure   TFormModules.SetOutVolume3( aValue: Integer);
    begin
      knob_outputlevel3.KnobPosition := aValue;
      FOutShadow3                    := knob_outputlevel3.AsValue;
    end;

    function    TFormModules.GetInVolume4: Integer;
    begin
      Result := knob_inputlevel4.KnobPosition;
    end;

    procedure   TFormModules.SetInVolume4( aValue: Integer);
    begin
      knob_inputlevel4.KnobPosition := aValue;
      FInShadow4                    := knob_inputlevel4.AsValue;
    end;

    function    TFormModules.GetOutVolume4: Integer;
    begin
      Result := knob_outputlevel4.KnobPosition;
    end;

    procedure   TFormModules.SetOutVolume4( aValue: Integer);
    begin
      knob_outputlevel4.KnobPosition := aValue;
      FOutShadow4                    := knob_outputlevel4.AsValue;
    end;

//  private

    procedure   TFormModules.StartRendering;
    // Start recording
    var
      WasRunning : Boolean;
      i          : Integer;
      OldPrio    : Integer;
      aLeft      : TSignal;
      aRight     : TSignal;
      aMaxLeft   : TSignal;
      aMaxRight  : TSignal;
      aDb        : TSignal;
      aTimeLimit : TSignal;
    begin
      with SaveDialogWave
      do begin
        WasRunning := FAudioInRunning or FAudioOutRunning;
        StopAudioIn;
        StopAudioOut;

        FileName := FRenderFileName;
        if
          Assigned( FSynthPatch) and
          Execute                and
          InputQuery(
            'Please give a maximum duration for recording',
            'Duration in minutes (may be fractional, 0 or blank means unlimted)',
            FRenderDuration
          )
        then begin
          StopRendering; // Close any render file that would still be open for whatever reason ...
          FRenderFileName := FileName;
          FRenderFile     := TStereoWaveWriter.Create( FRenderFileName, System_Rate);
          ResetRunTime;
          KnobsLedrendering.Visible := True;
          FOutShadow1 := knob_outputlevel1.AsValue;
          aTimeLimit  := StrToFloatDef( FRenderDuration, 0) * 60 * 1000;

          OldPrio   := PrioLevel;
          PrioLevel := -1;             // Set 'idle' priority level for rendering
          LogFmt( 'Rendering to file %s', [ FRenderFileName]);
          try
            try
              FSynthPatch.FixZippers;
              if ResetOnRender
              then FSynthPatch.Reset;
              while RenderToFile and not ( FAudioInRunning or FAudioOutRunning)
              do begin
                Application.ProcessMessages;
                DeZipper;
                aMaxLeft  := 0;
                aMaxRight := 0;
                for i := 1 to 512
                do begin
                  DeZipper;
                  if FRenderFile.Size >= 2 * Int64( GIBI)
                  then begin
                    Log( 'Rendering stopped, file size >= 2 GiB');
                    RenderToFile := False;
                    Break;
                  end;

                  with FSynthPatch
                  do begin
                    Tick;
                    aLeft  := FOutVolume1 * Output[ 0];
                    aRight := FOutVolume1 * Output[ 1];
                  end;

                  AddRenderData( aLeft, aRight);
                  aMaxLeft  := Max( aMaxLeft , Abs( aLeft ));
                  aMaxRight := Max( aMaxRight, Abs( aRight));
                  FdBOut1 := SignalTodB( aMaxLeft );
                  FdBOut2 := SignalTodB( aMaxRight);
                  adB     := Max( FdBOut1, FdBOut2);
                  if adB > FdBOutMax1
                  then FdBOutMax1 := adB
                  else FdBOutMax1 := ( 199 * FdBOutMax1 + adB) / 200;
                  if adB > FdBOutMaxMax1
                  then FdBOutMaxMax1 := adB;
                  if adB < FdBOutMaxMin1
                  then FdBOutMaxMin1 := adB;

                end;
                if aTimeLimit > 0
                then begin
                  if FRenderFile.Duration >= aTimeLimit
                  then RenderToFile := False;
                  LabelRunTime.Caption := FormatDateTime( '"R" hh:mm:ss', ( aTimeLimit - FRenderFile.Duration) / ( 1000 * 60 * 60 * 24), AppLocale);
                  LabelRunTime.Hint    := 'Remaining time for current recording, abort by clicking the stop file render button';
                end
                else begin
                  LabelRunTime.Caption := FormatDateTime( '"D" hh:mm:ss', FRenderFile.Duration / ( 1000 * 60 * 60 * 24), AppLocale);
                  LabelRunTime.Hint    := 'Duration of current recording, abort by clicking the stop file render button';
                end;
              end;
            except
              on E: Exception
              do begin
                LogFmt( 'Rendering stopped with error: %s', [ E.Message]);
                RenderToFile := False;
              end;
            end;
          finally
            PrioLevel := OldPrio;
            StopRendering;
          end;
        end
        else begin
          // File dialog or time dialog was cancelled, do not start a rendering
          RenderToFile              := False;
          KnobsLedrendering.Visible := False;
          if WasRunning
          then begin
            StartAudioIn;
            StartAudioOut;
          end;
        end;
      end;
    end;

    procedure   TFormModules.StopRendering;
    // End a recording
    begin
      KnobsLedrendering.Visible := False;
      FreeAndNil( FRenderFile);
    end;

    procedure   TFormModules.AddRenderData( const aLeft, aRight: TSignal);
    begin
      if Assigned( FRenderFile)
      then FRenderFile.WriteSample( SignalToSample( aLeft) + ( SignalToSample( aRight) shl 16));
    end;


//  private

    procedure   TFormModules.OpenRecentFile( const anIndex: Integer);
    var
      aFileName: string;
    begin
      if
        Assigned( FRecentSourceFiles)         and
        ( anIndex >= 0)                       and
        ( anIndex < FRecentSourceFiles.Count)
      then begin
        aFileName := FRecentSourceFiles[ anIndex];
        if FileExists( aFileName)
        then DoLoadPatch( aFileName)
        else begin
          FRecentSourceFiles.Delete( anIndex);
          SetRecentMenuItems;
        end;
      end;
    end;

    procedure   TFormModules.DorecentMenuItemClick( aSender: TObject);
    var
      aMenuItem: TMenuItem;
    begin
      aMenuItem := aSender as TMenuItem;
      if Assigned( aMenuItem)
      then OpenRecentFile( aMenuItem.Tag);
    end;

    procedure   TFormModules.AddRecentMenuItem( anIndex: Integer; const aFileName: string);
    var
      aMenuItem : TMenuItem;
      aHotKey   : Char;
    begin
      if FileExists( aFileName)
      then begin
        aMenuItem := TMenuItem.Create( MenuFileReopen);
        with aMenuItem
        do begin
          if anIndex >= 10
          then aHotKey := Char( anIndex + Ord( 'A'))
          else aHotKey := Char( anIndex + Ord( '0'));
          Caption := Format( '&%s %s', [ aHotKey, aFileName], AppLocale);
          Tag     := anIndex;
          OnClick := DorecentMenuItemClick;
        end;
        MenuFileReopen.Add( aMenuItem);
      end;
    end;

    procedure   TFormModules.RemoveRecentMenuItems;
    var
      i : Integer;
    begin
      with MenuFileReopen
      do begin
        for i := Count - 1 downto 0
        do Delete( i);
      end;
    end;

    procedure   TFormModules.SetRecentMenuItems;
    var
      i : Integer;
    begin
      RemoveRecentMenuItems;
      for i := 0 to FRecentSourceFiles.Count - 1
      do AddrecentMenuItem( i, FRecentSourceFiles[ i]);
    end;

    procedure   TFormModules.SetMostRecentFile( const aFileName: string);
    begin
      FRecentSourceFiles.SetMostRecent( aFileName);
      SetRecentMenuItems;
    end;

    procedure   TFormModules.DoSelectorMenuItemClick( aSender: TObject);
    var
      aSelector : TKnobsSelector;
      aMenuItem : TMenuItem;
    begin
      aMenuItem := aSender as TMenuItem;
      if Assigned( aMenuItem)
      then begin
        aSelector := TKnobsSelector( FPopupSender);
        aSelector.KnobPosition := aMenuItem.MenuIndex;
        aSelector.FixPeers;
      end;
    end;

    procedure   TFormModules.AddSelectorMenuItem( anIndex: Integer; const aName: string);
    var
      aMenuItem : TMenuItem;
      aHotKey   : Char;
    begin
        aMenuItem := TMenuItem.Create( PopupMenuSelector);
        with aMenuItem
        do begin
          if anIndex >= 10
          then aHotKey := Char( anIndex + Ord( 'A'))
          else aHotKey := Char( anIndex + Ord( '0'));
          Caption := Format( '&%s %s', [ aHotKey, aName], AppLocale);
          Tag        := anIndex;
          ImageIndex := anIndex;
          OnClick    := DoSelectorMenuItemClick;
        end;
        PopupMenuSelector.Items.Add( aMenuItem);
    end;

    procedure   TFormModules.RemoveSelectorMenuItems;
    var
      i : Integer;
    begin
      with PopupMenuSelector
      do begin
        for i := Items.Count - 1 downto 0
        do Items.Delete( i);
      end;
    end;

const

  sdfs = 'settings';

    procedure   TFormModules.LoadIni;
    var
      L, T, W, H   : Integer;
      anIniFile    : TMemIniFile;
      DoAutoRun    : Boolean;
      WinState     : TWindowState;
      LRate        : Integer;
      ControlWidth : Integer;
    begin
      logFmt( 'Loading inifile: %s', [ IniFileName]);

      anIniFile    := TMemIniFile.Create( IniFileName);
      LRate        := KnobsSmallKnob_LightsRate.KnobPosition;
      ControlWidth := PanelControl.Width;

      with anIniFile
      do begin
        try
          FRecentSourceFiles.LoadFromIni( anIniFile, 'RecentFiles');
          HistoryCount         := FRecentSourceFiles.MaxDepth;

          L                    :=                ReadInteger( sdfs, 'Left'              ,          Left                 );
          T                    :=                ReadInteger( sdfs, 'Top'               ,          Top                  );
          W                    :=                ReadInteger( sdfs, 'Width'             ,          Width                );
          H                    :=                ReadInteger( sdfs, 'Height'            ,          Height               );
          WinState             := TWindowState ( ReadInteger( sdfs, 'WindowState'       , Integer( WindowState        )));
          ControlWidth         :=                ReadInteger( sdfs, 'ControlWidth'      ,          ControlWidth         );
          OffsetLeft           :=                ReadInteger( sdfs, 'OffsetLeft'        ,          OffsetLeft           );
          OffsetTop            :=                ReadInteger( sdfs, 'OffsetTop'         ,          OffsetTop            );
          ModuleColor          := TColor       ( ReadInteger( sdfs, 'ModuleColor'       , Integer( ModuleColor        )));
          ModuleOpacity        :=                ReadInteger( sdfs, 'ModuleOpacity'     ,          ModuleOpacity        );
          PrioLevel            :=                ReadInteger( sdfs, 'PrioLevel'         ,          PrioLevel            );
          ReloadLastPatch      :=                ReadBool   ( sdfs, 'ReloadLastPatch'   ,          ReloadLastPatch      );
          DoAutoRun            :=                ReadBool   ( sdfs, 'AutoRun'           ,          AutoRun              );
          FRenderFileName      :=                ReadString ( sdfs, 'RenderFileName'    ,          FRenderFileName      );
          FRenderDuration      :=                ReadString ( sdfs, 'RenderDuration'    ,          FRenderDuration      );
          SourceFileName       :=                ReadString ( sdfs, 'SourceFileName'    ,          SourceFileName       );
          UseGraph             :=                ReadBool   ( sdfs, 'UseGraph'          ,          UseGraph             );
          GraphStairs          :=                ReadBool   ( sdfs, 'GraphStairs'       ,          GraphStairs          );
          InVolume1            :=                ReadInteger( sdfs, 'InVolume1'         ,          InVolume1            );
          InVolume2            :=                ReadInteger( sdfs, 'InVolume2'         ,          InVolume2            );
          InVolume3            :=                ReadInteger( sdfs, 'InVolume3'         ,          InVolume3            );
          InVolume4            :=                ReadInteger( sdfs, 'InVolume4'         ,          InVolume4            );
          OutVolume1           :=                ReadInteger( sdfs, 'OutVolume1'        ,          OutVolume1           );
          OutVolume2           :=                ReadInteger( sdfs, 'OutVolume2'        ,          OutVolume2           );
          OutVolume3           :=                ReadInteger( sdfs, 'OutVolume3'        ,          OutVolume3           );
          OutVolume4           :=                ReadInteger( sdfs, 'OutVolume4'        ,          OutVolume4           );
          WireThickness        :=                ReadInteger( sdfs, 'WireThickness'     ,          WireThickness        );
          CurvedLines          :=                ReadBool   ( sdfs, 'CurvedLines'       ,          CurvedLines          );
          ControlMode          := TDistanceMode( ReadInteger( sdfs, 'ControlMode'       , Integer( ControlMode        )));
          LRate                :=                ReadInteger( sdfs, 'LightsRate'        ,          LRate                );
          SampleRate           :=                ReadInteger( sdfs, 'SampleRate'        ,          Samplerate           );
          BufferSize           :=                ReadInteger( sdfs, 'BufferSize'        ,          BufferSize           );
          ReferenceA           :=                ReadFloat  ( sdfs, 'ReferenceA'        ,          ReferenceA           );
          NotesPerOctave       :=                ReadFloat  ( sdfs, 'NotesPerOctave'    ,          NotesPerOctave       );
          MiddleNote           :=                ReadFloat  ( sdfs, 'MiddleNote'        ,          MiddleNote           );
          FSelectedAPIID       :=                ReadInteger( sdfs, 'SelectedAPIID'     ,          FSelectedAPIID       );
          FSelectedInputId     := DWORD(         ReadInteger( sDfs, 'SelectedInput'     ,          FSelectedInputId    ));
          FSelectedOutputId    := DWORD(         ReadInteger( sDfs, 'SelectedOutput'    ,          FSelectedOutputId   ));
          FSelectedInputIdPA   := DWORD(         ReadInteger( sDfs, 'SelectedInputPA'   ,          FSelectedInputIdPA  ));
          FSelectedOutputIdPA  := DWORD(         ReadInteger( sDfs, 'SelectedOutputPA'  ,          FSelectedOutputIdPA ));
          NetMidiServer        :=                ReadString ( sdfs, 'NetMidiServer'     ,          NetMidiServer        );
          NetMidiPort          :=                ReadString ( sdfs, 'NetMidiPort'       ,          NetMidiPort          );
          NetMidiAutoConnect   :=                ReadBool   ( sdfs, 'NetMidiAutoConnect',          NetMidiAutoConnect   );
          LogMidi              :=                ReadBool   ( sdfs, 'LogMidi'           ,          LogMidi              );
          LogMidiMsgs          :=                ReadBool   ( sdfs, 'LogMidiMsgs'       ,          LogMidiMsgs          );
          CompilerDebug        :=                ReadBool   ( sdfs, 'CompilerDebug'     ,          CompilerDebug        );
          WarnOnPatchChange    :=                ReadBool   ( sdfs, 'WarnOnPatchChange' ,          WarnOnPatchChange    );
          UseWheelOnKnobs      :=                ReadBool   ( sdfs, 'UseWheelOnKnobs'   ,          UseWheelOnKnobs      );
          WheelSensitivity     :=                ReadInteger( sdfs, 'WheelSensitivity'  ,          WheelSensitivity     );
          UseUnFocus           :=                ReadBool   ( sdfs, 'UseUnFocus'        ,          UseUnFocus           );
          UsePortAudio         :=                ReadBool   ( sdfs, 'UsePortAudio'      ,          UsePortAudio         );
          ResetOnRender        :=                ReadBool   ( sdfs, 'ResetOnRender'     ,          ResetOnRender        );

          NetMidiCancel;

          if ( L < 0) or ( L > Screen.Width  - 20) then L := 0;
          if ( T < 0) or ( T > Screen.Height - 20) then T := 0;
          if W > Screen.Width                      then W := Screen.Width  - 20;
          if H > Screen.Height                     then H := Screen.Height - 20;

          SetBounds( L, T, W, H);
          if WinState = wsMaximized
          then WindowState := wsMaximized;

          PanelControl.Width := ControlWidth;

          VerifyDevices;
          if ReloadLastPatch and FileExists( SourceFileName)
          then begin
            LogFmt( 'Reopening last used patch [%s]', [ SourceFileName]);
            DoLoadPatch( SourceFileName);
          end
          else begin
            LogFmt( 'Could not find last used patch [%s] - starting a new patch', [ SourceFileName]);
            DoAutoRun      := False;
            PatchName      := 'new patch';
            SourceFileName := 'new_patch';
          end;
          AutoRun := DoAutoRun;
          UpdateCaptions;
          KnobsSmallKnob_LightsRate.KnobPosition := LRate;
          FIniLoaded := True;
        finally
          Free;
        end;
      end;
      Log('ini file loaded');
    end;

    procedure   TFormModules.SaveIni;
    var
      anIniFile    : TMemIniFile;
      LRate        : Integer;
      ControlWidth : Integer;
    begin
      anIniFile    := TMemIniFile.Create( IniFileName);
      LRate        := KnobsSmallKnob_LightsRate.KnobPosition;
      ControlWidth := PanelControl.Width;
      with anIniFile
      do begin
        try
          EraseSection( sdfs);
          WriteInteger( sdfs, 'Left'              ,          Left                 );
          WriteInteger( sdfs, 'Top'               ,          Top                  );
          WriteInteger( sdfs, 'Width'             ,          Width                );
          WriteInteger( sdfs, 'Height'            ,          Height               );
          WriteInteger( sdfs, 'WindowState'       , Integer( WindowState         ));
          WriteInteger( sdfs, 'ControlWidth'      ,          ControlWidth         );
          WriteInteger( sdfs, 'PrioLevel'         ,          PrioLevel            );
          WriteInteger( sdfs, 'OffsetLeft'        ,          OffsetLeft           );
          WriteInteger( sdfs, 'OffsetTop'         ,          OffsetTop            );
          WriteInteger( sdfs, 'ModuleColor'       , Integer( ModuleColor         ));
          WriteInteger( sdfs, 'ModuleOpacity'     ,          ModuleOpacity        );
          WriteBool   ( sdfs, 'ReloadLastPatch'   ,          ReloadLastPatch      );
          WriteBool   ( sdfs, 'AutoRun'           ,          AutoRun              );
          WriteBool   ( sdfs, 'RenderToFile'      ,          RenderToFile         );
          WriteString ( sdfs, 'RenderFileName'    ,          FRenderFileName      );
          WriteString ( sdfs, 'RenderDuration'    ,          FRenderDuration      );
          WriteString ( sdfs, 'SourceFileName'    ,          SourceFileName       );
          WriteBool   ( sdfs, 'UseGraph'          ,          UseGraph             );
          WriteBool   ( sdfs, 'GraphStairs'       ,          GraphStairs          );
          WriteFloat  ( sdfs, 'InVolume1'         ,          InVolume1            );
          WriteFloat  ( sdfs, 'InVolume2'         ,          InVolume2            );
          WriteFloat  ( sdfs, 'InVolume3'         ,          InVolume3            );
          WriteFloat  ( sdfs, 'InVolume4'         ,          InVolume4            );
          WriteFloat  ( sdfs, 'OutVolume1'        ,          OutVolume1           );
          WriteFloat  ( sdfs, 'OutVolume2'        ,          OutVolume2           );
          WriteFloat  ( sdfs, 'OutVolume3'        ,          OutVolume3           );
          WriteFloat  ( sdfs, 'OutVolume4'        ,          OutVolume4           );
          WriteInteger( sdfs, 'WireThickness'     ,          WireThickness        );
          WriteBool   ( sdfs, 'CurvedLines'       ,          CurvedLines          );
          WriteInteger( sdfs, 'ControlMode'       , Integer( ControlMode         ));
          WriteInteger( sdfs, 'LightsRate'        ,          LRate                );
          WriteInteger( sdfs, 'SampleRate'        ,          Samplerate           );
          WriteInteger( sdfs, 'BufferSize'        ,          BufferSize           );
          WriteFloat  ( sdfs, 'ReferenceA'        ,          ReferenceA           );
          WriteFloat  ( sdfs, 'NotesPerOctave'    ,          NotesPerOctave       );
          WriteFloat  ( sdfs, 'MiddleNote'        ,          MiddleNote           );
          WriteInteger( sdfs, 'SelectedAPIID'     ,          FSelectedAPIID       );
          WriteInteger( sDfs, 'SelectedInput'     , Integer( FSelectedInputId    ));
          WriteInteger( sDfs, 'SelectedOutput'    , Integer( FSelectedOutputId   ));
          WriteInteger( sDfs, 'SelectedInputPA'   , Integer( FSelectedInputIdPA  ));
          WriteInteger( sDfs, 'SelectedOutputPA'  , Integer( FSelectedOutputIdPA ));
          WriteString ( sdfs, 'NetMidiServer'     ,          NetMidiServer        );
          WriteString ( sdfs, 'NetMidiPort'       ,          NetMidiPort          );
          WriteBool   ( sdfs, 'NetMidiAutoConnect',          NetMidiAutoConnect   );
          WriteBool   ( sdfs, 'LogMidi'           ,          LogMidi              );
          WriteBool   ( sdfs, 'LogMidiMsgs'       ,          LogMidiMsgs          );
          WriteBool   ( sdfs, 'CompilerDebug'     ,          CompilerDebug        );
          WriteBool   ( sdfs, 'WarnOnPatchChange' ,          WarnOnPatchChange    );
          WriteBool   ( sdfs, 'UseWheelOnKnobs'   ,          UseWheelOnKnobs      );
          WriteInteger( sdfs, 'WheelSensitivity'  ,          WheelSensitivity     );
          WriteBool   ( sdfs, 'UseUnFocus'        ,          UseUnFocus           );
          WriteBool   ( sdfs, 'UsePortAudio'      ,          UsePortAudio         );
          WriteBool   ( sdfs, 'ResetOnRender'     ,          ResetOnRender        );

          FRecentSourceFiles.MaxDepth := HistoryCount;
          FRecentSourceFiles.SaveToIni( anIniFile, 'RecentFiles');
        finally
          UpdateFile;
          Free;
        end;
      end;
    end;

    procedure   TFormModules.ShowHelp;
    var
      aHelpIndex : string;
      aModule    : TKnobsCustomModule;
      anURL      : string;
    begin
      aHelpIndex := '';
      if Assigned( EditorPatch)
      then begin
        aModule := EditorPatch.FindFirstSelectedModule;
        if Assigned( aModule)
        then aHelpIndex := Format( '#%d', [ aModule.ModuleType]);
      end;
      if MustMakeDocs
      then begin
        if MessageDlg(
          Format(
            'I need to make some folders and files for that inside my application folder:'^M^M'%s,'^M^M'is that okay?',
            [ ApplicationPath],
            AppLocale
          ),
          mtInformation,
          [ mbYes, mbNo],
          0
        ) = mrYes
        then MakeDocs( DocsPath);
      end;
      if FileExists( DocsPath + '\modules.html')
      then begin
        anURL := Format( '"file:///%s/modules.html%s"', [ DocsPath, aHelpIndex]);
        anURL := StringReplace( anURL, '\', '/', [ rfReplaceAll]);
        if not BrowseURL( anURL)
        then MessageDlg( 'could not open the docs in the default web browser ...', mtError, [ mbOK], 0);
      end
      else MessageDlg( 'could not create docs ...', mtError, [ mbOK], 0);
    end;

    function    TFormModules.MustMakeDocs: Boolean;
    begin
      if not FileExists( DocsPath + '\modules.html')
      then Result := True
      else begin
        if DirectoryExists( DocsPath + '\images')
        then begin
          if FileExists( Format( '%s\images\%s', [ DocsPath, GetFileVersion], AppLocale))
          then Result := False
          else Result := True;
        end
        else Result := True;
      end;
    end;

    procedure   TFormModules.MakeDocs( const aFolder : string);
    const
      Images = '\images';
    var
      aFileNames   : TStrings;
      aFileName    : string;
      aFile        : TextFile;
      aFileVersion : string;
      aVersion     : string;
    begin
      aFileVersion := GetFileVersion;

      if not DirectoryExists( aFolder)
      then begin
        ForceDirectories( aFolder);
      end;
      if not DirectoryExists( aFolder + Images)
      then begin
        ForceDirectories( aFolder + Images);
      end;

      aFileNames := GetFileNames( aFolder + Images, '*.*');
      if Assigned( aFileNames)
      then begin
        try
          for aFileName in aFileNames
          do DeleteFile( aFileName);
        finally
          aFileNames.Free;
        end;
      end;

      FormStore.Show;
      try
        FormStore.Document( aFolder, Images, aFileVersion);
      finally
        FormStore.Hide;
      end;

      aVersion := Format( '%s\%s\%s', [ aFolder, Images, aFileVersion], AppLocale);
      AssignFile( aFile, aVersion);
      Rewrite( aFile);
      try
        WriteLn( aFile, 'this file is for documentation version checking');
        WriteLn( aFile, aVersion);
        WriteLn( aFile, 'when the path above is not my actual position and name, just delete me please.');
      finally
        CloseFile( aFile);
      end;
    end;


//  private

    procedure   TFormModules.Log( const aMsg: string);
    begin
      MemoDebug.Lines.Add( Format( '%s %s', [ GetDebugTimeStr, aMsg], AppLocale));
    end;

    procedure   TFormModules.LogFmt( const aFmt: string; const anArgs: array of const);
    begin
      Log( Format( aFmt, anArgs, AppLocale));
    end;

    procedure   TFormModules.MidiLog( const aMsg: string);
    begin
      if LogMidi
      then LogFmt( 'NET MIDI %s', [ aMsg]);
    end;

    procedure   TFormModules.MidiLogFmt( const aFmt: string; const anArgs: array of const);
    begin
      MidiLog( Format( aFmt, anArgs));
    end;

    procedure   TFormModules.MidiMsgLog( const aMsg: string);
    begin
      if LogMidiMsgs
      then LogFmt( 'NET MIDI msg %s', [ aMsg]);
    end;

    procedure   TFormModules.MidiMsgLogFmt( const aFmt: string; const anArgs: array of const);
    begin
      MidiMsgLog( Format( aFmt, anArgs));
    end;

    procedure   TFormModules.ClearMemo;
    begin
      MemoDebug.Clear;
    end;

    procedure   TFormModules.ClearGraphs;
    var
      i : Integer;
    begin
      for i := 0 to Length( FChartSeries) - 1
      do FChartSeries[ i].Clear;
    end;

    procedure   TFormModules.BuildGraphs;
    const
      Colors : array[ 0 .. 3] of TColor = ( clRed, clBlue, clGreen, clPurple);
    var
      ChartCount : Integer;
      i          : Integer;
      aSeries    : TChartSeries;
    begin
      if UseGraph
      then begin
        // RemoveAllSeries does not work ... well, it frees them not ...
        while ChartDebug.SeriesList.Count > 0
        do begin
          aSeries := ChartDebug.SeriesList[ ChartDebug.SeriesList.Count - 1];
          ChartDebug.RemoveSeries( aSeries);
          aSeries.Free;
        end;
        if Assigned( FSynthPatch)
        then begin
          ChartCount := FSynthPatch.OutputCount;
          SetLength( FChartSeries, ChartCount);
          for i := 0 to ChartCount - 1
          do begin
            FChartSeries[ i]                := TFastLineSeries.Create( ChartDebug);
            FChartSeries[ i].Name           := Format( 'out_%d', [ i], AppLocale);
            FChartSeries[ i].Stairs         := GraphStairs;
            FChartSeries[ i].InvertedStairs := True;
            FChartSeries[ i].LinePen.Width  := 2;
            FChartSeries[ i].Active         := True;
            FChartSeries[ i].Visible        := True;
            if i < Length( Colors)
            then FChartSeries[ i].Color := Colors[ i];
            ChartDebug.AddSeries( FChartSeries[ i]);
          end;
        end;
      end;
    end;

    procedure   TFormModules.ShowPatch;
    var
      S : string;
    begin
      S := '';
      if Assigned( FSynthPatch)
      then FSynthPatch.Save( 0, S);
      if S = ''
      then Log( 'FSynthPatch not assigned, can not dump patch')
      else LogFmt( '%s', [ S]);
    end;

    procedure   TFormModules.ProfilePatch;
    var
      aProfile : TStringList;
      aPath    : string;
    begin
      if not HAS_PATCH_PROFILER
      then Exit;

      if Assigned( FSynthPatch)
      then begin
        aProfile := FSynthPatch.GetProfileHtml;
        if Assigned( aProfile)
        then begin
          try
            aPath := IncludeTrailingPathDelimiter( IncludeTrailingPathDelimiter( ApplicationPath) + 'data');
            if not DirectoryExists( aPath)
            then ForceDirectories( aPath);
            aProfile.SaveToFile( aPath + 'profile.html');
            if FileExists( aPath + 'profile.html')
            then begin
              ShellExecute(
                Handle,
                Nil,
                PChar( Format( 'file://%s', [ aPath + 'profile.html'])),
                Nil,
                Nil,
                SW_SHOWNORMAL
              );
            end
          finally
            FreeAndNil( aProfile);
          end;
        end;
      end
      else Log( 'No synth patch avaialable, can not profile');
    end;

    function   TFormModules.ChangeSynthPatch( const aSynthPatch: TSynthPatch): Boolean;
    var
      OldSynth : TSynthPatch;
    begin
      Result := False;
      if Assigned( aSynthPatch)
      then begin
        if not aSynthPatch.IsSamePatch( FSynthPatch) // Do not change the patch if it's 'the same' .. equivalent ...
        then begin
          EditorPatch.BlockScreenUpdates;
          try
            OldSynth := FSynthPatch;
            if Assigned( OldSynth)
            then OldSynth.OnSendMidi := nil;

            aSynthPatch.GatherLights( '', DoLights);
            aSynthPatch.GatherData  ( '', DoData  );
            aSynthPatch.GatherXYData( '', DoXYData);
            aSynthPatch.GatherInfo  ( '', DoInfo  );
            aSynthPatch.OnSendMidi := DoMidiSendMessage;
            aSynthPatch.FixZippers;

            PatchName := aSynthPatch.Name;

            FSynthPatch := aSynthPatch;
            EditorPatch.FixAllSynthParams;
            BuildGraphs;

            if Assigned( OldSynth)
            then FreeAndNil( OldSynth);

            Result := True;
          finally
            EditorPatch.UnblockScreenUpdates;
          end;
        end;
      end
      else PageControlMain.ActivePage := TabSheetDebug;
    end;

    procedure   TFormModules.ExecutePatch;
    begin
      if Assigned( FSynthPatch)
      then FSynthPatch.Tick;
      if not ( FAudioInRunning and FAudioOutRunning) and UseGraph
      then ChartOoutputs;
    end;

    procedure   TFormModules.ChartOutput( anIndex: Integer; aValue: TSignal);
    begin
      if Assigned( FSynthPatch)
      then begin
        if FChartSeries[ anIndex].Count > 409600
        then FChartSeries[ anIndex].Clear;
        FChartSeries[ anIndex].AddXY( SampleCountToTime( FSynthPatch.Samples) * 1000, anIndex + aValue); // in ms
      end;
    end;

    procedure   TFormModules.ChartOoutputs;
    var
      i : Integer;
    begin
      Assert( Assigned( FSynthPatch), 'FSynthPatch should be assigned here');
      for i := 0 to Length( FChartSeries) - 1
      do ChartOutput( i, Max( -256, Min( 256, FSynthPatch.Output[ i])))
    end;

    procedure   TFormModules.DebugRunStop;
    var
      i : Integer;
    begin
      if FAudioInRunning or FAudioOutRunning
      then Log( 'can not do a debug run while real time audio generation is on')
      else begin
        Assert( Assigned( FSynthPatch), 'FSynthPatch should be assigned here');
        if FDebugRunning
        then begin
          FTime                  := timeGetTime - FTime;
          FDebugRunning          := False;
          BitBtnDebugRun.Caption := 'debug Run';
          Log( 'DebugRun stopped');
        end
        else begin
          FSynthPatch.Reset;
          FDebugRunning          := True;
          BitBtnDebugRun.Caption := 'debug Stop';
          Log( 'DebugRun started');
          FTime                  := timeGetTime;
          while FDebugRunning and not ( FAudioInRunning or FAudioOutRunning)
          do begin
            Application.ProcessMessages;
            for i := 1 to 512
            do ExecutePatch;
          end;
          FDebugRunning := False;
          BitBtnDebugRun.Caption := 'debug Run';
        end;
      end;
    end;

    procedure   TFormModules.EnableDebugButtons( anEnable: Boolean);
    begin
      BitBtnDebugStep .Enabled := anEnable;
      BitBtnDebugRun  .Enabled := anEnable;
      BitBtnDebugReset.Enabled := anEnable;
    end;

    procedure   TFormModules.FixLocalWheelSettings;
    var
      i : Integer;
    begin
      for i := 0 to ComponentCount - 1
      do begin
        if Components[ i] is TKnobsKnob
        then begin
          TKnobsKnob( Components[ i]).WheelSupport     := UseWheelOnKnobs;
          TKnobsKnob( Components[ i]).WheelSensitivity := WheelSensitivity;
        end;
      end;
    end;

//   private

    procedure   TFormModules.DeZipper;
    begin
      FOutVolume1 := ( FOutShadow1 + FOutVolume1 * 1023) / 1024;
      FInVolume1  := ( FInShadow1  + FInVolume1  * 1023) / 1024;
      FOutVolume2 := ( FOutShadow2 + FOutVolume2 * 1023) / 1024;
      FInVolume2  := ( FInShadow2  + FInVolume2  * 1023) / 1024;
      FOutVolume3 := ( FOutShadow3 + FOutVolume3 * 1023) / 1024;
      FInVolume3  := ( FInShadow3  + FInVolume3  * 1023) / 1024;
      FOutVolume4 := ( FOutShadow4 + FOutVolume4 * 1023) / 1024;
      FInVolume4  := ( FInShadow4  + FInVolume4  * 1023) / 1024;
    end;

    procedure   TFormModules.UpdateLights;
    begin
      FUpdateCounter := ( FUpdateCounter + 1) mod 2;
      if Assigned( FSynthPatch)
      then begin
        case FUpdateCounter of
          0 : FSynthPatch.GatherLights( '', DoLights);
          1 : begin
              FSynthPatch.GatherData  ( '', DoData  );
              FSynthPatch.GatherXYData( '', DoXYData);
              FSynthPatch.GatherInfo  ( '', DoInfo  );
            end;
        end;
      end;

      IndicatorBarVolumeOutLeft1 .Value := RangeMap( Clip( FdBOut1, -100, 20), -100, 20, 0, 24);
      IndicatorBarVolumeOutRight1.Value := RangeMap( Clip( FdBOut2, -100, 20), -100, 20, 0, 24);
      IndicatorBarVolumeInLeft1  .Value := RangeMap( Clip( FDbIn1 , -100, 20), -100, 20, 0, 24);
      IndicatorBarVolumeInRight1 .Value := RangeMap( Clip( FdBIn2 , -100, 20), -100, 20, 0, 24);
      IndicatorBarVolumeOutLeft2 .Value := RangeMap( Clip( FdBOut3, -100, 20), -100, 20, 0, 24);
      IndicatorBarVolumeOutRight2.Value := RangeMap( Clip( FdBOut4, -100, 20), -100, 20, 0, 24);
      IndicatorBarVolumeInLeft2  .Value := RangeMap( Clip( FDbIn3 , -100, 20), -100, 20, 0, 24);
      IndicatorBarVolumeInRight2 .Value := RangeMap( Clip( FdBIn4 , -100, 20), -100, 20, 0, 24);
      IndicatorBarVolumeOutLeft3 .Value := RangeMap( Clip( FdBOut5, -100, 20), -100, 20, 0, 24);
      IndicatorBarVolumeOutRight3.Value := RangeMap( Clip( FdBOut6, -100, 20), -100, 20, 0, 24);
      IndicatorBarVolumeInLeft3  .Value := RangeMap( Clip( FDbIn5 , -100, 20), -100, 20, 0, 24);
      IndicatorBarVolumeInRight3 .Value := RangeMap( Clip( FdBIn6 , -100, 20), -100, 20, 0, 24);
      IndicatorBarVolumeOutLeft4 .Value := RangeMap( Clip( FdBOut7, -100, 20), -100, 20, 0, 24);
      IndicatorBarVolumeOutRight4.Value := RangeMap( Clip( FdBOut8, -100, 20), -100, 20, 0, 24);
      IndicatorBarVolumeInLeft4  .Value := RangeMap( Clip( FDbIn7 , -100, 20), -100, 20, 0, 24);
      IndicatorBarVolumeInRight4 .Value := RangeMap( Clip( FdBIn8 , -100, 20), -100, 20, 0, 24);

      ShowOverUnderFlows;
    end;


    function    TFormModules.HandleAudioInOnBufferFilled( aBuffer: pAnsiChar; var aSize: Integer): Boolean;
    // Handle legacy audio input and drive the local dezippers
    var
      i            : Integer;
      aSampleCount : Integer;
      aLeft        : TSignal;
      aRight       : TSignal;
      aMaxLeft     : TSignal;
      aMaxRight    : TSignal;
      adB          : TSignal;
    begin
      Result := False;
      try
        aSampleCount := aSize div 4; // 16 bit samples and two channels, so 4 times a byte
        {$Q-R-}Inc( FIOBalance);{$Q+R+}
        aMaxLeft  := 0;
        aMaxRight := 0;

        if Assigned( FSynthPatch)
        then begin
          for i := 0 to aSampleCount - 1
          do begin
            DeZipper;
            aLeft     := FInVolume1 * SampleToUnits( PSamples( aBuffer)[ 2 * i + 0]);
            aRight    := FInVolume1 * SampleToUnits( PSamples( aBuffer)[ 2 * i + 1]);
            aMaxLeft  := Max( aMaxLeft , Abs( aLeft ));
            aMaxRight := Max( aMaxRight, Abs( aRight));
            FSynthPatch.AcceptSamplePair1( aLeft, aRight);
          end;
        end;

        FdBIn1 := SignalTodB( aMaxLeft );
        FdBIn2 := SignalTodB( aMaxRight);
        adB    := Max( FdBIn1, FdBIn2);
        if adB > FdBInMax1
        then FdBInMax1 := adB
        else FdBInMax1 := ( 199 * FdBInMax1 + adB) / 200;
        if adB > FdBInMaxMax1
        then FdBInMaxMax1 := adB;
        if adB < FdBInMaxMin1
        then FdBInMaxMin1 := adB;

        Result := True;
      except
        on E: Exception
        do begin
          StopAudioIn;
          StopAudioOut;
          LogFmt( 'Execution error: ''%s'', synth engine was stopped.', [ E.Message]);
        end;
      end;
    end;


    function    TFormModules.HandleAudioOutOnFillBuffer( aBuffer: pAnsiChar; var aSize: Integer): Boolean;
    // Collect legacy audio output from synth and send it to the output device
    // Drive the synth, an output channel must always be active
    var
      i             : Integer;
      aLeft         : TSignal;
      aRight        : TSignal;
      aSampleCount  : Integer;
      aMaxLeft      : TSignal;
      aMaxRight     : TSignal;
      adB           : TSignal;
    begin
      Result := False;
      try
        aSampleCount := aSize div 4; // 16 bit samples and two channels, so 4 times a byte
        {$Q-R-}Dec( FIOBalance);{$Q+R+}
        aMaxLeft  := 0;
        aMaxRight := 0;

        if Assigned( FSynthPatch)
        then begin
          for i := 0 to aSampleCount - 1
          do begin
            with FSynthPatch
            do begin
              Tick;
              aLeft  := FOutVolume1 * Output[ 0];
              aRight := FOutVolume1 * Output[ 1];
            end;
            PSamples( aBuffer)[ 2 * i + 0] := SignalToSample( aLeft );
            PSamples( aBuffer)[ 2 * i + 1] := SignalToSample( aRight);
            aMaxLeft  := Max( aMaxLeft , Abs( aLeft ));
            aMaxRight := Max( aMaxRight, Abs( aRight));
          end;
        end
        else begin
          for i := 0 to aSampleCount - 1
          do begin
            PSamples( aBuffer)[ 2 * i + 0] := 0;
            PSamples( aBuffer)[ 2 * i + 1] := 0;
          end;
        end;

        FdBOut1 := SignalTodB( aMaxLeft );
        FdBOut2 := SignalTodB( aMaxRight);
        adB     := Max( FdBOut1, FdBOut2);
        if adB > FdBOutMax1
        then FdBOutMax1 := adB
        else FdBOutMax1 := ( 199 * FdBOutMax1 + adB) / 200;
        if adB > FdBOutMaxMax1
        then FdBOutMaxMax1 := adB;
        if adB < FdBOutMaxMin1
        then FdBOutMaxMin1 := adB;

        Result := True;
      except
        on E: Exception
        do begin
          StopAudioIn;
          StopAudioOut;
          LogFmt( 'Execution error: ''%s'', synth engine was stopped.', [ E.Message]);
        end;
      end;
    end;

    procedure   TFormModules.HandleAudioInOnStart( aSender: TObject);
    begin
      Log( 'legacy audio in was started');
      FAudioInRunning := True;
      EnableDebugButtons( not FAudioOutRunning);
      UpdateCaptions;
    end;

    procedure   TFormModules.HandleAudioInOnStop( aSender: TObject);
    begin
      Log( 'legacy audio in was stopped');
      FAudioInRunning := False;
      EnableDebugButtons( not FAudioOutRunning);
      UpdateCaptions;
    end;

    procedure   TFormModules.HandleAudioOutOnStart( aSender: TObject);
    begin
      Log( 'legacy audio out was started');
      FAudioOutRunning := True;
      EnableDebugButtons( not FAudioOutRunning);
      UpdateCaptions;
    end;

    procedure   TFormModules.HandleAudioOutOnStop( aSender: TObject);
    begin
      Log( 'legacy audio out was stopped');
      FAudioOutRunning := False;
      EnableDebugButtons( not FAudioOutRunning);
      UpdateCaptions;
    end;

    function    TFormModules.HandleAudioInOnBufferFilledPA( anInput, anOutput: Pointer; aFrameCount: culong; aTimeInfo: PPaStreamCallbackTimeInfo; aStatusFlags: TPaStreamCallbackFlags; UserData: Pointer): cint;
    // Handle PortAudio audio input and drive the local dezippers
    const
      MaxChannels = 8;
    var
      i         : Integer;
      j         : Integer;
      Values    : array[ 0 .. MaxChannels       - 1] of TSignal;
      Maxima    : array[ 0 .. MaxChannels       - 1] of TSignal;
      Volumes   : array[ 0 .. MaxChannels div 2 - 1] of TSignal;
      adB1      : TSignal;
      adB2      : TSignal;
      adB3      : TSignal;
      adB4      : TSignal;
      ChCount   : Integer;
    begin
      try
        {$Q-R-}Inc( FIOBalance);{$Q+R+}
        for j := 0 to MaxChannels - 1
        do Maxima[ j] := 0;

        Volumes[ 0] := FInVolume1;
        Volumes[ 1] := FInVolume2;
        Volumes[ 2] := FInVolume3;
        Volumes[ 3] := FInVolume4;

        if Assigned( FSynthPatch)
        then begin
          ChCount := FPaOutstreamParameters.channelCount;
          for i := 0 to aFrameCount - 1
          do begin
            DeZipper;

            for j := 0 to ChCount - 1
            do Values[ j] := Volumes[ j div 2] * SampleToUnits( PSamples( anInput)[ ChCount * i + j]);
            for j := ChCount to MaxChannels - 1
            do Values[ j] := 0;
            for j := 0 to MaxChannels - 1
            do Maxima[ j] := Max( Maxima[ j], Abs( Values[ j]));

            FSynthPatch.AcceptSamplePair1( Values[ 0], Values[ 1]);
            FSynthPatch.AcceptSamplePair2( Values[ 2], Values[ 3]);
            FSynthPatch.AcceptSamplePair3( Values[ 4], Values[ 5]);
            FSynthPatch.AcceptSamplePair4( Values[ 6], Values[ 7]);
          end;
        end;

        FdBIn1 := SignalTodB( Maxima[ 0]);
        FdBIn2 := SignalTodB( Maxima[ 1]);
        FdBIn3 := SignalTodB( Maxima[ 2]);
        FdBIn4 := SignalTodB( Maxima[ 3]);
        FdBIn5 := SignalTodB( Maxima[ 4]);
        FdBIn6 := SignalTodB( Maxima[ 5]);
        FdBIn7 := SignalTodB( Maxima[ 6]);
        FdBIn8 := SignalTodB( Maxima[ 7]);

        adB1 := Max( FdBIn1, FdBIn2);
        if adB1 > FdBInMax1    then FdBInMax1    := adB1 else FdBInMax1 := ( 199 * FdBInMax1 + adB1) / 200;
        if adB1 > FdBInMaxMax1 then FdBInMaxMax1 := adB1;
        if adB1 < FdBInMaxMin1 then FdBInMaxMin1 := adB1;

        adB2 := Max( FdBIn3, FdBIn4);
        if adB2 > FdBInMax2    then FdBInMax2    := adB2 else FdBInMax2 := ( 199 * FdBInMax2 + adB2) / 200;
        if adB2 > FdBInMaxMax2 then FdBInMaxMax2 := adB2;
        if adB2 < FdBInMaxMin2 then FdBInMaxMin2 := adB2;

        adB3 := Max( FdBIn5, FdBIn6);
        if adB3 > FdBInMax3    then FdBInMax3    := adB3 else FdBInMax3 := ( 199 * FdBInMax3 + adB3) / 200;
        if adB3 > FdBInMaxMax3 then FdBInMaxMax3 := adB3;
        if adB3 < FdBInMaxMin3 then FdBInMaxMin3 := adB3;

        adB4 := Max( FdBIn7, FdBIn8);
        if adB4 > FdBInMax4    then FdBInMax4    := adB4 else FdBInMax4 := ( 199 * FdBInMax4 + adB4) / 200;
        if adB4 > FdBInMaxMax4 then FdBInMaxMax4 := adB4;
        if adB4 < FdBInMaxMin4 then FdBInMaxMin4 := adB4;

        {$Q-R-}
        if aStatusFlags and paInputUnderflow  <> 0 then Inc( FPaInUnderflows );
        if aStatusFlags and paInputOverflow   <> 0 then Inc( FPaInoverflows  );
        if aStatusFlags and paOutputUnderflow <> 0 then Inc( FPaOutUnderflows);
        if aStatusFlags and paOutputOverflow  <> 0 then Inc( FPaOutoverflows );
        {$Q+R+}

        Result := paContinue;
      except
        on E: Exception
        do begin
          Result := paAbort;
          LogFmt( 'Execution error: ''%s'', synth engine was stopped.', [ E.Message]);
        end;
      end;
    end;

    function    TFormModules.HandleAudioOutOnFillBufferPA( anInput, anOutput: Pointer; aFrameCount: culong; aTimeInfo: PPaStreamCallbackTimeInfo; aStatusFlags: TPaStreamCallbackFlags; UserData: Pointer): cint;
    // Collect PortAudio audio output from synth and send it to the output device
    // Drive the synth, an output channel must always be active
    const
      MaxChannels = 8;
    var
      i         : Integer;
      j         : Integer;
      Values    : array[ 0 .. MaxChannels - 1] of TSignal;
      Maxima    : array[ 0 .. MaxChannels - 1] of TSignal;
      adB1      : TSignal;
      adB2      : TSignal;
      adB3      : TSignal;
      adB4      : TSignal;
      ChCount   : Integer;
    begin
      try
        {$Q-R-}Dec( FIOBalance);{$Q+R+}
        for j := 0 to MaxChannels - 1
        do Maxima[ j] := 0;

        ChCount := FPaOutstreamParameters.channelCount;

        if Assigned( FSynthPatch)
        then begin
          for i := 0 to aFrameCount - 1
          do begin
            with FSynthPatch
            do begin
              Tick;
              Values[ 0] := FOutVolume1 * Output[ 0];
              Values[ 1] := FOutVolume1 * Output[ 1];
              Values[ 2] := FOutVolume2 * Output[ 2];
              Values[ 3] := FOutVolume2 * Output[ 3];
              Values[ 4] := FOutVolume3 * Output[ 4];
              Values[ 5] := FOutVolume3 * Output[ 5];
              Values[ 6] := FOutVolume4 * Output[ 6];
              Values[ 7] := FOutVolume4 * Output[ 7];

              for j := 0 to ChCount - 1
              do begin
                PSamples( anOutput)[ ChCount * i + j] := SignalToSample( Values[ j]);
                Maxima[ j] := Max( Maxima[ j] , Abs( Values[ j]));
              end;
              for j := ChCount to MaxChannels - 1
              do Maxima[ j] := Max( Maxima[ j] , Abs( Values[ j]));
            end;
          end;
        end
        else begin
          for i := 0 to aFrameCount - 1
          do begin
            for j := 0 to MaxChannels - 1
            do PSamples( anOutput)[ ChCount * i + j] := 0;
          end;
        end;

        FdBOut1 := SignalTodB( Maxima[ 0]);
        FdBOut2 := SignalTodB( Maxima[ 1]);
        FdBOut3 := SignalTodB( Maxima[ 2]);
        FdBOut4 := SignalTodB( Maxima[ 3]);
        FdBOut5 := SignalTodB( Maxima[ 4]);
        FdBOut6 := SignalTodB( Maxima[ 5]);
        FdBOut7 := SignalTodB( Maxima[ 6]);
        FdBOut8 := SignalTodB( Maxima[ 7]);

        adB1 := Max( FdBOut1, FdBOut2);
        if adB1 > FdBOutMax1    then FdBOutMax1    := adB1 else FdBOutMax1 := ( 199 * FdBOutMax1 + adB1) / 200;
        if adB1 > FdBOutMaxMax1 then FdBOutMaxMax1 := adB1;
        if adB1 < FdBOutMaxMin1 then FdBOutMaxMin1 := adB1;

        adB2 := Max( FdBOut3, FdBOut4);
        if adB2 > FdBOutMax2    then FdBOutMax2    := adB2 else FdBOutMax2 := ( 199 * FdBOutMax2 + adB2) / 200;
        if adB2 > FdBOutMaxMax2 then FdBOutMaxMax2 := adB2;
        if adB2 < FdBOutMaxMin2 then FdBOutMaxMin2 := adB2;

        adB3 := Max( FdBOut5, FdBOut6);
        if adB3 > FdBOutMax3    then FdBOutMax3    := adB3 else FdBOutMax3 := ( 199 * FdBOutMax3 + adB3) / 200;
        if adB3 > FdBOutMaxMax3 then FdBOutMaxMax3 := adB3;
        if adB3 < FdBOutMaxMin3 then FdBOutMaxMin3 := adB3;

        adB4 := Max( FdBOut7, FdBOut8);
        if adB4 > FdBOutMax4    then FdBOutMax4    := adB4 else FdBOutMax4 := ( 199 * FdBOutMax4 + adB4) / 200;
        if adB4 > FdBOutMaxMax4 then FdBOutMaxMax4 := adB4;
        if adB4 < FdBOutMaxMin4 then FdBOutMaxMin4 := adB4;

        Result := paContinue;
      except
        on E: Exception
        do begin
          Result := paAbort;
          LogFmt( 'Execution error: ''%s'', synth engine was stopped.', [ E.Message]);
        end;
      end;
    end;

    procedure   TFormModules.HandleAudioOnStartPA( userdata: Pointer);
    begin
      Log( 'port audio was started');
      FAudioInRunning  := True;
      FAudioOutRunning := True;
      EnableDebugButtons( False);
      UpdateCaptions;
    end;

    procedure   TFormModules.HandleAudioOnStopPA( userdata: Pointer);
    begin
   // Log( 'port audio was stopped');     -- can not be called from a port audio callback apparently
      FAudioInRunning  := False;
      FAudioOutRunning := False;
   // EnableDebugButtons( True);          -- can not be called from a port audio callback apparently - and there seems to be no need to
   // UpdateCaptions;                     -- can not be called from a port audio callback apparently - and there seems to be no need to
    end;

    procedure   TFormModules.CreateDevices;
    begin
      if FBufferSize = 0
      then FBufferSize := 8192;

      if FPortAudioSelected
      then begin
        Log(    'creating  port audio device');
        with FPaInstreamParameters
        do begin
          device                    := FormWaveDeviceSelect.PaInputDeviceIDs[ FSelectedInputIdPA];
          channelCount              := Min( 8, FormWaveDeviceSelect.PaInputDevices[ FSelectedInputIdPA].maxInputChannels);
          sampleFormat              := paInt16;
          suggestedLatency          := FormWaveDeviceSelect.PaInputDevices[ FSelectedInputIdPA].defaultLowInputLatency;
          hostApiSpecificStreamInfo := nil;
          if FormWaveDeviceSelect.PaHostApis[ FormWaveDeviceSelect.PaInputDevices[ FSelectedInputIdPA].hostApi]._type = paASIO
          then PaAsio_GetAvailableBufferSizes( FPaInstreamParameters.device, FPaAsioMinFrames, FPaAsioMaxFrames, FPaAsioPrefFrames, FPaAsioGranFrames)
          else begin
            FPaAsioMinFrames  := 0;
            FPaAsioMaxFrames  := 0;
            FPaAsioPrefFrames := 0;
            FPaAsioGranFrames := 0;
          end;
        end;
        with FPaOutstreamParameters
        do begin
          device                    := FormWaveDeviceSelect.PaOutputDeviceIDs[ FSelectedOutputIdPA];
          channelCount              := Min( 8, FormWaveDeviceSelect.PaOutputDevices[ FSelectedOutputIdPA].maxOutputChannels);
          sampleFormat              := paInt16;
          suggestedLatency          := FormWaveDeviceSelect.PaOutputDevices[ FSelectedOutputIdPA].defaultLowOutputLatency;
          hostApiSpecificStreamInfo := nil;
          if FormWaveDeviceSelect.PaHostApis[ FormWaveDeviceSelect.PaOutputDevices[ FSelectedOutputIdPA].hostApi]._type = paASIO
          then PaAsio_GetAvailableBufferSizes( FPaOutstreamParameters.device, FPaAsioMinFrames, FPaAsioMaxFrames, FPaAsioPrefFrames, FPaAsioGranFrames)
          else begin
            FPaAsioMinFrames  := 0;
            FPaAsioMaxFrames  := 0;
            FPaAsioPrefFrames := 0;
            FPaAsioGranFrames := 0;
          end;
        end;
      end
      else begin
        Log(    'creating  legacy audio devices');
        FAudioOut := TAudioOut.Create( Self);
        FAudioIn  := TAudioIn .Create( Self);

        FAudioOut.BufferSize :=  BufferSize;
        FAudioOut.NumBuffers :=           4;
        FAudioOut.FrameRate  := System_Rate;
        FAudioOut.Stereo     :=        True;

        FAudioIn .BufferSize :=  BufferSize;
        FAudioIn .NumBuffers :=           4;
        FAudioIn .FrameRate  := System_Rate;
        FAudioIn .Stereo     :=        True;
      end;

      HookDevices;
    end;

    procedure   TFormModules.FreeDevices;
    begin
      StopAudioIn;
      StopAudioOut;
      UnhookDevices;
      if FPortAudioSelected
      then begin
        Log(    'freeing   port audio device');
        FPaStream := nil;
      end
      else begin
        Log(    'freeing   legacy audio devices');
        FAudioIn .Free;
        FAudioOut.Free;
      end;
    end;

    procedure   TFormModules.HookDevices;
    begin
      if not FPortAudioSelected
      then begin
        Log(    'hooking   legacy audio devices');
        FAudioIn .OnBufferFilled := HandleAudioInOnBufferFilled;
        FAudioIn .OnStart        := HandleAudioInOnStart;
        FAudioIn .OnStop         := HandleAudioInOnStop;

        FAudioOut.OnFillBuffer   := HandleAudioOutOnFillBuffer;
        FAudioOut.OnStart        := HandleAudioOutOnStart;
        FAudioOut.OnStop         := HandleAudioOutOnStop;
      end;
    end;

    procedure   TFormModules.UnhookDevices;
    begin
      if not FPortAudioSelected
      then begin
        Log(    'unhooking legacy audio devices');
        FAudioIn .OnBufferFilled := nil;
        FAudioIn .OnStart        := nil;
        FAudioIn .OnStop         := nil;

        FAudioOut.OnFillBuffer   := nil;
        FAudioOut.OnStart        := nil;
        FAudioOut.OnStop         := nil;
      end;
    end;

    procedure   TFormModules.StopAudioIn;
    begin
      if FPortAudioSelected
      then begin
        LogFmt( 'stopping  port audio for current patch "%s"', [ PatchName]);
        if Assigned( FPaStream)
        then begin
          if FAudioInRunning
          then Pa_StopStream( FPaStream);
          Pa_CloseStream( FPaStream);
        end;
        FPaStream := nil;
      end
      else begin
        LogFmt( 'stopping  legacy audio in  for current patch "%s"', [ PatchName]);
        FAudioIn.StopGracefully;
      end;
      ClearVolumeIndicators;
      UpdateCaptions;
    end;

    procedure   TFormModules.StopAudioOut;
    begin
      FOutVolume1 := 0;
   // FOutShadow1 := 0;
      if not FPortAudioSelected
      then begin
        LogFmt( 'stopping  legacy audio out for current patch "%s"', [ PatchName]);
        FAudioOut.StopGracefully;
      end;
      ClearVolumeIndicators;
      UpdateCaptions;
    end;

    procedure   TFormModules.StartAudioIn;
    var
      BufSize : Integer;
      anError : TPaError;
    begin
      if FPortAudioSelected
      then begin
        try
          if FPaAsioPrefFrames <> 0
          then BufSize := FPaAsioPrefFrames
          else BufSize := BufferSize;

          LogFmt(
            'starting  port audio [api: "%s", in: "%s" ch: %d, out: "%s" ch: %d] for current patch "%s" at %f ks/s with buffer size %d frames',
            [
              FormWaveDeviceSelect.SelectedAPI,
              FormWaveDeviceSelect.SelectedInputPA,
              FPaInstreamParameters.channelCount,
              FormWaveDeviceSelect.SelectedOutputPA,
              FPaOutstreamParameters.channelCount,
              PatchName,
              System_Rate / 1000,
              BufSize
            ]
          );

          anError := Pa_OpenStream( FPaStream, @ FPaInstreamParameters, @ FPaOutstreamParameters, System_Rate, BufSize, paNoFlag, @ GHandleAudioOnBufferFilledPA, nil);
          if anError = paNoError
          then begin
            anError := Pa_SetStreamFinishedCallback( FPaStream, @ GHandleAudioOnStopPA);
            if anError = paNoError
            then begin
              anError := Pa_StartStream( FPaStream);
              if anError = paNoError
              then HandleAudioOnStartPA( nil)
              else begin
                LogFmt( 'error starting port audio stream: %s', [ string( Pa_GetErrorText( anError))]);
             // FPaStream := nil;
              end;
            end
            else begin
              LogFmt( 'error opening port audio stream finished callback: %s', [ string( Pa_GetErrorText( anError))]);
           // FPaStream := nil;
            end;
          end
          else begin
            LogFmt( 'error opening port audio stream: %s', [ string( Pa_GetErrorText( anError))]);
            FPaStream := nil;
          end;
        except
          on e : Exception
          do LogFmt( 'exception on opening port audio stream: "%s"', [ e.Message]);
        end;
      end
      else begin
        FAudioIn.StopAtOnce;
        LogFmt( 'starting  legacy audio in  for current patch "%s"', [ PatchName]);
        FAudioIn.WaveDevice := FSelectedInputId;
        FAudioIn.Start;
      end;
      ClearVolumeIndicators;
      UpdateCaptions;
      FIOBalance       := 0;
      FPaInUnderflows  := 0;
      FPaInoverflows   := 0;
      FPaOutUnderflows := 0;
      FPaOutoverflows  := 0;
    end;

    procedure   TFormModules.StartAudioOut;
    begin
      if Assigned( FSynthPatch)
      then FSynthPatch.FixZippers;
      FOutShadow1 := knob_outputlevel1.AsValue;
      if not FPortAudioSelected
      then begin
        FAudioOut.StopAtOnce;
        LogFmt( 'starting  legacy audio out for current patch "%s"', [ PatchName]);
        FAudioOut.WaveDevice := FSelectedOutputId;
        FAudioOut.Start;
      end;
      ClearVolumeIndicators;
      UpdateCaptions;
      FIOBalance       := 0;
      FPaInUnderflows  := 0;
      FPaInoverflows   := 0;
      FPaOutUnderflows := 0;
      FPaOutoverflows  := 0;
      if not RenderToFile
      then ResetRunTime;
    end;

    procedure   TFormModules.StartStopAudioIo;
    begin
      if FAudioOutRunning
      then begin
        StopAudioIn;
        StopAudioOut;
      end
      else begin
        StartAudioIn;
        StartAudioOut;
      end;
    end;

    procedure   TFormModules.VerifyDevices;
    begin
      FormWaveDeviceSelect.AllowPortAudio     := UsePortAudio;
      FormWaveDeviceSelect.SelectedAPIID      := FSelectedAPIID;
      FormWaveDeviceSelect.SelectedInputId    := FSelectedInputId;
      FormWaveDeviceSelect.SelectedOutputId   := FSelectedOutputId;
      FormWaveDeviceSelect.SelectedInputIdPA  := FSelectedInputIdPA;
      FormWaveDeviceSelect.SelectedOutputIdPA := FSelectedOutputIdPA;
      FormWaveDeviceSelect.BufferSize         := FBufferSize;
      SelectDevices;
    end;

    procedure   TFormModules.SelectDevices;
    var
      WasRunning   : Boolean;
      WasPortAudio : Boolean;
      IsPortAudio  : Boolean;
    begin
      WasRunning := FAudioInRunning or FAudioOutRunning;

      StopAudioIn;
      StopAudioOut;

      WasPortAudio         := FPortAudioSelected;
      IsPortAudio          := FormWaveDeviceSelect.UsePortAudio and UsePortAudio;
      FSelectedAPIID       := FormWaveDeviceSelect.SelectedAPIID;
      FSelectedInputId     := FormWaveDeviceSelect.SelectedInputId;
      FSelectedOutputId    := FormWaveDeviceSelect.SelectedOutputId;
      FSelectedInputIdPA   := FormWaveDeviceSelect.SelectedInputIdPA;
      FSelectedOutputIdPA  := FormWaveDeviceSelect.SelectedOutputIdPA;
      FBufferSize          := FormWaveDeviceSelect.BufferSize;

      if IsPortAudio <> WasPortAudio
      then begin
        FreeDevices;
        FPortAudioSelected := IsPortAudio;
        CreateDevices;
      end;

      if WasRunning
      then begin
        StartAudioIn;
        StartAudioOut;
      end;
    end;

    procedure   TFormModules.ClearVolumeIndicators;
    begin
      IndicatorBarVolumeInLeft1  .Value := 0.0;
      IndicatorBarVolumeInRight1 .Value := 0.0;
      IndicatorBarVolumeOutLeft1 .Value := 0.0;
      IndicatorBarVolumeOutRight1.Value := 0.0;
      IndicatorBarVolumeInLeft2  .Value := 0.0;
      IndicatorBarVolumeInRight2 .Value := 0.0;
      IndicatorBarVolumeOutLeft2 .Value := 0.0;
      IndicatorBarVolumeOutRight2.Value := 0.0;
      IndicatorBarVolumeInLeft3  .Value := 0.0;
      IndicatorBarVolumeInRight3 .Value := 0.0;
      IndicatorBarVolumeOutLeft3 .Value := 0.0;
      IndicatorBarVolumeOutRight3.Value := 0.0;
      IndicatorBarVolumeInLeft4  .Value := 0.0;
      IndicatorBarVolumeInRight4 .Value := 0.0;
      IndicatorBarVolumeOutLeft4 .Value := 0.0;
      IndicatorBarVolumeOutRight4.Value := 0.0;
      ResetPeaks;
    end;

    procedure   TFormModules.ShowOverUnderFlows;
    var
      Underflows : Integer;
      Overflows  : Integer;
    begin
      Underflows := FPaInUnderflows + FPaOutUnderflows;
      Overflows  := FPaInoverflows  + FPaOutoverflows;
      if Assigned( FSynthPatch)
      then begin
        Underflows := Underflows + FSynthPatch.Underflows;
        Overflows  := Overflows  + FSynthPatch.Overflows;
      end;
      LabelUnderflows.Caption := Format( 'underflows: %d', [ Underflows], AppLocale);
      LabelOverflows .Caption := Format( 'overflows: %d' , [ Overflows ], AppLocale);
    end;

    procedure   TFormModules.ShowRunTime;
    var
      Delta : TDateTime;
    begin
      Delta := Now - FStartTime;
      LabelRunTime.Caption := Format( FormatDateTime( '"D %.2d":hh:mm:ss', Delta), [ Floor( Delta)], AppLocale);
      LabelRunTime.Hint    := 'Current run time for the program, click to reset';
    end;

    procedure   TFormModules.ResetRuntime;
    begin
      FStartTime := Now;
      ShowRunTime;
    end;

    procedure   TFormModules.ConnectorDelete( const aConnector: TKnobsConnector);
    begin
      if Assigned( EditorPatch)
      then EditorPatch.ConnectorDelete( aConnector);
    end;

    procedure   TFormModules.ConnectorBreak( const aConnector: TKnobsConnector);
    begin
      if Assigned( EditorPatch)
      then EditorPatch.ConnectorBreak( aConnector);
    end;

    procedure   TFormModules.ConnectorDisconnect( const aConnector: TKnobsConnector);
    begin
      if Assigned( EditorPatch)
      then EditorPatch.ConnectorDisconnect( aConnector);
    end;

    procedure   TFormModules.ModuleCut( const aModule: TKnobsModule);
    begin
      if Assigned( EditorPatch) and Assigned( aModule)
      then begin
        aModule.FixSelection;
        CutModules;
      end;
    end;

    procedure   TFormModules.ModuleCopy( const aModule: TKnobsModule);
    begin
      if Assigned( EditorPatch) and Assigned( aModule)
      then begin
        aModule.FixSelection;
        CopyModules;
      end;
    end;

    procedure   TFormModules.ModuleDelete( const aModule: TKnobsModule);
    begin
      if Assigned( EditorPatch) and Assigned( aModule)
      then begin
        aModule.FixSelection;
        DeleteModules;
      end;
    end;

    procedure   TFormModules.ChangeModuleColor( const aModule: TKnobsModule);
    begin
      if Assigned( EditorPatch) and Assigned( aModule)
      then begin
        aModule.FixSelection;
        with ColorDialogModule
        do begin
          Color := aModule.Color;
          if Execute
          then EditorPatch.SetSelectedModuleColor( Color);
        end;
      end;
    end;

    procedure   TFormModules.KnobSetDefaultValue( const aValuedControl: TKnobsValuedControl);
    begin
      if Assigned( aValuedControl)
      then aValuedControl.SetDefault;
    end;

    procedure   TFormModules.KnobChangeLock( const aKnob: TKnobsKnob);
    begin
      if Assigned( aKnob)
      then aKnob.Locked := not aKnob.Locked;
    end;

//  private

    procedure   TFormModules.SetWireThickness( aValue: Integer);
    begin
      if aValue <> FWireThickness
      then begin
        FWireThickness := aValue;
        if Assigned( EditorPatch)
        then EditorPatch.WireThickness := aValue;
      end;
    end;

    procedure   TFormModules.SetCurvedLines( aValue: Boolean);
    begin
      if aValue <> FCurvedLines
      then begin
        FCurvedLines := aValue;
        if Assigned( EditorPatch)
        then EditorPatch.CurvedLines := aValue;
        CheckBoxCurvedLines.Checked  := aValue;
      end;
    end;

    procedure   TFormModules.SetControlMode( aValue: TDistanceMode);
    begin
      if aValue <> FControlMode
      then begin
        FControlMode := aValue;
        if Assigned( EditorPatch)
        then EditorPatch.ControlMode := FControlMode;
        RadioGroupControlMode.ItemIndex := Integer( FControlMode);
      end;
    end;

    procedure   TFormModules.SetLightsRate( aValue: TSignal);
    begin
      aValue := UnitsToLfoFastFrequency( aValue);
      PClip( aValue, 0.254, 401.8);
      if ( aValue <> FLightsRate) and Assigned( TimerLightsUpdate)
      then begin
        FLightsRate := aValue;
        TimerLightsUpdate.Interval := Round( 1000 / aValue);
      end;
    end;

    function    TFormModules.GetReferenceA: TSignal;
    begin
      Result := KnobsConversions.ReferenceA;
    end;

    procedure   TFormModules.SetReferenceA( aValue: TSignal);
    begin
      if aValue <> KnobsConversions.ReferenceA
      then begin
        KnobsConversions.ReferenceA := aValue;
        EditReferenceA.Text := Format( '%.3f', [ aValue], AppLocale);
      end;
    end;

    function    TFormModules.GetNotesPerOctave: TSignal;
    begin
      Result := KnobsConversions.NotesPerOctave;
    end;

    procedure   TFormModules.SetNotesPerOctave( aValue: TSignal);
    begin
      if aValue <> KnobsConversions.NotesPerOctave
      then begin
        KnobsConversions.NotesPerOctave := aValue;
        EditNotesPerOctave.Text := Format( '%.3f', [ aValue], AppLocale);
      end;
    end;

    function    TFormModules.GetMiddleNote: TSignal;
    begin
      Result := KnobsConversions.MiddleNote;
    end;

    procedure   TFormModules.SetMiddleNote( aValue: TSignal);
    begin
      if aValue <> KnobsConversions.MiddleNote
      then begin
        KnobsConversions.MiddleNote := aValue;
        EditMiddleNote.Text := Format( '%.3f', [ aValue], AppLocale);
      end;
    end;

    procedure   TFormModules.SetResetOnRender( aValue: Boolean);
    begin
      if aValue <> FResetOnRender
      then begin
        FResetOnRender                := aValue;
        CheckBoxResetOnRender.Checked := aValue;
      end;
    end;

//  private

    procedure   TFormModules.DoDesignerLog( const aSender: TObject; const aMsg: string);
    begin
      Log( aMsg);
    end;

    procedure   TFormModules.DoWirePanelLog( const aSender: TObject; const aMsg: string);
    begin
      Log( aMsg);
    end;

    procedure   TFormModules.DoHistoryChanged( const aSender: TObject; anUndoCount, aRedoCount: Integer);
    begin
      MenuEditUndo.Enabled := anUndoCount  > 0;
      MenuEditRedo.Enabled := aRedoCount   > 0;
      PatchChanged         := anUndoCount <> 0;
    end;

    procedure   TFormModules.DoValueChanged( const aSender: TObject; const aPath, aControlType: string; aValue: TSignal; IsFinal: Boolean);
    var
      aPrefix   : string;
      aFullname : string;
    begin
      // An editor module control changed value, to be reflected in a synth setting
      if Assigned( FSynthPatch)
      then begin
        if IsFinal
        then HandleSpecialValues( aPath, aControlType, aValue);    // Handle some special cases here
        ParsePrefix( aPath, aPrefix, aFullname);                   // Parse off the container prefix - and ignore that.
        FSynthPatch.AcceptParam( aFullname, aValue);               // Pass on the value to the Synth
      end;
    end;

    procedure   TFormModules.DoDisplayChanged( const aSender: TObject; const aPath, aValue: string);
    var
      aPrefix        : string;
      aRest          : string;
      aValues        : TSignals;
      aModuleName    : string;
      aFullParamName : string;
      aModuleIndex   : Integer;
      aModule        : TMod;
      aParts         : TStringList;
    begin
      // An editor module's display changed value, to be reflected in a synth setting
      // These changes are assumed to always be 'final' - i.e. 'inbetween' edits should
      // not make it to here. And for now the value is assumed to be for a text based
      // sequencer only ... ok, but that is tested at least (TModTextSequencer)
      if Assigned( FSynthPatch)
      then begin
        ParsePrefix( aPath, aPrefix, aRest);                   // Parse off the container prefix - and ignore that.
        ParsePrefix( aRest, aModuleName, aFullParamName);
        aModuleIndex := FSynthPatch.FindModule( aModuleName);
        if aModuleIndex >= 0
        then begin
          aModule := FSynthPatch.Module[ aModuleIndex];
          if Assigned( aModule)
          then begin

            if ( aModule is TModTextSequencer) and SameText( aFullParamName, 'textsequencer_values')
            then begin
              aValues := ParseTextSequencerValue( aValue);
              if Assigned( aValues)
              then begin
                try
                  TModTextSequencer( aModule).SetStepValues( aValues);
                finally
                  aValues.Free;
                end;
              end;
            end

            else if (( aModule is TModWavePlayer ) and SameText( aFullParamName, 'waveplayer_display_filename' )) or
                    (( aModule is TModCsvData    ) and SameText( aFullParamName, 'csvdata_display_filename'    )) or
                    (( aModule is TModMorse      ) and SameText( aFullParamName, 'morse_display_text'          ))
            then begin
              aParts := Explode( aFullParamName, '_');
              try
                if aParts.Count = 3
                then aModule.StringValue[ aParts[ 2]] := aValue;
              finally
                aParts.Free;
              end;
            end

            else begin
              aParts := Explode( aFullParamName, '_');
              try
                if ( aParts.Count = 3) and SameText( aParts[ 1], 'display')
                then begin
                  aModule.InternalStringValue[ aParts[ 2]] := aValue;   // Which can set both a param value or an internal value
                end;
              finally
                aParts.Free;
              end;
            end;

          end;
        end;
      end;
    end;

    procedure   TFormModules.DoFileChanged( const aSender: TObject; const aPath, aValue: string);
    var
      aPrefix        : string;
      aRest          : string;
      aModuleName    : string;
      aFullParamName : string;
      aModuleIndex   : Integer;
      aModule        : TMod;
      aParts         : TStringList;
    begin
      // An editor module's filename changed.
      if Assigned( FSynthPatch)
      then begin
        ParsePrefix( aPath, aPrefix, aRest);                   // Parse off the container prefix - and ignore that.
        ParsePrefix( aRest, aModuleName, aFullParamName);
        aModuleIndex := FSynthPatch.FindModule( aModuleName);
        if aModuleIndex >= 0
        then begin
          aModule := FSynthPatch.Module[ aModuleIndex];
          if Assigned( aModule)
          then begin
            if (( aModule is TModWavePlayer ) and SameText( aFullParamName, 'waveplayer_fileselector_filename' )) or
               (( aModule is TModCsvData    ) and SameText( aFullParamName, 'csvdata_fileselector_filename'    )) or
               (( aModule is TModScala      ) and SameText( aFullParamName, 'scala_fileselector_mapping'       )) or
               (( aModule is TModScala      ) and SameText( aFullParamName, 'scala_fileselector_scale'         ))
            then begin
              aParts := Explode( aFullParamName, '_');
              try
                if aParts.Count = 3
                then aModule.StringValue[ aParts[ 2]] := aValue;
              finally
                aParts.Free;
              end;
            end;
          end;
        end;
      end;
    end;

    procedure   TFormModules.DoShowHint( var aHintStr: string; var CanShow: Boolean; var aHintInfo: Vcl.Controls.THintInfo);
    begin
      if Pos( '~', aHintStr) > 0
      then aHintInfo.HintWindowClass := TKnobsHintWindow
      else aHintInfo.HintWindowClass := THintWindow;
    end;

    function    TFormModules.DoCreateModuleBitmap( const aModuleType: TKnobsModuleType): TBitmap;
    begin
      Result := FormStore.CreateModuleBitmap( aModuleType);
    end;

    function    TFormModules.DoReadModuleComment( const aModuleType: TKnobsModuleType): string;
    begin
      Result := FormStore.ReadModuleComment( aModuleType);
    end;

//  private

    function    TFormModules.SplitValueInfo( const aPath: string; var aModule: TKnobsCustomModule; var aModuleType, aSignalName: string): Boolean;
    var
      aParts      : TStringList;
      bParts      : TStringList;
      aModuleName : string;
      aMod        : TKnobsCustomModule;
    begin
      Result      := False;
      aModule     := nil;
      aModuleType := '';
      aSignalName := '';
      aParts := Explode( aPath, '/');
      try
        if aParts.Count >= 2
        then begin
          aModuleName := aParts[ aParts.Count - 2];
          aMod        := EditorPatch.FindModule( aModuleName);
          if Assigned( aMod)
          then begin
            aSignalName := aParts[ aParts.Count - 1];
            bParts      := Explode( aSignalName, '_');
            try
              if bParts.Count = 2
              then begin
                aModuleType := bParts[ 0];
                aSignalName := bParts[ 1];
                aModule     := aMod;
                Result      := True;
              end;
            finally
              bParts.Free;
            end;
          end;
        end;
      finally
        aParts.Free;
      end;
    end;

    procedure   TFormModules.HandleSpecialValues( const aPath, aControlType: string; aValue: TSignal);
    var
      aPostFix    : string;
      aModule     : TKnobsCustomModule;
      aModuleType : string;
      aSignalName : string;
    begin
      if SplitValueInfo( aPath, aModule, aModuleType, aSignalName)
      then begin
        aPostFix := ParsePostFix( aPath);
        if SameText( aPostFix, 'range')
        then ChangeRangeFor( aModule, aModuleType, aPostFix, aValue)
        else if SameText( aPostFix, 'arange')
        then ChangeRangeFor( aModule, aModuleType, aPostFix, aValue)
        else if SameText( aPostFix, 'hrange')
        then ChangeRangeFor( aModule, aModuleType, aPostFix, aValue)
        else if SameText( aPostFix, 'drange')
        then ChangeRangeFor( aModule, aModuleType, aPostFix, aValue)
        else if SameText( aPostFix, 'rrange')
        then ChangeRangeFor( aModule, aModuleType, aPostFix, aValue)
        else if SameText( aPostFix, 'mode') or SameText( aPostFix, 'lock')or SameText( aPostFix, 'lockxy')
        then ChangeModeFor( aModule, aModuleType, aValue)
        else if SameText( aPostFix, 'random')
        then HandleRandomFor( aModule, aModuleType, aValue);
      end;
    end;

    procedure   TFormModules.ChangeRangeFor( const aModule: TKnobsCustomModule; const aModuleType, aRangeType: string; aValue: TSignal);
    var
      aKnob       : TKnobsKnob;
      aKnobName   : string;
      i           : Integer;
      anEnvSpeed  : TEnvRange;
      anLfoSpeed  : TLfoRange;
      aDelaySize  : TDelaySize;
    begin
      if Assigned( aModule)
      then begin
        with aModule
        do begin

          if
            SameText( aModuleType, 'envahd') or
            SameText( aModuleType, 'envadsr')
          then begin
            anEnvSpeed := SignalToEnvRange( aValue);
            for i := 0 to ComponentCount - 1
            do begin
              if Components[ i] is TKnobsKnob
              then begin
                aKnob     := TKnobsKnob( Components[ i]);
                aKnobName := aKnob.Name;
                if
                  ( SameText( aKnobName, 'envahd_attack'  ) and SameText( aRangeType, 'arange')) or
                  ( SameText( aKnobName, 'envahd_hold'    ) and SameText( aRangeType, 'hrange')) or
                  ( SameText( aKnobName, 'envahd_decay'   ) and SameText( aRangeType, 'drange')) or
                  ( SameText( aKnobName, 'envadsr_attack' ) and SameText( aRangeType, 'arange')) or
                  ( SameText( aKnobName, 'envadsr_decay'  ) and SameText( aRangeType, 'drange')) or
                  ( SameText( aKnobName, 'envadsr_release') and SameText( aRangeType, 'rrange'))
                then begin
                  case anEnvSpeed of
                    erFast   : aKnob.ControlType := 'EnvTimeFast'  ;
                    erMedium : aKnob.ControlType := 'EnvTimeMedium';
                    erSlow   : aKnob.ControlType := 'EnvTimeSlow'  ;
                  end;
                end;
              end;
            end;
          end

          else if
            SameText( aModuleType, 'lfo'          ) or
            SameText( aModuleType, 'squarelfo'    ) or
            SameText( aModuleType, 'lfotrig'      ) or
            SameText( aModuleType, 'squarelfotrig') or
            SameText( aModuleType, 'randsig'      ) or
            SameText( aModuleType, 'randomwalklfo')
          then begin
            anLfoSpeed := SignalToLfoRange( aValue);
            for i := 0 to ComponentCount - 1
            do begin
              if Components[ i] is TKnobsKnob
              then begin
                aKnob     := TKnobsKnob( Components[ i]);
                aKnobName := aKnob.Name;
                if
                  SameText( aKnobName, 'lfo_frequency'          ) or
                  SameText( aKnobName, 'lfotrig_frequency'      ) or
                  SameText( aKnobName, 'squarelfo_frequency'    ) or
                  SameText( aKnobName, 'squarelfotrig_frequency') or
                  SameText( aKnobName, 'randsig_frequency'      ) or
                  SameText( aKnobName, 'randomwalklfo_frequency')
                then begin
                  case anLfoSpeed of
                    lsFast   : aKnob.ControlType := 'LfoFreqCoarseFast'  ;
                    lsMedium : aKnob.ControlType := 'LfoFreqCoarseMedium';
                    lsSlow   : aKnob.ControlType := 'LfoFreqCoarseSlow'  ;
                    lsBPM    : aKnob.ControlType := 'LfoFreqCoarseBPM'   ;
                    lsLin    : aKnob.ControlType := 'LfoFreqCoarseLin'   ;
                  end;
                end
              end;
            end;
          end

          else if
            SameText( aModuleType, 'delay')
          then begin
            aDelaySize := SignalToDelaySize( aValue);
            for i := 0 to ComponentCount - 1
            do begin
              if Components[ i] is TKnobsKnob
              then begin
                aKnob     := TKnobsKnob( Components[ i]);
                aKnobName := aKnob.Name;
                if
                  SameText( aKnobName, 'delay_length')
                then begin
                  case aDelaySize of
                    dsShort  : aKnob.ControlType := 'DelayTimeShort';
                    dsMedium : aKnob.ControlType := 'DelayTimeMedium';
                    dsLong   : aKnob.ControlType := 'DelayTimeLong';
                  end;
                end;
              end;
            end;
          end;
        end;
      end;
    end;

    procedure   TFormModules.ChangeModeFor( const aModule: TKnobsCustomModule; const aModuleType: string; aValue: TSignal);
    var
      aKnob : TKnobsKnob;
      i     : Integer;
    begin
      if Assigned( aModule)
      then begin
        if SameText( aModuleType, 'scaler')
        then begin
          aKnob := nil;
          with aModule
          do begin
            for i := 0 to ComponentCount - 1
            do begin
              if Components[ i] is TKnobsKnob
              then begin
                aKnob := TKnobsKnob( Components[ i]); // Pick the first Knob found ... it should be paired in the designer already.
                Break;
              end;
            end;
          end;
          if Assigned( aKnob)
          then aKnob.PairingMode := TKnobsPairingMode( SignalToInt( aValue));
        end
        else if SameText( aModuleType, 'xyscope')
        then begin
          aKnob := nil;
          with aModule
          do begin
            for i := 0 to ComponentCount - 1
            do begin
              if ( Components[ i] is TKnobsKnob) and ( TKnobsKnob( Components[ i]).Name = 'xyscope_levx')
              then begin
                aKnob := TKnobsKnob( Components[ i]); // Pick the X level Knob ... it should be paired in the designer already with the Y level one.
                Break;
              end;
            end;
          end;
          if Assigned( aKnob)
          then aKnob.PairingMode := TKnobsPairingMode( SignalToInt( aValue));
        end
        else if SameText( aModuleType, 'hardclip')
        then begin
          aKnob := nil;
          with aModule
          do begin
            for i := 0 to ComponentCount - 1
            do begin
              if ( Components[ i] is TKnobsKnob) and ( TKnobsKnob( Components[ i]).Name = 'hardclip_lowlevel')
              then begin
                aKnob := TKnobsKnob( Components[ i]); // Pick the low level Knob ... it should be paired in the designer already with the high level one.
                Break;
              end;
            end;
          end;
          if Assigned( aKnob)
          then aKnob.PairingMode := TKnobsPairingMode( SignalToInt( aValue));
        end
        else if
          SameText( aModuletype, 'mixm4to1') or
          SameText( aModuletype, 'mixs2to1') or
          SameText( aModuletype, 'mixt1to1') or
          SameText( aModuletype, 'mixm6to6')
        then begin
          with aModule
          do begin
            for i := 0 to ComponentCount - 1
            do begin
              if Components[ i] is TKnobsKnob
              then begin
                if SignalToInt( aValue) = 0
                then TKnobsKnob( Components[ i]).ControlType := 'linear[-1,1]'
                else TKnobsKnob( Components[ i]).ControlType := 'dB[0,1]'
              end;
            end;
          end;
        end
        else if
          SameText( aModuletype, 'amplifier')
        then begin
          with aModule
          do begin
            for i := 0 to ComponentCount - 1
            do begin
              if Components[ i] is TKnobsKnob
              then begin
                if SignalToInt( aValue) = 0
                then TKnobsKnob( Components[ i]).ControlType := 'linear[-4,4]'    // 0 : for compatibility with older patches
                else TKnobsKnob( Components[ i]).ControlType := 'dB[0,4]'         // 1 : for compatibility with older patches
              end;
            end;
          end;
        end
        else if
          SameText( aModuletype, 'constant' )
        then begin
          with aModule
          do begin
            for i := 0 to ComponentCount - 1
            do begin
              if Components[ i] is TKnobsKnob
              then begin
                aKnob := TKnobsKnob( Components[ i]);
                case SignalToInt( aValue) of
                  0 :  aKnob.ControlType := 'linear[-4,4]'; // 0 : for compatibility with older patches
                  1 :  aKnob.ControlType := 'dB[0,4]';      // 1 : for compatibility with older patches
                  2 :  aKnob.ControlType := 'linear[-1,1]';
                  3 :  aKnob.ControlType := 'dB[0,1]';
                  4 :  aKnob.ControlType := 'linear[0,4]';
                  5 :  aKnob.ControlType := 'linear[0,1]';
                  else aKnob.ControlType := 'NoteName';
                end;
              end;
            end;
          end;
        end;
      end;
    end;

    procedure   TFormModules.HandleRandomFor( const aModule: TKnobsCustomModule; const aModuleType: string; aValue: TSignal);
    var
      aKnob : TKnobsKnob;
      i     : Integer;
    begin
      if SameText( aModuleType, 'sequencer')
      then begin
        if Assigned( aModule)
        then begin
          with aModule
          do begin
            for i := 0 to ComponentCount - 1
            do begin
              if Components[ i] is TKnobsNoKnob
              then begin
                aKnob := TKnobsKnob( Components[ i]);
                if SameText( aKnob.ControlType, 'NoteName')
                then aKnob.KnobPosition := Random( aKnob.StepCount);
              end;
            end;
          end;
        end;
      end;
    end;

    procedure   TFormModules.DoLights( const aSender: TMod; const aMsg: string);
    // A synth signal to be reflected in a module light
    var
      aTmp    : string; // use aTmp to avoid crashes in optimized code - see comments in ParsePrefix code
      aPrefix : string;
      aRest   : string;
      aModule : string;
      aSignal : string;
      aValue  : string;
      aMod    : TKnobsCustomModule;
      aVal    : TSignal;
    begin
      ParsePrefix( aMsg, aPrefix, aTmp);                // Strip off the container prefix
      ParsePrefix( aTmp, aModule, aRest);               // Strip off the module
      aMod  := EditorPatch.FindModule( aModule);        // Find the module in the editor
      if Assigned( aMod)
      then begin
        ParsePrefix( aRest, aSignal, aValue);           // Strip off the signal name
        aVal := StrToFloatDef( aValue, -1);             // which leaves the value ...
        aMod.SetLight( aSignal, aVal);
      end;
    end;

    procedure   TFormModules.DoData( const aSender: TMod; const aPath: string; const aData: TSignalArray);
    // A synth signal to be reflected in a module control
    var
      aTmp    : string; // use aTmp to avoid crashes in optimized code - see comments in ParsePrefix code
      aPrefix : string;
      aModule : string;
      aSignal : string;
      aMod    : TKnobsCustomModule;
    begin
      ParsePrefix( aPath, aPrefix, aTmp);               // Strip off the container prefix
      ParsePrefix( aTmp, aModule, aSignal);             // Strip off the module, leaving the signal name
      aMod  := EditorPatch.FindModule( aModule);        // Find the module in the editor
      if Assigned( aMod)
      then aMod.SetData( aSignal, aData);
    end;

    procedure   TFormModules.DoXYData( const aSender: TMod; const aPath: string; const aData: TSignalFifo);
    var
      aTmp    : string; // use aTmp to avoid crashes in optimized code - see comments in ParsePrefix code
      aPrefix : string;
      aModule : string;
      aSignal : string;
      aMod    : TKnobsCustomModule;
    begin
      ParsePrefix( aPath, aPrefix, aTmp);               // Strip off the container prefix
      ParsePrefix( aTmp, aModule, aSignal);             // Strip off the module, leaving the signal name
      aMod  := EditorPatch.FindModule( aModule);        // Find the module in the editor
      if Assigned( aMod)
      then aMod.SetXYData( aSignal, aData);
    end;

    procedure   TFormModules.DoInfo( const aSender: TMod; const aMsg: string);
    // A synth signal to be reflected in a module light
    var
      aTmp    : string; // use aTmp to avoid crashes in optimized code - see comments in ParsePrefix code
      aPrefix : string;
      aRest   : string;
      aModule : string;
      aSignal : string;
      aValue  : string;
      aMod    : TKnobsCustomModule;
    begin
      ParsePrefix( aMsg, aPrefix, aTmp);                // Strip off the container prefix
      ParsePrefix( aTmp, aModule, aRest);               // Strip off the module
      aMod  := EditorPatch.FindModule( aModule);        // Find the module in the editor
      if Assigned( aMod)
      then begin
        ParsePrefix( aRest, aSignal, aValue);           // Strip off the signal name
        aMod.SetInfo( aSignal, aValue);                 // which leaves the value ...
      end;
    end;

    procedure   TFormModules.DoPatchChanged( const aSender: TKnobsWirePanel);
    // The patch changed module, module-type or wire wise.
    begin
      CompilePatch;
    end;

    procedure   TFormModules.DoShowPopupMenu( const aSender: TKnobsWirePanel; const aControl: TControl);

      procedure ShowPopupConnector( aPopup: TPopupMenu; aControl: TControl);
      begin
        FPopupSender := aControl;
        aPopup.Popup( aControl.ClientOrigin.X + 10, aControl.ClientOrigin.Y + 10);
      end;

      procedure ShowPopupModule( aPopup: TPopupMenu; aControl: TControl);
      begin
        FPopupSender := aControl;
        aPopup.Popup( aControl.ClientOrigin.X + 10, aControl.ClientOrigin.Y + 10);
      end;

      procedure ShowPopupSelector( aPopup: TPopupMenu; aControl: TControl);
      var
        aSelector : TKnobsSelector;
        i         : Integer;
      begin
        FPopupSender := aControl;
        aSelector    := TKnobsSelector( aControl);
        aPopup.Images := aSelector.Glyphs;
        with aSelector
        do begin
          RemoveSelectorMenuItems;
          for i := 0 to Captions.Count - 1
          do AddSelectorMenuItem( i, Captions[ i]);
        end;
        aPopup.Popup( aControl.ClientOrigin.X + 10, aControl.ClientOrigin.Y + 10);
      end;

      procedure ShowPopupKnob( aPopup: TPopupMenu; aControl: TControl);
      begin
        FPopupSender := aControl;
        if aControl is TKnobsKnob
        then LockKnob.Checked := TKnobsKnob( aControl).Locked
        else LockKnob.Visible := False;
        aPopup.Popup( aControl.ClientOrigin.X + 10, aControl.ClientOrigin.Y + 10);
      end;

    begin
      if aControl is TKnobsConnector
      then ShowPopupConnector( PopupMenuConnector, aControl)
      else if aControl is TKnobsModule
      then ShowPopupModule( PopupMenuModule, aControl)
      else if aControl is TKnobsSelector
      then ShowPopupSelector( PopupMenuSelector, aControl)
      else if aControl is TKnobsValuedControl
      then ShowPopupKnob( PopupMenuKnob, aControl);
    end;

    procedure   TFormModules.DoUnFocus( const aSender: TObject);
    begin
      knob_outputlevel1.SetFocus;
    end;

    function    TFormModules.SavePatch: Boolean;
    var
      aFileName : string;
    begin
      aFileName := EditorPatch.Filename;
      if FileExists( aFileName)
      then begin
        FPatchWriter.WriteFile( EditorPatch, aFileName);
        EditorPatch.ClearUndoRedo;
        Result := True;
      end
      else Result := SavePatchAs;
    end;

    function    TFormModules.SavePatchAs: Boolean;
    begin
      Result := False;
      with SaveDialogPatch
      do begin
        if FileName = ''
        then Filename := EditorPatch.Filename;
        InitialDir := ExtractFilePath( Filename);
        FileName   := ExtractFileName( Filename);
        if InitialDir = ''
        then InitialDir := ApplicationPath + 'patches';
        if Execute
        then begin
          SourceFileName := FileName;
          PatchName      := CleanFileName( FileName);
          FPatchWriter.WriteFile( EditorPatch, FileName);
          EditorPatch.ClearUndoRedo;
          Result := True;
        end;
      end;
    end;

    procedure   TFormModules.DoLoadPatch( const aFileName: string);
    begin
      if FileExists( aFileName)
      then begin
        EditorPatch.BlockScreenUpdates;
        try
          LogFmt( 'loading file %s', [ aFileName]);
          SourceFileName := aFileName;
          FPatchReader.ReadFile( aFileName, EditorPatch, rmReplace);
          PatchName := EditorPatch.Title;
          EditorPatch.ClearUndoRedo;
          EditorPatch.UnSelectAllModules;
          ClearVolumeIndicators;
        finally
          EditorPatch.UnblockScreenUpdates;
        end;
      end;
    end;

    procedure   TFormModules.LoadPatch;
    begin
      with OpenDialogPatch
      do begin
        if FileName = ''
        then Filename := EditorPatch.Filename;
        InitialDir := ExtractFilePath( Filename);
        FileName   := ExtractFileName( Filename);
        if InitialDir = ''
        then InitialDir := ApplicationPath + 'patches';
        if Execute
        then DoLoadPatch( FileName);
      end;
    end;

    procedure   TFormModules.NewPatch;
    begin
      SourceFileName := 'new';
      if Assigned( EditorPatch)
      then begin
        EditorPatch.FreeModules;
        EditorPatch  .Title := 'new';
        EditPatchName.Text  := 'new';
      end;
    end;

    procedure   TFormModules.DeleteModules;
    begin
      if Assigned( EditorPatch)
      then EditorPatch.FreeSelectedModules;
    end;

    procedure   TFormModules.CutModules;
    begin
      CopyModules;
      DeleteModules;
    end;

    procedure   TFormModules.CopyModules;
    begin
      if Assigned( FPatchWriter)
      then FPatchWriter.WriteToClipboard( EditorPatch, wmSelected);
    end;

    procedure   TFormModules.PasteModules;
    begin
      if Assigned( FPatchReader)
      then FPatchReader.ReadFromClipboard( EditorPatch, rmAppend);
    end;

    procedure   TFormModules.SelectAll;
    begin
      if Assigned( EditorPatch)
      then EditorPatch.SelectAllModules;
    end;

    procedure   TFormModules.SelectNone;
    begin
      if Assigned( EditorPatch)
      then EditorPatch.UnselectAllModules;
    end;

    procedure   TFormModules.InvertSelection;
    begin
      if Assigned( EditorPatch)
      then EditorPatch.InvertModuleSelection;
    end;

    procedure   TFormModules.WiggleWires;
    begin
      if Assigned( EditorPatch)
      then EditorPatch.WiggleWires;
    end;

    procedure   TFormModules.SearchPatch( const aValue: string);
    begin
      if Assigned( EditorPatch)
      then EditorPatch.Search( aValue);
    end;

    procedure   TFormModules.FindUnconnectedModules;
    begin
      if Assigned( EditorPatch)
      then EditorPatch.FindUnconnectedModules;
    end;

//  private

    function    TFormModules.FunctionalPinName( const aName: string): string;
    var
      aList: TStringList;
    begin
      aList  := Explode( aName, '_');
      Result := '';
      try
        if aList.Count = 2
        then Result := aList[ 1];
      finally
        aList.Free;
      end;
    end;

    function    TFormModules.SplitConnectorName( const aName: string; var aMod, aPin: string): Boolean;
    var
      aList: TStringList;
    begin
      aMod   := '';
      aPin   := '';
      Result := False;
      aList  := Explode( aName, '.');
      try
        if aList.Count = 2
        then begin
          aMod   := aList[ 0];
          aPin   := aList[ 1];
          Result := True;
        end;
      finally
        aList.Free;
      end;
    end;

    function    TFormModules.ModuleTypeToModule( aType: Integer; const aParent: TSynthPatch; const aName: string): TMod;
    // This couples an editor module ID to it's synth implementation
    // Stuff that needs or can not be compiled, i.e. 'editor only' modules should return nil here
    var
      M : TModuleClass;
    begin
      Result := nil;
      M      := LookupModuleClass( aType);
      if Assigned( M)
      then Result := M.Create( aParent, aName);
    end;

    procedure   TFormModules.CompilePatch;
    // This creates a synth patch from an editor patch and then
    // changes the the current synth patch for the new one.
    var
      aSynthPatch   : TSynthPatch;
      i             : Integer;
      aPatchModule  : TKnobsCustomModule;
      aModuleType   : Integer;
      aModuleName   : string;
      aModule       : TMod;
      S             : string;
      aWire         : TKnobsWire;
      aSrcConnector : string;
      aDstConnector : string;
      aSrcMod       : string;
      aSrcPin       : string;
      aDstMod       : string;
      aDstPin       : string;
    begin
      Log( 'compiling synth patch');
      if Assigned( EditorPatch)
      then begin

        aSynthPatch := TSynthPatch.Create( nil, PatchName);

        try

          aSynthPatch.Version := EditorPatch.Version;

          with EditorPatch
          do begin
            for i := 0 to ModuleCount - 1
            do begin
              aPatchModule := Module[ i];
              aModuleType  := aPatchModule.ModuleType;
              aModuleName  := aPatchModule.Name;
              aModule      := ModuleTypeToModule( aModuleType, aSynthPatch, aModuleName);

              if Assigned( aModule)                      // Module translates
              then aSynthPatch.AddModule( aModule);
            end;

            FixAllWires;                                 // Get the wire directions right before wire compilation
            for i := 0 to WireCount - 1
            do begin

              aWire         := Wire[ i];
              aSrcConnector := aWire.SourceName;
              aDstConnector := aWire.DestinationName;

              if
                SplitConnectorName( aSrcConnector, aSrcMod, aSrcPin) and
                SplitConnectorName( aDstConnector, aDstMod, aDstPin) and
                not SameText( aSrcMod, '<nil>')                      and
                not SameText( aDstMod, '<nil>')                      and
                not SameText( aSrcPin, '<nil>')                      and
                not SameText( aDstPin, '<nil>')
              then begin

                aSrcPin := FunctionalPinName( aSrcPin);
                aDstPin := FunctionalPinName( aDstPin);
                aSynthPatch.AddConnection( aSrcMod, aSrcPin, aDstMod, aDstPin);

              end;
            end; // for i := 0 to WireCount - 1

            if not ChangeSynthPatch( aSynthPatch)
            then FreeAndNil( aSynthPatch);

            // Some debug stuff - write the just created synth patch to test.txt - in the current (application) directory
            if CompilerDebug and Assigned( FSynthPatch)
            then begin
              S := '';
              FSynthPatch.Save( 0, S);
              StringTofile( S, 'test.txt');
            end;

          end; // with WirePanel ..
        except
          on E: Exception
          do begin
            KilledException( E);
            aSynthPatch.Free;
          end;
        end; // try ... except

      end; // if Assigned( aWirePanel)
      Log( 'compiled synth patch');
    end;

//  private

    procedure   TFormModules.InitializeCPUCounter;
    begin
      FCpuUsageData := CreateCpuUsageCounter( GetCurrentProcessId);
    end;

    procedure   TFormModules.FinalizeCPUCounter;
    begin
      if Assigned( FCpuUsageData)
      then begin
        DestroyCpuUsageCounter( FCpuUsageData);
        FCpuUsageData := nil;
      end;
    end;

    procedure   TFormModules.TickCPUCounter;
    begin
      if Assigned( FCpuUsageData)
      then FProcessTime := ( FProcessTime + 2 * GetCpuUsage( FCpuUsageData) / CpuCount) / 3
      else FProcessTime := -1;
    end;

//  private

    procedure   TFormModules.StartNetMidiConnectTimer;
    begin
      StopNetMidiConnectTimer;
      TimerNetMidiConnect.Interval := 1000;
      TimerNetMidiConnect.Enabled  := True;
    end;

    procedure   TFormModules.StopNetMidiConnectTimer;
    begin
      TimerNetMidiConnect.Enabled  := False;
    end;

    procedure   TFormModules.NetMidiConnectTimerFired;
    begin
      if NetMidiAutoConnect and not NetMidiConnected
      then NetMidiConnect;
    end;

    procedure   TFormModules.NetMidiConnect;
    begin
      if not NetMidiConnected
      then begin
        // set net midi connect params
        WSocketNetMidi.Addr := NetMidiServer;
        WSocketNetMidi.Port := NetMidiPort;
        // start net midi client
        WSocketNetMidi.Connect;
      end;
    end;

    procedure   TFormModules.NetMidiDisconnect;
    begin
      if NetMidiConnected
      then begin
        // stop net midi client
        WSocketNetMidi.Close;
      end;
    end;

    procedure   TFormModules.NetMidiApply;
    var
      WasConnected : Boolean;
    begin
      WasConnected := NetMidiConnected;
      NetMidiDisconnect;
      NetMidiServer := EditNetMidiServer.Text;
      NetMidiPort   := EditNetMidiPort  .Text;
      if WasConnected
      then NetMidiConnect;
      NetMidiChanged := False;
    end;

    procedure   TFormModules.NetMidiCancel;
    begin
      EditNetMidiServer.Text := NetMidiServer;
      EditNetMidiPort  .Text := NetMidiPort;
      NetMidiChanged := False;
    end;

    function    TFormModules.SocketStateToStr( aValue: TSocketState): string;
    begin
      Result := GetEnumName(TypeInfo( TSocketState), Integer( aValue));
    end;

    procedure   TFormModules.ReceiveNetMidi;
    var
      aBuffer : array[ 0 .. 1023] of Byte;
      aCount  : Integer;
      aData   : TBytes;
      i       : Integer;
    begin
      aCount := WSocketNetMidi.Receive( @ aBuffer, 1024);
      if aCount > 0
      then begin
        SetLength( aData, aCount);
        for i := 0 to aCount - 1
        do aData[ i] := aBuffer[ i];
        AcceptNetMidi( aData);
      end;
    end;

    procedure   TFormModules.SendNetMidi( const aData: TBytes);
    type
      TPackedBytes = array[ 0 .. MaxInt - 1] of Byte;
      PPackedBytes = ^TPackedBytes;
    var
      Bytes : PPackedBytes;
      Res   : Integer;
      i     : Integer;
    begin
      if Length( aData) > 0
      then begin
        GetMem( Bytes, Length( aData));
        try
          for i := 0 to Length( aData) - 1
          do Bytes^[ i] := aData[ i];
          Res := WSocketNetMidi.Send( Bytes, Length( aData));
          if Res > 0
          then begin
            LedNetMidiTx1.Active := True;
            LedNetMidiTx2.Active := True;
          end
          else MidiLogFmt( 'TX error : %d', [ Res]);
        finally
          FreeMem( Bytes);
        end;
      end;
    end;

    procedure   TFormModules.AcceptNetMidi( const aData: TBytes);
    var
      i : Integer;
    begin
      for i := 0 to Length( aData) - 1
      do AcceptMidiByte( aData[ i]);
    end;

    procedure   TFormModules.AcceptMidiByte( aByte: Byte);
    begin
      case FMidiRxState of

        mrxNormal :
          begin
            if aByte and $80 = $80
            then AcceptMidiCommand( aByte);
          end;

        mrxRunningStatus :
          begin
            if aByte and $80 = $80
            then AcceptMidiCommand( aByte)
            else AcceptMidiData   ( aByte);
          end;

      end;
    end;

    procedure   TFormModules.AcceptMidiCommand( aByte: Byte);
    begin
      FMidiDataCount := 0;

      case aByte and $f0 of

        CSysEx : AcceptMidiSysex( aByte);

        else begin
          FMidiRunningStatus := aByte;
          FMidiRxState       := mrxRunningStatus;
          FMidiChannel       := aByte and $0f;
        end;

      end;
    end;

    procedure   TFormModules.AcceptMidiData( aByte: Byte);
    begin
      case FMidiRunningStatus of

        CNoteOff :         // = $80; // Length = 3;
          begin
            if FMidiDataCount = 1
            then MidiProcessNoteOff( aByte, FMidiData, FMidiChannel)
            else begin
              FMidiData := aByte;
              Inc( FMidiDataCount);
            end;
          end;

        CNoteOn :          // = $90; // Length = 3;
          begin
            if FMidiDataCount = 1
            then MidiProcessNoteOn( aByte, FMidiData, FMidiChannel)
            else begin
              FMidiData := aByte;
              Inc( FMidiDataCount);
            end;
          end;

        CKeyPressure :     // = $a0; // Length = 3;
          begin
            if FMidiDataCount = 1
            then MidiProcessKeyPressure( aByte, FMidiData, FMidiChannel)
            else begin
              FMidiData := aByte;
              Inc( FMidiDataCount);
            end;
          end;

        CControlChange :   // = $b0; // Length = 3;
          begin
            if FMidiDataCount = 1
            then MidiProcessControlChange( aByte, FMidiData, FMidiChannel)
            else begin
              FMidiData := aByte;
              Inc( FMidiDataCount);
            end;
          end;

        CProgramChange :   // = $c0; // Length = 2;
          begin
            MidiProcessProgramChange( aByte,FMidiChannel);
          end;

        CChannelPressure : // = $d0; // Length = 2;
          begin
            MidiProcessChannelPressure( aByte,FMidiChannel);
          end;

        CPitchBend :       // = $e0; // Length = 2;
          begin
            if FMidiDataCount = 1
            then MidiProcessPitchBend(( aByte and $7f) + 128 * ( FMidiData and $7f), FMidiChannel)
            else begin
              FMidiData := aByte;
              Inc( FMidiDataCount);
            end;
          end;

        CSysEx :           // = $f0; // Length = n;
          begin
            MidiProcessSysExData( aByte);
          end;

        SSongPosition :
          begin
            if FMidiDataCount = 1
            then MidiProcessSongPosition(( aByte and $7f) + 128 * ( FMidiData and $7f))
            else begin
              FMidiData := aByte;
              Inc( FMidiDataCount);
            end;
          end;

        SSongSelect :
          begin
            MidiProcessSongSelect( aByte);
          end;

        else MidiReset;

      end;
    end;

    procedure   TFormModules.AcceptMidiSysex( aByte: Byte);
    begin
      case aByte and $0f of

        SSysEx :          // = $00; // Length = 1, followed by arbitrary amt of data, finalized by SEox;
          begin
            FMidiRunningStatus := SSysEx;
            FMidiRxState       := mrxRunningStatus;
            MidiProcessStartSysEx;
          end;

        SSongPosition :   // = $02; // Length = 3;
          begin
            FMidiRunningStatus := SSongPosition;
            FMidiRxState       := mrxRunningStatus;
          end;

        SSongSelect :     // = $03; // Length = 2;
          begin
            FMidiRunningStatus := SSongPosition;
            FMidiRxState       := mrxRunningStatus;
          end;

        STuneRequest :    // = $06; // Length = 1;
          begin
            MidiProcessTuneRequest;
          end;

        SEox :            // = $07; // Length = 1;
          begin
            MidiProcessEndSysEx;
          end;

        STimingClock :    // = $08; // Length = 1;
          begin
            MidiProcessTimingClock;
          end;

        SStart :          // = $0a; // Length = 1;
          begin
            MidiProcessStart;
          end;

        SContinue :       // = $0b; // Length = 1;
          begin
            MidiProcessContinue;
          end;

        SStop :           // = $0c; // Length = 1;
          begin
            MidiProcessStop;
          end;

        SActiveSense :    // = $0e; // Length = 1;
          begin
            MidiProcessActiveSense;
          end;

        SReset :          // = $0f; // Length = 1;
          begin
            MidiProcessReset;
          end;

      end;
    end;

    procedure   TFormModules.MidiReset;
    begin
      FMidiRxState       := mrxNormal;
      FMidiRunningStatus := 0;
    end;

    procedure   TFormModules.MidiProcessNoteOff( aVelocity, aNote, aChannel: Byte);
    begin
      MidiProcessMessage( MakeMidiNoteOff( aVelocity, aNote, aChannel));
    end;

    procedure   TFormModules.MidiProcessNoteOn( aVelocity, aNote, aChannel: Byte);
    begin
      if aVelocity = 0
      then MidiProcessMessage( MakeMidiNoteOff( 0        , aNote, aChannel))
      else MidiProcessMessage( MakeMidiNoteOn ( aVelocity, aNote, aChannel));
    end;

    procedure   TFormModules.MidiProcessKeyPressure( aPressure, aNote, aChannel: Byte);
    begin
      MidiProcessMessage( MakeMidiKeyPressure( aPressure, aNote, aChannel));
    end;

    procedure   TFormModules.MidiProcessControlChange( aValue, aController, aChannel: Byte);
    begin
      MidiProcessMessage( MakeMidiControlChange( aValue, aController, aChannel));
    end;

    procedure   TFormModules.MidiProcessProgramChange( aProgram, aChannel: Byte);
    begin
      MidiProcessMessage( MakeMidiProgramChange( aProgram, aChannel));
    end;

    procedure   TFormModules.MidiProcessChannelPressure( aValue, aChannel: Byte);
    begin
      MidiProcessMessage( MakeMidiChannelPressure( aValue, aChannel));
    end;

    procedure   TFormModules.MidiProcessPitchBend( aData: Word; aChannel: Byte);
    begin
      MidiProcessMessage( MakeMidiPitchBend( aData, aChannel));
    end;

    procedure   TFormModules.MidiProcessStartSysEx;
    begin
      SetLength( FMidiSysex, 0);
    end;

    procedure   TFormModules.MidiProcessEndSysEx;
    begin
      // Sysex message completed and stored in FMidiSysex
      MidiProcessMessage( MakeMidiSysExData( FMidiSysex));
    end;

    procedure   TFormModules.MidiProcessSongPosition( aData: Word);
    begin
      MidiProcessMessage( MakeMidiSongPosition( aData));
    end;

    procedure   TFormModules.MidiProcessSongSelect( aSong: Byte);
    begin
      MidiProcessMessage( MakeMidiSongSelect( aSong));
    end;

    procedure   TFormModules.MidiProcessTuneRequest;
    begin
      MidiProcessMessage( MakeMidiTuneRequest);
    end;

    procedure   TFormModules.MidiProcessTimingClock;
    begin
      MidiProcessMessage( MakeMidiTimingClock);
    end;

    procedure   TFormModules.MidiProcessStart;
    begin
      MidiProcessMessage( MakeMidiStart);
    end;

    procedure   TFormModules.MidiProcessContinue;
    begin
      MidiProcessMessage( MakeMidiContinue);
    end;

    procedure   TFormModules.MidiProcessStop;
    begin
      MidiProcessMessage( MakeMidiStop);
    end;

    procedure   TFormModules.MidiProcessActiveSense;
    begin
      MidiProcessMessage( MakeMidiActiveSense);
    end;

    procedure   TFormModules.MidiProcessReset;
    begin
      MidiProcessMessage( MakeMidiReset);
    end;

    procedure   TFormModules.MidiProcessSysExData( aData: Byte);
    begin
      if Length( FMidiSysex) >= 1024 // Prevent buffer from getting arbitrary large
      then begin
        MidiProcessEndSysEx;         // process the partial message
        MidiProcessStartSysEx;       // and start a new one
      end;
      SetLength( FMidiSysex, Length( FMidiSysex) + 1);
      FMidiSysex[ Length( FMidiSysex) - 1] := aData;
    end;

    procedure   TFormModules.MidiProcessMessage( const aMsg: TMidiMessage);
    begin
      if Assigned( FSynthPatch) and ( FAudioInRunning and FAudioOutRunning)
      then begin
        FSynthPatch.AcceptMidi( aMsg);
        MidiMsgLogFmt( 'RX : %s', [ MidiMessageToLog( aMsg)]);
      end;
    end;

    procedure   TFormModules.DoMidiSendMessage( const aSender: TObject; const aMsg: TMidiMessage);
    var
      aData : TBytes;
    begin
      MidiMessageToBytes( aMsg, aData);
      SendNetMidi( aData);
      MidiMsgLogFmt( 'TX : %s', [ MidiMessageToLog( aMsg)]);
    end;

// public

    procedure TFormModules.MemoDebugWindowProc( var aMsg: TMessage);
    var
      aTicks     : SmallInt;
      aScrollMsg : TWMVScroll;
    begin
      if aMsg.Msg = WM_MOUSEWHEEL
      then begin
          aScrollMsg.Msg := WM_VSCROLL;
          aTicks         := SmallInt( HiWord( aMsg.WParam));
          if aTicks > 0
          then aScrollMsg.ScrollCode := SB_LINEUP
          else aScrollMsg.ScrollCode := SB_LINEDOWN;

          aScrollMsg.Pos := 0;
          MemoDebug.Dispatch( aScrollMsg) ;
        end
      else FOldMemoDebug( aMsg);
    end;

    function    TFormModules.IsShortCut( var aMessage: TWMKey): Boolean; // override;
    begin
      if EditorPatch.HasEditPopup
      then Result := False
      else Result := inherited IsShortcut( aMessage);
    end;

    procedure   TFormModules.ResetInPeaks;
    begin
      FdBInMax1    := -333;
      FdBInMaxMax1 := -333;
      FdBInMaxMin1 :=    0;
      labeldbIn1   .Caption := '---';
      LabeldBInMax1.Caption := '---';
      LabeldBInMin1.Caption := '---';

      FdBInMax2    := -333;
      FdBInMaxMax2 := -333;
      FdBInMaxMin2 :=    0;
      labeldbIn2   .Caption := '---';
      LabeldBInMax2.Caption := '---';
      LabeldBInMin2.Caption := '---';

      FdBInMax3    := -333;
      FdBInMaxMax3 := -333;
      FdBInMaxMin3 :=    0;
      labeldbIn3   .Caption := '---';
      LabeldBInMax3.Caption := '---';
      LabeldBInMin3.Caption := '---';

      FdBInMax4    := -333;
      FdBInMaxMax4 := -333;
      FdBInMaxMin4 :=    0;
      labeldbIn4   .Caption := '---';
      LabeldBInMax4.Caption := '---';
      LabeldBInMin4.Caption := '---';
    end;

    procedure   TFormModules.ResetOutPeaks;
    begin
      FdBOutMax1    := -333;
      FdBOutMaxMax1 := -333;
      FdBOutMaxMin1 :=    0;
      labeldbOut1   .Caption := '---';
      LabeldBOutMax1.Caption := '---';
      LabeldBOutMin1.Caption := '---';

      FdBOutMax2    := -333;
      FdBOutMaxMax2 := -333;
      FdBOutMaxMin2 :=    0;
      labeldbOut2   .Caption := '---';
      LabeldBOutMax2.Caption := '---';
      LabeldBOutMin2.Caption := '---';

      FdBOutMax3    := -333;
      FdBOutMaxMax3 := -333;
      FdBOutMaxMin3 :=    0;
      labeldbOut3   .Caption := '---';
      LabeldBOutMax3.Caption := '---';
      LabeldBOutMin3.Caption := '---';

      FdBOutMax4    := -333;
      FdBOutMaxMax4 := -333;
      FdBOutMaxMin4 :=    0;
      labeldbOut4   .Caption := '---';
      LabeldBOutMax4.Caption := '---';
      LabeldBOutMin4.Caption := '---';
    end;

    procedure   TFormModules.ResetPeaks;
    begin
      ResetInPeaks;
      ResetOutPeaks;
    end;

// Delphi area


procedure TFormModules.Color1Click(Sender: TObject);
begin
  ChangeModuleColor( FPopupSender as TKnobsModule);
end;

procedure TFormModules.SplitterMainMoved(Sender: TObject);
begin
  SplitterMain.ShowHint := PanelControl.Width = 0;
end;

procedure TFormModules.LabeldBInMax1Click(Sender: TObject);
begin
  ResetInPeaks;
end;

procedure TFormModules.LabeldBOutMax1Click(Sender: TObject);
begin
  ResetOutPeaks;
end;

procedure TFormModules.LabelRunTimeClick(Sender: TObject);
begin
  if not RenderToFile
  then ResetRuntime;
end;

procedure TFormModules.LockKnobClick(Sender: TObject);
begin
  KnobChangeLock( FPopupSender as TKnobsKnob);
end;

procedure TFormModules.SetKnobDefaultvalueClick(Sender: TObject);
begin
  KnobSetDefaultValue( FPopupSender as TKnobsValuedcontrol)
end;

procedure TFormModules.DeleteModuleClick(Sender: TObject);
begin
  ModuleDelete( FPopupSender as TKnobsModule);
end;

procedure TFormModules.CopyModuleClick(Sender: TObject);
begin
  ModuleCopy( FPopupSender as TKnobsModule);
end;

procedure TFormModules.CutModuleClick(Sender: TObject);
begin
  ModuleCut( FPopupSender as TKnobsModule);
end;

procedure TFormModules.DisconnectConnectorClick(Sender: TObject);
begin
  ConnectorDisconnect( FPopupSender as TKnobsConnector);
end;

procedure TFormModules.DeleteConnectorClick(Sender: TObject);
begin
  ConnectorDelete( FPopupSender as TKnobsConnector);
end;

procedure TFormModules.Find1Click(Sender: TObject);
begin
  EditSearch.SetFocus;
end;

procedure TFormModules.Findunconnectedmodules1Click(Sender: TObject);
begin
  FindUnconnectedModules;
end;

procedure TFormModules.Profile1Click(Sender: TObject);
begin
  ProfilePatch;
end;

procedure TFormModules.WSocketNetMidiBgException(Sender: TObject; E: Exception; var CanClose: Boolean);
begin
  MidiLogFmt( 'exception : %s', [ E.Message]);
  CanClose := True;
end;

procedure TFormModules.WSocketNetMidiChangeState(Sender: TObject; OldState, NewState: TSocketState);
begin
  MidiLogFmt( 'state changed from %s to %s', [ SocketStateToStr( OldState), SocketStateToStr( NewState)]);
end;

procedure TFormModules.WSocketNetMidiDataAvailable(Sender: TObject; ErrCode: Word);
begin
  // MidiLogFmt( 'data available, error code %d', [ ErrCode]);
  LedNetMidiRx1.Active := True;
  LedNetMidiRx2.Active := True;
  ReceiveNetMidi;
end;

procedure TFormModules.WSocketNetMidiDataSent(Sender: TObject; ErrCode: Word);
begin
  // MidiLogFmt( 'data sent, error code %d', [ ErrCode]);
  LedNetMidiTx1.Active := True;
  LedNetMidiTx2.Active := True;
end;

procedure TFormModules.WSocketNetMidiError(Sender: TObject);
begin
  MidiLog( 'error (no further specification available)');
end;

procedure TFormModules.WSocketNetMidiSessionClosed(Sender: TObject; ErrCode: Word);
begin
  MidiLogFmt( 'session closed, error code %d', [ ErrCode]);
  NetMidiConnected := False;
  if NetMidiAutoConnect
  then StartNetMidiConnectTimer;
end;

procedure TFormModules.WSocketNetMidiSessionConnected(Sender: TObject; ErrCode: Word);
begin
  MidiLogFmt( 'session connected, error code %d', [ ErrCode]);
  NetMidiConnected := True;
end;

procedure TFormModules.MenuViewGraphsClick(Sender: TObject);
begin
  PageControlMain.ActivePage := TabSheetDebug;
  PageControlDGSA.ActivePage := TabSheetGraph;
end;

procedure TFormModules.MenuViewDebuggerClick(Sender: TObject);
begin
  PageControlMain.ActivePage := TabSheetDebug;
  PageControlDGSA.ActivePage := TabSheetText;
end;

procedure TFormModules.EditMiddleNoteChange(Sender: TObject);
var
  F : TSignal;
begin
  if EditMiddleNote.Text <> ''
  then begin
    F := StrToFloatDef( EditMiddleNote.Text, NaN);
    if not IsNan( F) and not AlmostZero( F)
    then MiddleNote := F;
  end;
end;

procedure TFormModules.EditNetMidiPortChange(Sender: TObject);
begin
  NetMidiChanged := True;
end;

procedure TFormModules.EditNetMidiServerChange(Sender: TObject);
begin
  NetMidiChanged := True;
end;

procedure TFormModules.EditNotesPerOctaveChange(Sender: TObject);
var
  F : TSignal;
begin
  if EditNotesPerOctave.Text <> ''
  then begin
    F := StrToFloatDef( EditNotesPerOctave.Text, NaN);
    if not IsNan( F) and not AlmostZero( F)
    then NotesPerOctave := F;
  end;
end;

procedure TFormModules.MenuViewEditorClick(Sender: TObject);
begin
  PageControlMain.ActivePage := TabSheetEditor;
end;

procedure TFormModules.EditPatchNameChange(Sender: TObject);
begin
  PatchName := EditPatchName.Text;
end;

procedure TFormModules.EditReferenceAChange(Sender: TObject);
var
  F: TSignal;
begin
  if EditReferenceA.Text <> ''
  then begin
    F := StrToFloatDef( EditReferenceA.Text, NaN);
    if not IsNan( F)
    then ReferenceA := F;
  end;
end;

procedure TFormModules.EditSearchChange(Sender: TObject);
begin
  SearchPatch( EditSearch.Text);
end;

procedure TFormModules.RadioGroupControlModeClick(Sender: TObject);
begin
  ControlMode := TDistanceMode( RadioGroupControlMode.ItemIndex);
end;

procedure TFormModules.RadioGroupPrioLevelClick( Sender: TObject);
begin
  PrioLevel := RadioGroupPrioLevel.ItemIndex;
end;

procedure TFormModules.RadioGroupSampleRateClick(Sender: TObject);
begin
  case RadioGroupSampleRate.ItemIndex of
    1 :  Samplerate := 48000;
    2 :  Samplerate := 88200;
    3 :  Samplerate := 96000;
    else Samplerate := 44100;
  end;
end;

procedure TFormModules.MenuSetupSettingsClick(Sender: TObject);
begin
  PageControlMain.ActivePage := TabSheetDebug;
  PageControlDGSA.ActivePage := TabSheetSettings;
end;

procedure TFormModules.MenuViewSettingsClick(Sender: TObject);
begin
  PageControlMain.ActivePage := TabSheetDebug;
  PageControlDGSA.ActivePage := TabSheetSettings;
end;

procedure TFormModules.MenuHelpHelpClick(Sender: TObject);
begin
  ShowHelp;
end;

procedure TFormModules.SpinButtonWureThicknessDownClick(Sender: TObject);
begin
  if WireThickness > 0
  then WireThickness := WireThickness - 1;
end;

procedure TFormModules.SpinButtonWureThicknessUpClick(Sender: TObject);
begin
  if WireThickness < 4
  then WireThickness := WireThickness + 1;
end;

procedure TFormModules.MenuFileNewClick(Sender: TObject);
begin
  NewPatch;
end;

procedure TFormModules.MenuSetupDevicesClick(Sender: TObject);
begin
  with FormWaveDeviceSelect
  do begin
    AllowPortAudio     := Self.UsePortAudio;
    PAInitialized      := Self.FPAInitialized;
    SelectedAPIID      := Self.FSelectedAPIID;
    SelectedInputId    := Self.FSelectedInputId;
    SelectedOutputId   := Self.FSelectedOutputId;
    SelectedInputIdPA  := Self.FSelectedInputIdPA;
    SelectedOutputIdPA := Self.FSelectedOutputIdPA;
    BufferSize         := Self.FBufferSize;
    if Execute
    then SelectDevices;
  end;
end;

procedure TFormModules.MenuEditWiggleWiresClick(Sender: TObject);
begin
  WiggleWires;
end;

procedure TFormModules.MenuEditRedoClick(Sender: TObject);
begin
  if Assigned( EditorPatch)
  then EditorPatch.Redo;
end;

procedure TFormModules.MenuEditUndoClick(Sender: TObject);
begin
  if Assigned( EditorPatch)
  then EditorPatch.Undo;
end;

procedure TFormModules.MenuEditInvertSelectionClick(Sender: TObject);
begin
  InvertSelection;
end;

procedure TFormModules.MenuEditSelectAllClick(Sender: TObject);
begin
  SelectAll;
end;

procedure TFormModules.SelectNone1Click(Sender: TObject);
begin
  SelectNone;
end;

procedure TFormModules.MenuEditPasteClick(Sender: TObject);
begin
  PasteModules;
end;

procedure TFormModules.MenuActionRunStopClick(Sender: TObject);
begin
  StartStopAudioIo;
end;

procedure TFormModules.MenuEditCopyClick(Sender: TObject);
begin
  CopyModules;
end;

procedure TFormModules.MenuEditCutClick(Sender: TObject);
begin
  CutModules;
end;

procedure TFormModules.MenuEditDeleteClick(Sender: TObject);
begin
  DeleteModules;
end;

procedure TFormModules.MenuFileExitClick(Sender: TObject);
begin
  if FDebugRunning
  then DebugRunStop;
  if RenderToFile
  then RenderToFile := False
  else Close;
end;

procedure TFormModules.MenuFileSaveClick(Sender: TObject);
begin
  SavePatch;
end;

procedure TFormModules.MenuFileSaveAsClick(Sender: TObject);
begin
  SavePatchAs;
end;

procedure TFormModules.MenuFileLoadClick(Sender: TObject);
begin
  LoadPatch;
end;

function TFormModules.ModuleSelectorGetGlyph(aSender: TObject; const aName: string): TBitmap;
begin
  Result := FormStore.FindBitmap( aName);
end;

procedure TFormModules.ModuleSelectorModuleButtonClick(aSender: TObject; aModuleclass: Integer);
begin
  // User requested module creation by clicking
  // a button in the module selector, create it !
  // todo : is FixupInsertions really needed here?
  EditorPatch.BeginStateChange;
  try
    FormStore.CreateModule( EditorPatch, aModuleClass, DO_DRAG).FixupInsertion;
  finally
    EditorPatch.EndStateChange( True);
  end;
end;

procedure TFormModules.TimerStatsUpdateTimer(Sender: TObject);
begin
  TickCPUCounter;

  LabelCpuUsage .Caption := Format( 'CPU: %.1f%%'    , [ FProcessTime * CpuCount], AppLocale);
  LabelIOBalance.Caption := Format( 'I/O balance: %d', [ FIOBalance             ], AppLocale);

  if FdBInMax1 <= -120
  then LabeldBIn1.Caption := '---'
  else LabeldBIn1.Caption := Format( '%.1f dB', [ FdBinMax1], AppLocale);
  if FdBInMaxMax1 <= -120
  then LabeldBInMax1.Caption := '---'
  else LabeldBInMax1.Caption := Format( '%.1f dB', [ FdBinMaxMax1], AppLocale);
  if FdBInMaxMin1 <= -120
  then LabeldBInMin1.Caption := '---'
  else LabeldBInMin1.Caption := Format( '%.1f dB', [ FdBinMaxMin1], AppLocale);

  if FdBInMax1 > 0
  then LabeldBIn1.Font.Color := clYellow
  else LabeldBIn1.Font.Color := clBlack;
  if FdBInMaxMax1 > 0
  then LabeldBInMax1.Font.Color := clYellow
  else LabeldBInMax1.Font.Color := clBlack;
  if FdBInMaxMin1 > 0
  then LabeldBInMin1.Font.Color := clYellow
  else LabeldBInMin1.Font.Color := clBlack;

  if FdBOutMax1 <= -120
  then LabeldBOut1.Caption := '---'
  else LabeldBOut1.Caption := Format( '%.1f dB', [ FdBOutMax1], AppLocale);
  if FdBOutMaxMax1 <= -120
  then LabeldBOutMax1.Caption := '---'
  else LabeldBOutMax1.Caption := Format( '%.1f dB', [ FdBOutMaxMax1], AppLocale);
  if FdBOutMaxMin1 <= -120
  then LabeldBOutMin1.Caption := '---'
  else LabeldBOutMin1.Caption := Format( '%.1f dB', [ FdBOutMaxMin1], AppLocale);

  if FdBOutMax1 > 0
  then LabeldBOut1.Font.Color := clYellow
  else LabeldBOut1.Font.Color := clBlack;
  if FdBOutMaxMax1 > 0
  then LabeldBOutMax1.Font.Color := clYellow
  else LabeldBOutMax1.Font.Color := clBlack;
  if FdBOutMaxMin1 > 0
  then LabeldBOutMin1.Font.Color := clYellow
  else LabeldBOutMin1.Font.Color := clBlack;

  if FAudioInRunning and FAudioOutRunning
  then ShowRunTime;

  with KnobsLedrendering
  do Active := not Active;

  // if Assigned( EditorPatch)
  // then LabelPaintCount.Caption := Format( 'paint count: %d %d', [ EditorPatch.PaintCount, EditorPatch.PaintClocks div 1000]);
end;

procedure TFormModules.TimerLightsUpdateTimer(Sender: TObject);
begin
  UpdateLights;
end;

procedure TFormModules.TimerNetMidiConnectTimer(Sender: TObject);
begin
  if NetMidiAutoConnect
  then begin
    if NetMidiConnected
    then StopNetMidiConnectTimer
    else NetMidiConnectTimerFired;
  end
  else StopNetMidiConnectTimer;
end;

procedure TFormModules.knob_inputlevel1ValueChanged(aSender: TObject; const aPath, aControlType: string; aValue: Double; IsFinal: Boolean);
begin
  InVolume1 := knob_inputlevel1.KnobPosition;
end;

procedure TFormModules.knob_outputlevel1ValueChanged(aSender: TObject; const aPath, aControlType: string; aValue: Double; IsFinal: Boolean);
begin
  OutVolume1 := knob_outputlevel1.KnobPosition;
end;

procedure TFormModules.KnobsSmallKnob_LightsRateValueChanged(aSender: TObject; const aPath, aControlType: string;
  aValue: Double; IsFinal: Boolean);
begin
  if IsFinal
  then LightsRate := aValue;
end;

procedure TFormModules.KnobsSelectorFileRenderValueChanged(const aSender: TObject; const aPath, aControlType: string;
  aValue: Double; IsFinal: Boolean);
begin
  RenderToFile := SignalToLogic( aValue);
end;

procedure TFormModules.knob_WheelSensitivityValueChanged(const aSender: TObject; const aPath,
  aControlType: string; aValue: Double; IsFinal: Boolean);
begin
  WheelSensitivity := knob_WheelSensitivity.KnobPosition;
end;

procedure TFormModules.KnobsSmallKnobModuleOpacityValueChanged(const aSender: TObject; const aPath,
  aControlType: string; aValue: Double; IsFinal: Boolean);
begin
  ModuleOpacity := Clip( SignalToInt( aValue), 0, 255);
end;

procedure TFormModules.KnobsSmallKnob_LeftOffsetValueChanged(aSender: TObject; const aPath, aControlType: string;
  aValue: Double; IsFinal: Boolean);
begin
  OffsetLeft := SignalToInt( aValue);
end;

procedure TFormModules.KnobsSmallKnob_TopOffsetValueChanged(aSender: TObject; const aPath, aControlType: string;
  aValue: Double; IsFinal: Boolean);
begin
  OffsetTop := SignalToInt( aValue);
end;

procedure TFormModules.CheckBoxAutoRunClick(Sender: TObject);
begin
  AutoRun := CheckBoxAutoRun.Checked;
end;

procedure TFormModules.CheckBoxCompilerDebugClick(Sender: TObject);
begin
  CompilerDebug := CheckBoxCompilerDebug.Checked;
end;

procedure TFormModules.CheckBoxCurvedLinesClick(Sender: TObject);
begin
  CurvedLines := CheckBoxCurvedLines.Checked;
end;

procedure TFormModules.CheckBoxGraphStairsClick(Sender: TObject);
begin
  GraphStairs := CheckBoxGraphStairs.Checked;
end;

procedure TFormModules.CheckBoxLogMidiClick(Sender: TObject);
begin
  LogMidi := CheckBoxLogMidi.Checked;
end;

procedure TFormModules.CheckBoxLogMidiMsgsClick(Sender: TObject);
begin
  LogMidiMsgs := CheckBoxLogMidiMsgs.Checked;
end;

procedure TFormModules.CheckBoxNetMidiAutoConnectClick(Sender: TObject);
begin
  NetMidiAutoConnect := CheckBoxNetMidiAutoConnect.Checked;
end;

procedure TFormModules.CheckBoxReloadLastPatchClick(Sender: TObject);
begin
  ReloadLastPatch := CheckBoxReloadLastPatch.Checked;
end;

procedure TFormModules.CheckBoxUseGraphClick(Sender: TObject);
begin
  UseGraph := CheckBoxUseGraph.Checked;
end;

procedure TFormModules.CheckBoxUsePortAudioClick(Sender: TObject);
begin
  UsePortAudio := CheckBoxUsePortAudio.Checked;
end;

procedure TFormModules.CheckBoxUseUnFocusClick(Sender: TObject);
begin
  UseUnFocus := CheckBoxUseUnFocus.Checked;
end;

procedure TFormModules.CheckBoxUseWheelOnKnobsClick(Sender: TObject);
begin
  UseWheelOnKnobs := CheckBoxUseWheelOnKnobs.Checked;
end;

procedure TFormModules.CheckBoxWarnOnPatchChangeClick(Sender: TObject);
begin
  WarnOnPatchChange := CheckBoxWarnOnPatchChange.Checked;
end;

procedure TFormModules.BitBtnDebugStepClick(Sender: TObject);
begin
  if FAudioInRunning or FAudioOutRunning
  then Log( 'can not do a debug step while audio generation is on')
  else ExecutePatch;
end;

procedure TFormModules.BitBtnDocumentClick(Sender: TObject);
begin
  MakeDocs( DocsPath);
end;

procedure TFormModules.BitBtnClearGraphClick(Sender: TObject);
begin
  ClearGraphs;
end;

procedure TFormModules.BitBtnCloseDubuggerClick(Sender: TObject);
begin
  PageControlMain.ActivePage := TabSheetEditor;
end;

procedure TFormModules.MenuViewAboutClick(Sender: TObject);
begin
  PageControlMain.ActivePage := TabSheetDebug;
  PageControlDGSA.ActivePage := TabSheetAbout;
end;

procedure TFormModules.MenuHelpAboutClick(Sender: TObject);
begin
  PageControlMain.ActivePage := TabSheetDebug;
  PageControlDGSA.ActivePage := TabSheetAbout;
end;

procedure TFormModules.BitBtnGhostCheckClick(Sender: TObject);
var
  aGhosts : TStringList;
  i       : Integer;
begin
  if Assigned( EditorPatch)
  then begin
    aGhosts := TStringList.Create;
    try
      EditorPatch.FindGhosts( aGhosts);
      Log( '---- Gosts:');
      for i := 0 to aGhosts.Count - 1
      do Log( aGhosts[ i]);
      Log( '---- EndGosts');
    finally
      aGhosts.Free;
    end;
  end;
end;

procedure TFormModules.BitBtnApplyNetMidiClick(Sender: TObject);
begin
  NetMidiApply;
end;

procedure TFormModules.BitBtnAudioRunningClick(Sender: TObject);
begin
  StartStopAudioIo;
end;

procedure TFormModules.BitBtnCancelNetMidiClick(Sender: TObject);
begin
  NetMidiCancel;
end;

procedure TFormModules.BitBtnClearClick(Sender: TObject);
begin
  ClearMemo;
end;

procedure TFormModules.BitBtnDebugResetClick(Sender: TObject);
begin
  if FAudioInRunning or FAudioOutRunning
  then Log( 'can not do a debug reset while audio generation is on')
  else begin
    if Assigned( FSynthPatch)
    then FSynthPatch.Reset;
    ClearGraphs;
  end;
end;

procedure TFormModules.BitBtnShowDesignerClick(Sender: TObject);
begin
  FormStore.Show;
end;

procedure TFormModules.BitBtnSynthResetClick(Sender: TObject);
begin
  if Assigned( FSynthPatch)
  then FSynthPatch.Reset;
end;

procedure TFormModules.BitBtnTestClick(Sender: TObject);
begin
  Rationals.UnitTest;
end;

procedure TFormModules.BreakConnectorClick(Sender: TObject);
begin
  ConnectorBreak( FPopupSender as TKnobsConnector);
end;

procedure TFormModules.BitBtnDebugRunClick(Sender: TObject);
begin
  DebugRunStop;
end;

procedure TFormModules.BitBtnDumpClick(Sender: TObject);
begin
  ShowPatch;
end;

procedure TFormModules.BitBtnExItClick(Sender: TObject);
begin
  FDebugRunning := False;
  Close;
end;

procedure TFormModules.BitBtnModuleColorClick(Sender: TObject);
begin
  if Assigned( EditorPatch)
  then begin
    with ColorDialogModule
    do begin
      Color := ModuleColor;
      if Execute
      then ModuleColor := Color;
    end;
  end;
end;

procedure TFormModules.BitBtnNetMidiConnectClick(Sender: TObject);
begin
  if NetMidiConnected
  then NetMidiDisconnect
  else NetMidiConnect;
end;

procedure TFormModules.BitBtnProfileClick(Sender: TObject);
begin
  ProfilePatch;
end;

procedure TFormModules.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  StopAudioIn;
  StopAudioOut;
  NetMidiDisconnect;
  if FIniLoaded
  then SaveIni;
end;

procedure TFormModules.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
var
  MResult : Integer;
begin
  if FPatchChanged and WarnOnPatchChange
  then begin
    MResult := MessageDlg
    (
      'The patch was changed'^M^M             +
      'Do you want to save your changes?'^M^M +
      '- Yes to save the patch and exit'^M    +
      '- No to not save, but exit anyway'^M   +
      '- Cancel to not exit the program',
      mtWarning,
      [ mbYes, mbNo, mbCancel],
      0,
      mbYes
    );
    if MResult = mrYes
    then CanClose := SavePatch
    else if MResult = mrNo
    then CanClose := True
    else CanClose := False;
  end
  else CanClose := True;
end;

procedure TFormModules.FormCreate(Sender: TObject);
var
  aPAError: TPAError;
begin
  FSelectedAPIID := -1;
  FPAInitialized := False;
  try
    aPAError       := Pa_Initialize;
    FPAInitialized := aPAError = paNoError;

  {$IFDEF DEBUG_PORT_AUDIO}
    if FPAInitialized
    then PaUtil_SetDebugPrintFunction( @ GPaDebugProc);
  {$ENDIF}

  except
    on E: Exception
    do KilledException( E, True); // no re-raise not even in debug mode, DLL errors are to be expected
  end;
  FormWaveDeviceSelect := TFormWaveDeviceSelect.Create( Self);
  FormWaveDeviceSelect.PAInitialized := Self.FPAInitialized;

  FOldMemoDebug        := MemoDebug.WindowProc;
  MemoDebug.WindowProc := MemoDebugWindowProc;
  Randomize;
  ClearDebugTiming;
  InitializeCPUCounter;
  knobs2013.GOnCreateModuleBitmap := DoCreateModuleBitmap;
  knobs2013.GOnReadModuleComment  := DoReadModuleComment;
  Application.HintPause           :=  0;
  Application.HintHidePause       := -1;
  Application.OnShowHint          := DoShowHint;
  FormStore                       := TFormStore.Create( Application);        // Ah .. "designer" needs manual creation .. ok, do it.
  FormStore.OnDesignerLog         := DoDesignerLog;
  FormStore.PopulateSelector( ModuleSelector);         // Poplulate module selector from the "designer"
  FPatchReader                  := TPatchReader.Create;
  FPatchWriter                  := TPatchWriter.Create;
  EditorPatch.OnLog             := DoWirePanelLog;
  EditorPatch.PatchReader       := FPatchReader;
  EditorPatch.PatchWriter       := FPatchWriter;
  EditorPatch.OnHistoryChange   := DoHistoryChanged;
  EditorPatch.OnValueChanged    := DoValueChanged;
  EditorPatch.OnDisplayChanged  := DoDisplayChanged;
  EditorPatch.OnFileChanged     := DoFileChanged;
  EditorPatch.OnPatchChanged    := DoPatchChanged;
  EditorPatch.OnShowPoup        := DoShowPopupMenu;
  EditorPatch.OnUnFocus         := DoUnFocus;
  EditorPatch.Title             := 'no name';
  FRecentSourceFiles            := TRecentStrings.Create( 20);
  EditorPatch.MaxHistory        := 100;
  with PageControlMain
  do begin
    TabHeight  := 2;
    TabWidth   := 2;
    ActivePage := TabSheetEditor;
  end;
end;

procedure TFormModules.FormDestroy(Sender: TObject);
begin
  if Assigned( FSynthPatch)
  then FSynthPatch.OnSendMidi := nil;
  FreeAndNil( FSynthPatch);
  FreeDevices;
  FreeAndNil( FRecentSourceFiles);
  FinalizeCPUCounter;
  try
    if FPAInitialized
    then Pa_Terminate;
  except
    on E: Exception
    do KilledException( E, True); // no re-raise, not even in debug mode
  end;
end;


procedure TFormModules.FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
  if ( Shift = []) and ( Key = VK_F8) and not FKeyF8Down
  then begin
    Key        := 0;
    FKeyF8Down := True;
    if Assigned( EditorPatch)
    then EditorPatch.ShowAllPopups;
  end;
end;

procedure TFormModules.FormKeyUp(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
  if ( Shift = []) and ( Key = VK_F8) and FKeyF8Down
  then begin
    Key        := 0;
    FKeyF8Down := False;
    if Assigned( EditorPatch)
    then EditorPatch.ForceHideAllPopups;
  end;
end;

procedure TFormModules.FormMouseWheel(Sender: TObject; Shift: TShiftState; WheelDelta: Integer; MousePos: TPoint;
  var Handled: Boolean);
Var
  aMsg  : Cardinal;
  aCode : Cardinal;
  i     : Integer;
  n     : Integer;
begin

  MousePos := ScreenToClient( MousePos);
  if
    ( MousePos.X > EditorPatch.Left                     ) and
    ( MousePos.Y > EditorPatch.Top                      ) and
    ( MousePos.X < EditorPatch.Left + EditorPatch.Width ) and
    ( MousePos.Y < EditorPatch.Top  + EditorPatch.Height)
  then begin
    if ssShift in Shift
    then aMsg := WM_HSCROLL
    else aMsg := WM_VSCROLL;

    if WheelDelta < 0
    then aCode := SB_LINEDOWN
    else aCode := SB_LINEUP;

    n := Mouse.WheelScrollLines;
    for i:= 1 to n
    do EditorPatch.Perform( aMsg, aCode, 0);
    EditorPatch.Perform( aMsg, SB_ENDSCROLL, 0);
    Handled := True;
  end;
end;

procedure TFormModules.FormShow(Sender: TObject);
begin
  FOrigCaption   := Caption;
  PatchName      := '';
  SourceFileName := '';

  KnobsLedrendering.Visible := False;

  CreateDevices;
  ClearMemo;

  FdBIn1  := - 333.33;  FdBIn2  := - 333.33;  FdBIn3  := - 333.33;  FdBIn4  := - 333.33;
  FdBIn5  := - 333.33;  FdBIn6  := - 333.33;  FdBIn7  := - 333.33;  FdBIn8  := - 333.33;
  FdBOut1 := - 333.33;  FdBOut2 := - 333.33;  FdBOut3 := - 333.33;  FdBOut4 := - 333.33;
  FdBOut5 := - 333.33;  FdBOut6 := - 333.33;  FdBOut7 := - 333.33;  FdBOut8 := - 333.33;

  SplitterMain.ShowHint := False;
  PanelControl.Width    := 47;         // Show channel 1 controls only

  FUseGraph           := True;         UseGraph           := False;
  InVolume1           := 1;            InVolume1          := 0;
  InVolume2           := 1;            InVolume2          := 0;
  InVolume3           := 1;            InVolume3          := 0;
  InVolume4           := 1;            InVolume4          := 0;
  OutVolume1          := 1;            OutVolume1         := 0;
  OutVolume2          := 1;            OutVolume2         := 0;
  OutVolume3          := 1;            OutVolume3         := 0;
  OutVolume4          := 1;            OutVolume4         := 0;
  FAudioInRunning     := False;
  FAudioOutRunning    := False;
  FReloadLastPatch    := False;        ReloadLastPatch    := True;
  FHistoryCount       := 0;            HistoryCount       := 15;
  FCurvedLines        := False;        CurvedLines        := True;
  FControlMode        := dmHorizontal; ControlMode        := dmCircular;
  Samplerate          := 48000;        Samplerate         := 44100;
  BufferSize          := 8192;
  ReferenceA          := 100;          ReferenceA         := 440.0;
  NotesPerOctave      := 3;            NotesPerOctave     := 12.0;
  MiddleNote          := 1;            MiddleNote         := 69;
  FWireThickness      := 2;            WireThickness      := 1;
  FPrioLevel          := 2;            PrioLevel          := 1;
  OffsetLeft          := 6;
  OffsetTop           := 6;
  NetMidiServer       := 'localhost';
  NetMidiPort         := '31415';
  FNetMidiAutoConnect := True;         NetMidiAutoConnect := False;
  FLogMidi            := False;        LogMidi            := True;
  FLogMidiMsgs        := True;         LogMidiMsgs        := False;
  FNetMidiChanged     := True;         NetMidiChanged     := False;
  FCompilerDebug      := True;         CompilerDebug      := False;
  FWarnOnPatchChange  := False;        WarnOnPatchChange  := True;
  FUseWheelOnKnobs    := True;         UseWheelOnKnobs    := False;
  FWheelSensitivity   := 1;            WheelSensitivity   := 25;
  FUseUnFocus         := False;        UseUnFocus         := True;
  FUsePortAudio       := False;        UsePortAudio       := True;
  FRenderToFile       := True;         RenderToFile       := False;
  FResetOnRender      := False;        ResetOnRender      := True;
  ModuleOpacity       := 223;

  if not HAS_PATCH_PROFILER
  then begin
    BitBtnProfile.Visible := False;
    Profile1     .Visible := False;
  end;

  FLightsRate                            :=   0;
  KnobsSmallKnob_LightsRate.KnobPosition :=   0;
  KnobsSmallKnob_LightsRate.KnobPosition := 156;

  LabelProgramVersion.Caption := Format( 'program version: %s', [ GetFileVersion   ], AppLocale);
  LabelPatchVersion  .Caption := Format( 'patch version: %d'  , [ KnobsPatchVersion], AppLocale);
  ClearVolumeIndicators;
  ResetRuntime;
  MemoAbout.Text := CopyRightMsg;

  if FileExists( IniFileName)
  then LoadIni
  else begin
    AutoRun    := True;
    FIniLoaded := True;
    SaveIni;
  end;

  if Assigned( EditorPatch)
  then KnobsLedModuleColor.ColorOn  := EditorPatch.ModuleColor;

  EditSearch.SetFocus; // Something harmless please ...
end;

initialization

  RegisterModuleType(  101, TModInput        );
  RegisterModuleType(  102, TModOutput       );

  RegisterModuleType(  201, TModXFade        );
  RegisterModuleType(  202, TModPan          );
  RegisterModuleType(  203, TModMixM4to1     );
  RegisterModuleType(  204, TModMixS2to1     );
  RegisterModuleType(  205, TModMixM6to6     );
  RegisterModuleType(  206, TModMixT1to1     );

  RegisterModuleType(  301, TModConstant     );
  RegisterModuleType(  302, TModInverter     );
  RegisterModuleType(  303, TModAdder        );
  RegisterModuleType(  304, TModMultiplier   );
  RegisterModuleType(  305, TModAmplifier    );
  RegisterModuleType(  306, TModScaler       );
  RegisterModuleType(  307, TModQuantize     );
  RegisterModuleType(  308, TModRatio        );
  RegisterModuleType(  309, TModRotator      );
  RegisterModuleType(  310, TModRectifier    );
  RegisterModuleType(  311, TModMinMax       );
  RegisterModuleType(  312, TModMultiMult    );
  RegisterModuleType(  313, TModNoteToDelay  );
  RegisterModuleType(  314, TModZeroCounter  );
  RegisterModuleType(  315, TModMedian       );
  RegisterModuleType(  316, TModScala        );
  RegisterModuleType(  317, TModHardClip     );
  RegisterModuleType(  318, TModTransInv     );

  RegisterModuleType(  401, TModLfo          );
  RegisterModuleType(  402, TModSquareLfo    );
  RegisterModuleType(  403, TModNoiseLfo     );
  RegisterModuleType(  404, TModRandomWalkLfo);
  RegisterModuleType(  405, TModLfoTrig      );
  RegisterModuleType(  406, TModSquareLfoTrig);
  RegisterModuleType(  407, TModNoiseLfoTrig );
  RegisterModuleType(  408, TModRandSig      );
  RegisterModuleType(  409, TModPulses       );

  RegisterModuleType(  501, TModOsc          );
  RegisterModuleType(  502, TModSquare       );
  RegisterModuleType(  503, TModNoise        );
  RegisterModuleType(  504, TModTrigOsc      );
  RegisterModuleType(  505, TModSquareTrig   );
  RegisterModuleType(  506, TModNoiseTrig    );
  RegisterModuleType(  507, TModTerraGen     );
  RegisterModuleType(  508, TModPluck        );

  RegisterModuleType(  601, TModNot          );
  RegisterModuleType(  602, TModGate         );
  RegisterModuleType(  603, TModDivider      );
  RegisterModuleType(  604, TModDFlipFlop    );
  RegisterModuleType(  605, TModRSFlipFlop   );
  RegisterModuleType(  606, TModCounter      );
  RegisterModuleType(  607, TModAdc          );
  RegisterModuleType(  608, TModDac          );
  RegisterModuleType(  609, TModPhaseDetect  );
  RegisterModuleType(  610, TModCompare      );

  RegisterModuleType(  701, TModDelay        );
  RegisterModuleType(  702, TModWavePlayer   );
  RegisterModuleType(  703, TModReverb       );
  RegisterModuleType(  704, TModFlangeChorus );
  RegisterModuleType(  705, TModPitchChange  );

  RegisterModuleType(  801, TModSampleAndHold);
  RegisterModuleType(  802, TModTrackAndHold );
  RegisterModuleType(  803, TModSwitch2to1   );
  RegisterModuleType(  804, TModMultiSAndH   );
  RegisterModuleType(  805, TModMux          );
  RegisterModuleType(  806, TModDemux        );

  RegisterModuleType(  901, TModEnvAR        );
  RegisterModuleType(  902, TModEnvARRetrig  );
  RegisterModuleType(  903, TModEnvAHD       );
  RegisterModuleType(  904, TModEnvADSR      );
  RegisterModuleType(  905, TModEnvelope     );
  RegisterModuleType(  906, TModCompressor   );

  RegisterModuleType( 1001, TModAverage      );
  RegisterModuleType( 1002, TModSVF          );
  RegisterModuleType( 1003, TModIntDif       );
  RegisterModuleType( 1004, TModFormant      );
  RegisterModuleType( 1005, TModPinkFilter   );
  RegisterModuleType( 1006, TModResonator    );

  RegisterModuleType( 1106, TModDisplay      );
  RegisterModuleType( 1108, TModXYScope      );

  RegisterModuleType( 1201, TModSequencer    );
  RegisterModuleType( 1202, TModTextSequencer);
  RegisterModuleType( 1203, TModSeqStep      );
  RegisterModuleType( 1204, TModSeqClockStep );
  RegisterModuleType( 1205, TModEuclids      );
  RegisterModuleType( 1206, TModCsvData      );
  RegisterModuleType( 1207, TModKleeBit      );
  RegisterModuleType( 1208, TModSeqRandom    );
  RegisterModuleType( 1209, TModMorse        );
  RegisterModuleType( 1210, TModGateSeq      );

  RegisterModuleType( 1301, TModMidiNoteIn   );
  RegisterModuleType( 1302, TModMidiCCIn     );
  RegisterModuleType( 1303, TModMidiNoteOut  );

  RegisterModuleType( 1401, TModFreqShifter  );

  RegisterModuleType( 4001, THrastOsc        );
  RegisterModuleType( 4002, THrastSVF        );
end.
